## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
############################################################
##########===Main Screen Mod===v2.3b=====BtS 3.03===========
############################################################
from CvPythonExtensions import *
import CvUtil
import ScreenInput
import CvScreenEnums
import CvEventInterface
import CvEventManager
import time
# Inquisition Mod
import GodsOfOld
# End Inquisition Mod
import CvVictoryScreen
import PyHelpers

# globals
gc = CyGlobalContext()
ArtFileMgr = CyArtFileMgr()
localText = CyTranslator()

#----------Main Screen Mod===Options===0===
# Show Era (default = true)
# false -> show min health & happiness
g_bShowEra = false

# City Cultural Expansion Turns (default = true)
g_bCityExpansionTurns = true

# City GP Birth Turns (default = true)
g_bGPBirthTurns = true

# Combat XP Counter (default = true)
g_bCombatXPCounter = true

g_bOxford = true
g_bWallStreet = true
g_bForbiddenPalace = true

# GP Bar (default = true)
g_bGPBar = true

# Main Screen City Scroll (default = true)
g_bMainCityScroll = true

#-----------------------------------------------------------

# Show Turn Options
# 0 = Standard BtS
# 1 = Show Turn Number (default)
# 2 = Show Turn Number and Max Turns
g_iShowTurn = 2

# Show Score Options
# 0 = Hide Score
# 1 = Show Score (default, standard)
# 2 = Show Score and Score per Turn
g_iShowScore = 1

# Show Attitude Options
# 0 = Hide Attitude (standard)
# 1 = Show Attitude Text or Icons (default)
# 2 = Show Attitude Text or Extra Icons (!! Porges' GameFont.tga required !!)
g_iShowAttitude = 2

# Attitude Value (default = false)
# !!! Blacksun's AttitudeValue .dll required !!!
g_bAttitudeValue = false
#----------Main Screen Mod===Options===X===

#----------Dimon157 Options 0
# Show Domination Values
g_bDominationCounter = true

# Show 3 Best Cities Insted of Flag
g_bThreeBestCities = false # needs fixing

# Show 3 Best Cities For Culture Victory
# 0 = off
# 1 = panels only
# 2 = panels + tips
g_iThreeCulturedCities = 2

# Show some info before name of civ from F4
# 0 = Don't show
# 1 = show icons
# 2 = show values
g_iShowF4 = 2

# Show detail power of AI?
g_bDetailPower = true

# Show detail GP Bar?
# 0 = Impaler GP Bar
# 1 = More details for GP Bar
# 2 = Maximum detailed GP Bar
g_iDetailGPBar = 2

g_iGoldSensitivityAincient = 30
g_iGoldSensitivityClassical = 50
g_iGoldSensitivityMedieval = 100
g_iGoldSensitivityRenaissance = 150
g_iGoldSensitivityIndustrial = 250
g_iGoldSensitivityModern = 400
g_iGoldSensitivityFuture = 600

g_iGoldPerTurnSensitivityAincient = 2
g_iGoldPerTurnSensitivityClassical = 4
g_iGoldPerTurnSensitivityMedieval = 6
g_iGoldPerTurnSensitivityRenaissance = 8
g_iGoldPerTurnSensitivityIndustrial = 10
g_iGoldPerTurnSensitivityModern = 12
g_iGoldPerTurnSensitivityFuture = 14

dominationVictoryEnabled = false # don't touch it, it's not an option!
#----------Dimon157 Options X

g_NumEmphasizeInfos = 0
g_NumCityTabTypes = 0
g_NumHurryInfos = 0
g_NumUnitClassInfos = 0
g_NumBuildingClassInfos = 0
g_NumProjectInfos = 0
g_NumProcessInfos = 0
g_NumActionInfos = 0
g_eEndTurnButtonState = -1

MAX_SELECTED_TEXT = 5
MAX_DISPLAYABLE_BUILDINGS = 15
MAX_DISPLAYABLE_TRADE_ROUTES = 4
MAX_BONUS_ROWS = 10
MAX_CITIZEN_BUTTONS = 8

SELECTION_BUTTON_COLUMNS = 8
SELECTION_BUTTON_ROWS = 2
NUM_SELECTION_BUTTONS = SELECTION_BUTTON_ROWS * SELECTION_BUTTON_COLUMNS

g_iNumBuildingWidgets = MAX_DISPLAYABLE_BUILDINGS
g_iNumTradeRouteWidgets = MAX_DISPLAYABLE_TRADE_ROUTES

# END OF TURN BUTTON POSITIONS
######################
iEndOfTurnButtonSize = 32
iEndOfTurnPosX = 296 # distance from right
iEndOfTurnPosY = 147 # distance from bottom

# MINIMAP BUTTON POSITIONS
######################
iMinimapButtonsExtent = 228
iMinimapButtonsX = 227
iMinimapButtonsY_Regular = 160
iMinimapButtonsY_Minimal = 32
iMinimapButtonWidth = 24
iMinimapButtonHeight = 24

# Globe button
iGlobeButtonX = 48
iGlobeButtonY_Regular = 168
iGlobeButtonY_Minimal = 40
iGlobeToggleWidth = 48
iGlobeToggleHeight = 48

# GLOBE LAYER OPTION POSITIONING
######################
iGlobeLayerOptionsX  = 235
iGlobeLayerOptionsY_Regular  = 170# distance from bottom edge
iGlobeLayerOptionsY_Minimal  = 38 # distance from bottom edge
iGlobeLayerOptionsWidth = 400
iGlobeLayerOptionHeight = 24

# STACK BAR
#####################
iStackBarHeight = 27


# MULTI LIST
#####################
iMultiListXL = 318
iMultiListXR = 332


# TOP CENTER TITLE
#####################
iCityCenterRow1X = 398
iCityCenterRow1Y = 78
iCityCenterRow2X = 398
iCityCenterRow2Y = 104

iCityCenterRow1Xa = 347
iCityCenterRow2Xa = 482


g_iNumTradeRoutes = 0
g_iNumBuildings = 0
g_iNumLeftBonus = 0
g_iNumCenterBonus = 0
g_iNumRightBonus = 0

g_szTimeText = ""
g_iTimeTextCounter = 0

g_pSelectedUnit = 0

#----------Dimon157 Best Cities 1/4 0		
hammerNo1Count=""
hammerNo1CityName=""
hammerNo2Count=""
hammerNo2CityName=""
hammerNo3Count=""
hammerNo3CityName=""
scienceNo1Count=""
scienceNo1CityName=""
scienceNo2Count=""
scienceNo2CityName=""
scienceNo3Count=""
scienceNo3CityName=""
goldNo1Count=""
goldNo1CityName=""
goldNo2Count=""
goldNo2CityName=""
goldNo3Count=""
goldNo3CityName=""
espionageNo1Count=""
espionageNo1CityName=""
espionageNo2Count=""
espionageNo2CityName=""
espionageNo3Count=""
espionageNo3CityName=""
#----------Dimon157 Best Cities 1/4 X		

class CvMainInterface:
	"Main Interface Screen"
	
	def numPlotListButtons(self):
		return self.m_iNumPlotListButtons

	def interfaceScreen (self):
#----------MSM===Attitude Colors===0===
		self.attitudeColors = ( 
			gc.getInfoTypeForString("COLOR_GREY"),		# NO_ATTITUDE
			gc.getInfoTypeForString("COLOR_RED"),		# ATTITUDE_FURIOUS
			gc.getInfoTypeForString("COLOR_YELLOW"),	# ATTITUDE_ANNOYED
			gc.getInfoTypeForString("COLOR_WHITE"),		# ATTITUDE_CAUTIOUS
			gc.getInfoTypeForString("COLOR_GREEN"),		# ATTITUDE_PLEASED
			gc.getInfoTypeForString("COLOR_CYAN"))		# ATTITUDE_FRIENDLY
#----------MSM===Attitude Colors===X===

		# Global variables being set here
		global g_NumEmphasizeInfos
		global g_NumCityTabTypes
		global g_NumHurryInfos
		global g_NumUnitClassInfos
		global g_NumBuildingClassInfos
		global g_NumProjectInfos
		global g_NumProcessInfos
		global g_NumActionInfos
		
		global MAX_SELECTED_TEXT
		global MAX_DISPLAYABLE_BUILDINGS
		global MAX_DISPLAYABLE_TRADE_ROUTES
		global MAX_BONUS_ROWS
		global MAX_CITIZEN_BUTTONS
		
		if ( CyGame().isPitbossHost() ):
			return

		# This is the main interface screen, create it as such
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		screen.setForcedRedraw(True)

		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		self.m_iNumPlotListButtons = (xResolution - (iMultiListXL+iMultiListXR) - 68) / 34
		
		screen.setDimensions(0, 0, xResolution, yResolution)

		# Set up our global variables...
		g_NumEmphasizeInfos = gc.getNumEmphasizeInfos()
		g_NumCityTabTypes = CityTabTypes.NUM_CITYTAB_TYPES
		g_NumHurryInfos = gc.getNumHurryInfos()
		g_NumUnitClassInfos = gc.getNumUnitClassInfos()
		g_NumBuildingClassInfos = gc.getNumBuildingClassInfos()
		g_NumProjectInfos = gc.getNumProjectInfos()
		g_NumProcessInfos = gc.getNumProcessInfos()
		g_NumActionInfos = gc.getNumActionInfos()
		
		# Help Text Area
		screen.setHelpTextArea( 350, FontTypes.SMALL_FONT, 7, yResolution - 172, -0.1, False, "", True, False, CvUtil.FONT_LEFT_JUSTIFY, 150 )

		# Center Left
		screen.addPanel( "InterfaceCenterLeftBackgroundWidget", u"", u"", True, False, 0, 0, 258, yResolution-149, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "InterfaceCenterLeftBackgroundWidget", "Panel_City_Left_Style" )
		screen.hide( "InterfaceCenterLeftBackgroundWidget" )

		# Top Left
		screen.addPanel( "InterfaceTopLeftBackgroundWidget", u"", u"", True, False, 258, 0, xResolution - 516, yResolution-149, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "InterfaceTopLeftBackgroundWidget", "Panel_City_Top_Style" )
		screen.hide( "InterfaceTopLeftBackgroundWidget" )

		# Center Right
		screen.addPanel( "InterfaceCenterRightBackgroundWidget", u"", u"", True, False, xResolution - 258, 0, 258, yResolution-149, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "InterfaceCenterRightBackgroundWidget", "Panel_City_Right_Style" )
		screen.hide( "InterfaceCenterRightBackgroundWidget" )
		
		screen.addPanel( "CityScreenAdjustPanel", u"", u"", True, False, 10, 44, 238, 105, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "CityScreenAdjustPanel", "Panel_City_Info_Style" )
		screen.hide( "CityScreenAdjustPanel" )
		
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=1/9===0===
############################################################
		screen.addPanel( "CityScreenAdjustPanelb", u"", u"", True, False, 10, 154, 238, 88, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "CityScreenAdjustPanelb", "Panel_City_Info_Style" )
		screen.hide( "CityScreenAdjustPanelb" )
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=1/9===X===
############################################################
		screen.addPanel( "TopCityPanelLeft", u"", u"", True, False, 260, 70, xResolution/2-260, 60, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "TopCityPanelLeft", "Panel_City_TanTL_Style" )
		screen.hide( "TopCityPanelLeft" )
		
		screen.addPanel( "TopCityPanelRight", u"", u"", True, False, xResolution/2, 70, xResolution/2-260, 60, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "TopCityPanelRight", "Panel_City_TanTR_Style" )
		screen.hide( "TopCityPanelRight" )
		
		# Top Bar

		# SF CHANGE		
		screen.addPanel( "CityScreenTopWidget", u"", u"", True, False, 0, -2, xResolution, 41, PanelStyles.PANEL_STYLE_STANDARD )

		screen.setStyle( "CityScreenTopWidget", "Panel_TopBar_Style" )
		screen.hide( "CityScreenTopWidget" )
		
		# Top Center Title
		screen.addPanel( "CityNameBackground", u"", u"", True, False, 260, 31, xResolution - (260*2), 38, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "CityNameBackground", "Panel_City_Title_Style" )
		screen.hide( "CityNameBackground" )

		# Left Background Widget
		screen.addDDSGFC( "InterfaceLeftBackgroundWidget", ArtFileMgr.getInterfaceArtInfo("INTERFACE_BOTTOM_LEFT").getPath(), 0, yResolution - 164, 304, 164, WidgetTypes.WIDGET_GENERAL, -1, -1 )
		screen.hide( "InterfaceLeftBackgroundWidget" )

		# Center Background Widget
		screen.addPanel( "InterfaceCenterBackgroundWidget", u"", u"", True, False, 296, yResolution - 133, xResolution - (296*2), 133, PanelStyles.PANEL_STYLE_STANDARD)
		screen.setStyle( "InterfaceCenterBackgroundWidget", "Panel_Game_HudBC_Style" )
		screen.hide( "InterfaceCenterBackgroundWidget" )

		# Left Background Widget
		screen.addPanel( "InterfaceLeftBackgroundWidget", u"", u"", True, False, 0, yResolution - 168, 304, 168, PanelStyles.PANEL_STYLE_STANDARD)
		screen.setStyle( "InterfaceLeftBackgroundWidget", "Panel_Game_HudBL_Style" )
		screen.hide( "InterfaceLeftBackgroundWidget" )

		# Right Background Widget
		screen.addPanel( "InterfaceRightBackgroundWidget", u"", u"", True, False, xResolution - 304, yResolution - 168, 304, 168, PanelStyles.PANEL_STYLE_STANDARD)
		screen.setStyle( "InterfaceRightBackgroundWidget", "Panel_Game_HudBR_Style" )
		screen.hide( "InterfaceRightBackgroundWidget" )
	
		# Top Center Background

		# SF CHANGE
		screen.addPanel( "InterfaceTopCenter", u"", u"", True, False, 257, -2, xResolution-(257*2), 48, PanelStyles.PANEL_STYLE_STANDARD)

		screen.setStyle( "InterfaceTopCenter", "Panel_Game_HudTC_Style" )
		screen.hide( "InterfaceTopCenter" )

		# Top Left Background
		screen.addPanel( "InterfaceTopLeft", u"", u"", True, False, 0, -2, 267, 60, PanelStyles.PANEL_STYLE_STANDARD)
		screen.setStyle( "InterfaceTopLeft", "Panel_Game_HudTL_Style" )
		screen.hide( "InterfaceTopLeft" )

		# Top Right Background
		screen.addPanel( "InterfaceTopRight", u"", u"", True, False, xResolution - 267, -2, 267, 60, PanelStyles.PANEL_STYLE_STANDARD)
		screen.setStyle( "InterfaceTopRight", "Panel_Game_HudTR_Style" )
		screen.hide( "InterfaceTopRight" )

		iBtnWidth	= 28
		iBtnAdvance = 25
		iBtnY = 27
		iBtnX = 27
		
		# Turn log Button
		screen.setImageButton( "TurnLogButton", "", iBtnX, iBtnY - 2, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_TURN_LOG).getActionInfoIndex(), -1 )
		screen.setStyle( "TurnLogButton", "Button_HUDLog_Style" )
		screen.hide( "TurnLogButton" )

##### RtW START
		# ChangeCiv Button
		iBtnX += iBtnAdvance
		screen.setImageButton( "ChangeCivButton", "Art/Interface/Buttons/ChangeCiv.dds", iBtnX, iBtnY - 2, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_GENERAL, -1, -1 )
#		screen.setStyle( "ChangeCivButton", "Button_HUDLog_Style" )
#		screen.hide( "ChangeCivButton" )
##### RtW END

		iBtnX = xResolution - 277
		
		# Advisor Buttons...
		screen.setImageButton( "DomesticAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_DOMESTIC_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "DomesticAdvisorButton", "Button_HUDAdvisorDomestic_Style" )
		screen.hide( "DomesticAdvisorButton" )

		iBtnX += iBtnAdvance
		screen.setImageButton( "FinanceAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_FINANCIAL_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "FinanceAdvisorButton", "Button_HUDAdvisorFinance_Style" )
		screen.hide( "FinanceAdvisorButton" )
		
		iBtnX += iBtnAdvance
		screen.setImageButton( "CivicsAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_CIVICS_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "CivicsAdvisorButton", "Button_HUDAdvisorCivics_Style" )
		screen.hide( "CivicsAdvisorButton" )
		
		iBtnX += iBtnAdvance 
		screen.setImageButton( "ForeignAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_FOREIGN_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "ForeignAdvisorButton", "Button_HUDAdvisorForeign_Style" )
		screen.hide( "ForeignAdvisorButton" )
		
		iBtnX += iBtnAdvance
		screen.setImageButton( "MilitaryAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_MILITARY_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "MilitaryAdvisorButton", "Button_HUDAdvisorMilitary_Style" )
		screen.hide( "MilitaryAdvisorButton" )
		
		iBtnX += iBtnAdvance
		screen.setImageButton( "TechAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_TECH_CHOOSER).getActionInfoIndex(), -1 )
		screen.setStyle( "TechAdvisorButton", "Button_HUDAdvisorTechnology_Style" )
		screen.hide( "TechAdvisorButton" )

		iBtnX += iBtnAdvance
		screen.setImageButton( "ReligiousAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_RELIGION_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "ReligiousAdvisorButton", "Button_HUDAdvisorReligious_Style" )
		screen.hide( "ReligiousAdvisorButton" )
		
		iBtnX += iBtnAdvance
		screen.setImageButton( "CorporationAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_CORPORATION_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "CorporationAdvisorButton", "Button_HUDAdvisorCorporation_Style" )
		screen.hide( "CorporationAdvisorButton" )
		
		iBtnX += iBtnAdvance
		screen.setImageButton( "VictoryAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_VICTORY_SCREEN).getActionInfoIndex(), -1 )
		screen.setStyle( "VictoryAdvisorButton", "Button_HUDAdvisorVictory_Style" )
		screen.hide( "VictoryAdvisorButton" )
		
		iBtnX += iBtnAdvance
		screen.setImageButton( "InfoAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_INFO).getActionInfoIndex(), -1 )
		screen.setStyle( "InfoAdvisorButton", "Button_HUDAdvisorRecord_Style" )
		screen.hide( "InfoAdvisorButton" )

		if not gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_ESPIONAGE):
			iBtnX += iBtnAdvance
			screen.setImageButton( "EspionageAdvisorButton", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_ESPIONAGE_SCREEN).getActionInfoIndex(), -1 )
			screen.setStyle( "EspionageAdvisorButton", "Button_HUDAdvisorEspionage_Style" )
			screen.hide( "EspionageAdvisorButton" )
		
		# City Tabs
		iBtnX = xResolution - 324
		iBtnY = yResolution - 94
		iBtnWidth = 24
		iBtnAdvance = 24

		screen.setButtonGFC( "CityTab0", "", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_CITY_TAB, 0, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
		screen.setStyle( "CityTab0", "Button_HUDJumpUnit_Style" )
		screen.hide( "CityTab0" )

		iBtnY += iBtnAdvance
		screen.setButtonGFC( "CityTab1", "", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_CITY_TAB, 1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
		screen.setStyle( "CityTab1", "Button_HUDJumpBuilding_Style" )
		screen.hide( "CityTab1" )
		
		iBtnY += iBtnAdvance
		screen.setButtonGFC( "CityTab2", "", "", iBtnX, iBtnY, iBtnWidth, iBtnWidth, WidgetTypes.WIDGET_CITY_TAB, 2, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
		screen.setStyle( "CityTab2", "Button_HUDJumpWonder_Style" )
		screen.hide( "CityTab2" )
		
		# Minimap initialization
		screen.setMainInterface(True)
		
		screen.addPanel( "MiniMapPanel", u"", u"", True, False, xResolution - 214, yResolution - 151, 208, 151, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "MiniMapPanel", "Panel_Game_HudMap_Style" )
		screen.hide( "MiniMapPanel" )

		screen.initMinimap( xResolution - 210, xResolution - 9, yResolution - 131, yResolution - 9, -0.1 )
		gc.getMap().updateMinimapColor()

		self.createMinimapButtons()
	
		# Help button (always visible)
		screen.setImageButton( "InterfaceHelpButton", ArtFileMgr.getInterfaceArtInfo("INTERFACE_GENERAL_CIVILOPEDIA_ICON").getPath(), xResolution - 28, 2, 24, 24, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_CIVILOPEDIA).getActionInfoIndex(), -1 )
		screen.hide( "InterfaceHelpButton" )

		screen.setImageButton( "MainMenuButton", ArtFileMgr.getInterfaceArtInfo("INTERFACE_GENERAL_MENU_ICON").getPath(), xResolution - 54, 2, 24, 24, WidgetTypes.WIDGET_MENU_ICON, -1, -1 )
		screen.hide( "MainMenuButton" )

		# Globeview buttons
		self.createGlobeviewButtons( )

		screen.addMultiListControlGFC( "BottomButtonContainer", u"", iMultiListXL, yResolution - 113, xResolution - (iMultiListXL+iMultiListXR), 100, 4, 48, 48, TableStyles.TABLE_STYLE_STANDARD )		
		screen.hide( "BottomButtonContainer" )

		# *********************************************************************************
		# PLOT LIST BUTTONS
		# *********************************************************************************

		for j in range(gc.getMAX_PLOT_LIST_ROWS()):
			yRow = (j - gc.getMAX_PLOT_LIST_ROWS() + 1) * 34
			yPixel = yResolution - 169 + yRow - 3
			xPixel = 315 - 3
			xWidth = self.numPlotListButtons() * 34 + 3
			yHeight = 32 + 3
		
			szStringPanel = "PlotListPanel" + str(j)
			screen.addPanel(szStringPanel, u"", u"", True, False, xPixel, yPixel, xWidth, yHeight, PanelStyles.PANEL_STYLE_EMPTY)

			for i in range(self.numPlotListButtons()):
				k = j*self.numPlotListButtons()+i
				
				xOffset = i * 34
				
				szString = "PlotListButton" + str(k)
				screen.addCheckBoxGFCAt(szStringPanel, szString, ArtFileMgr.getInterfaceArtInfo("INTERFACE_BUTTONS_GOVERNOR").getPath(), ArtFileMgr.getInterfaceArtInfo("BUTTON_HILITE_SQUARE").getPath(), xOffset + 3, 3, 32, 32, WidgetTypes.WIDGET_PLOT_LIST, k, -1, ButtonStyles.BUTTON_STYLE_LABEL, True )
				screen.hide( szString )
				
				szStringHealth = szString + "Health"
				screen.addStackedBarGFCAt( szStringHealth, szStringPanel, xOffset + 3, 26, 32, 11, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_GENERAL, k, -1 )
				screen.hide( szStringHealth )
				
				szStringIcon = szString + "Icon"
				szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_MOVE").getPath()
				screen.addDDSGFCAt( szStringIcon, szStringPanel, szFileName, xOffset, 0, 12, 12, WidgetTypes.WIDGET_PLOT_LIST, k, -1, False )
				screen.hide( szStringIcon )

		# End Turn Text		
		screen.setLabel( "EndTurnText", "Background", u"", CvUtil.FONT_CENTER_JUSTIFY, 0, yResolution - 188, -0.1, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
		screen.setHitTest( "EndTurnText", HitTestTypes.HITTEST_NOHIT )

		# Three states for end turn button...
		screen.setImageButton( "EndTurnButton", "", xResolution - (iEndOfTurnButtonSize/2) - iEndOfTurnPosX, yResolution - (iEndOfTurnButtonSize/2) - iEndOfTurnPosY, iEndOfTurnButtonSize, iEndOfTurnButtonSize, WidgetTypes.WIDGET_END_TURN, -1, -1 )
		screen.setStyle( "EndTurnButton", "Button_HUDEndTurn_Style" )
		screen.setEndTurnState( "EndTurnButton", "Red" )
		screen.hide( "EndTurnButton" )

		# *********************************************************************************
		# RESEARCH BUTTONS
		# *********************************************************************************

		i = 0
		for i in range( gc.getNumTechInfos() ):
			szName = "ResearchButton" + str(i)
			screen.setImageButton( szName, gc.getTechInfo(i).getButton(), 0, 0, 32, 32, WidgetTypes.WIDGET_RESEARCH, i, -1 )
			screen.hide( szName )

		i = 0
		for i in range(gc.getNumReligionInfos()):
			szName = "ReligionButton" + str(i)
			if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_PICK_RELIGION):
				szButton = gc.getReligionInfo(i).getGenericTechButton()
			else:
				szButton = gc.getReligionInfo(i).getTechButton()
			screen.setImageButton( szName, szButton, 0, 0, 32, 32, WidgetTypes.WIDGET_RESEARCH, gc.getReligionInfo(i).getTechPrereq(), -1 )
			screen.hide( szName )
		
		# *********************************************************************************
		# CITIZEN BUTTONS
		# *********************************************************************************

		szHideCitizenList = []

		# Angry Citizens
		i = 0
		for i in range(MAX_CITIZEN_BUTTONS):
			szName = "AngryCitizen" + str(i)
			screen.setImageButton( szName, ArtFileMgr.getInterfaceArtInfo("INTERFACE_ANGRYCITIZEN_TEXTURE").getPath(), xResolution - 74 - (26 * i), yResolution - 238, 24, 24, WidgetTypes.WIDGET_ANGRY_CITIZEN, -1, -1 )
			screen.hide( szName )
			
		iCount = 0

		# Increase Specialists...
		i = 0
		for i in range( gc.getNumSpecialistInfos() ):
			if (gc.getSpecialistInfo(i).isVisible()):
				szName = "IncreaseSpecialist" + str(i)
				screen.setButtonGFC( szName, u"", "", xResolution - 46, (yResolution - 270 - (26 * iCount)), 20, 20, WidgetTypes.WIDGET_CHANGE_SPECIALIST, i, 1, ButtonStyles.BUTTON_STYLE_CITY_PLUS )
				screen.hide( szName )

				iCount = iCount + 1

		iCount = 0

		# Decrease specialists
		i = 0
		for i in range( gc.getNumSpecialistInfos() ):
			if (gc.getSpecialistInfo(i).isVisible()):
				szName = "DecreaseSpecialist" + str(i)
				screen.setButtonGFC( szName, u"", "", xResolution - 24, (yResolution - 270 - (26 * iCount)), 20, 20, WidgetTypes.WIDGET_CHANGE_SPECIALIST, i, -1, ButtonStyles.BUTTON_STYLE_CITY_MINUS )
				screen.hide( szName )

				iCount = iCount + 1

		iCount = 0

		# Citizen Buttons
		i = 0
		for i in range( gc.getNumSpecialistInfos() ):
		
			if (gc.getSpecialistInfo(i).isVisible()):
			
				szName = "CitizenDisabledButton" + str(i)
				screen.setImageButton( szName, gc.getSpecialistInfo(i).getTexture(), xResolution - 74, (yResolution - 272 - (26 * i)), 24, 24, WidgetTypes.WIDGET_DISABLED_CITIZEN, i, -1 )
				screen.enable( szName, False )
				screen.hide( szName )

				for j in range(MAX_CITIZEN_BUTTONS):
					szName = "CitizenButton" + str((i * 100) + j)
					screen.addCheckBoxGFC( szName, gc.getSpecialistInfo(i).getTexture(), "", xResolution - 74 - (26 * j), (yResolution - 272 - (26 * i)), 24, 24, WidgetTypes.WIDGET_CITIZEN, i, j, ButtonStyles.BUTTON_STYLE_LABEL )
					screen.hide( szName )

		# **********************************************************
		# GAME DATA STRINGS
		# **********************************************************

		szGameDataList = []
		
		screen.addStackedBarGFC( "ResearchBar", 268 + ( (xResolution - 1024) / 2 ), 2, 487, iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_RESEARCH, -1, -1 )
		screen.setStackedBarColors( "ResearchBar", InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_RESEARCH_STORED") )
		screen.setStackedBarColors( "ResearchBar", InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_RESEARCH_RATE") )
		screen.setStackedBarColors( "ResearchBar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.setStackedBarColors( "ResearchBar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.hide( "ResearchBar" )

############################################################
##########=MSM===GP Bar (Impaler)===1/4===0===
############################################################
		if g_bGPBar:
			# long GP Bar for much of info
			if (g_iDetailGPBar == 2):
				screen.addStackedBarGFC( "GreatPersonBar", 268 + ( (xResolution - 1024) / 2 ), 30, 487, iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_HELP_GREAT_PEOPLE, -1, -1 )
			# original length
			else:
				screen.addStackedBarGFC( "GreatPersonBar", 328 + ( (xResolution - 1024) / 2 ), 30, 367, iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_HELP_GREAT_PEOPLE, -1, -1 )
			screen.setStackedBarColors( "GreatPersonBar", InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_GREAT_PEOPLE_STORED") )
			screen.setStackedBarColors( "GreatPersonBar", InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_GREAT_PEOPLE_RATE") )
			screen.setStackedBarColors( "GreatPersonBar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.setStackedBarColors( "GreatPersonBar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.hide( "GreatPersonBar" )
############################################################
##########=MSM===GP Bar (Impaler)===1/4===X===
############################################################

#----------Dimon157 Culture 1/3 0
		if (g_iThreeCulturedCities > 0):
			screen.addStackedBarGFC( "Culture1Bar", xResolution - 211, 59, 150, 19, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_RESEARCH, -1, -1 )
			screen.setStackedBarColors( "Culture1Bar", InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_RESEARCH_STORED") )
			screen.setStackedBarColors( "Culture1Bar", InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_RESEARCH_RATE") )
			screen.setStackedBarColors( "Culture1Bar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.setStackedBarColors( "Culture1Bar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.hide( "Culture1Bar" )
			screen.addStackedBarGFC( "Culture2Bar", xResolution - 211, 79, 150, 19, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_RESEARCH, -1, -1 )
			screen.setStackedBarColors( "Culture2Bar", InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_RESEARCH_STORED") )
			screen.setStackedBarColors( "Culture2Bar", InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_RESEARCH_RATE") )
			screen.setStackedBarColors( "Culture2Bar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.setStackedBarColors( "Culture2Bar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.hide( "Culture2Bar" )
			screen.addStackedBarGFC( "Culture3Bar", xResolution - 211, 99, 150, 19, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_RESEARCH, -1, -1 )
			screen.setStackedBarColors( "Culture3Bar", InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_RESEARCH_STORED") )
			screen.setStackedBarColors( "Culture3Bar", InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_RESEARCH_RATE") )
			screen.setStackedBarColors( "Culture3Bar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.setStackedBarColors( "Culture3Bar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
			screen.hide( "Culture3Bar" )
#----------Dimon157 Culture 1/3 X
		
		# *********************************************************************************
		# SELECTION DATA BUTTONS/STRINGS
		# *********************************************************************************

		szHideSelectionDataList = []

		screen.addStackedBarGFC( "PopulationBar", iCityCenterRow1X, iCityCenterRow1Y-4, xResolution - (iCityCenterRow1X*2), iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_HELP_POPULATION, -1, -1 )
		screen.setStackedBarColors( "PopulationBar", InfoBarTypes.INFOBAR_STORED, gc.getYieldInfo(YieldTypes.YIELD_FOOD).getColorType() )
		screen.setStackedBarColorsAlpha( "PopulationBar", InfoBarTypes.INFOBAR_RATE, gc.getYieldInfo(YieldTypes.YIELD_FOOD).getColorType(), 0.8 )
		screen.setStackedBarColors( "PopulationBar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_NEGATIVE_RATE") )
		screen.setStackedBarColors( "PopulationBar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.hide( "PopulationBar" )
		
		screen.addStackedBarGFC( "ProductionBar", iCityCenterRow2X, iCityCenterRow2Y-4, xResolution - (iCityCenterRow2X*2), iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_HELP_PRODUCTION, -1, -1 )
		screen.setStackedBarColors( "ProductionBar", InfoBarTypes.INFOBAR_STORED, gc.getYieldInfo(YieldTypes.YIELD_PRODUCTION).getColorType() )
		screen.setStackedBarColorsAlpha( "ProductionBar", InfoBarTypes.INFOBAR_RATE, gc.getYieldInfo(YieldTypes.YIELD_PRODUCTION).getColorType(), 0.8 )
		screen.setStackedBarColors( "ProductionBar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getYieldInfo(YieldTypes.YIELD_FOOD).getColorType() )
		screen.setStackedBarColors( "ProductionBar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.hide( "ProductionBar" )
		
		screen.addStackedBarGFC( "GreatPeopleBar", xResolution - 246, yResolution - 180, 194, iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_HELP_GREAT_PEOPLE, -1, -1 )
		screen.setStackedBarColors( "GreatPeopleBar", InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_GREAT_PEOPLE_STORED") )
		screen.setStackedBarColors( "GreatPeopleBar", InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_GREAT_PEOPLE_RATE") )
		screen.setStackedBarColors( "GreatPeopleBar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.setStackedBarColors( "GreatPeopleBar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.hide( "GreatPeopleBar" )
		
		screen.addStackedBarGFC( "CultureBar", 16, yResolution - 188, 220, iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_HELP_CULTURE, -1, -1 )
		screen.setStackedBarColors( "CultureBar", InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_CULTURE_STORED") )
		screen.setStackedBarColors( "CultureBar", InfoBarTypes.INFOBAR_RATE, gc.getInfoTypeForString("COLOR_CULTURE_RATE") )
		screen.setStackedBarColors( "CultureBar", InfoBarTypes.INFOBAR_RATE_EXTRA, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.setStackedBarColors( "CultureBar", InfoBarTypes.INFOBAR_EMPTY, gc.getInfoTypeForString("COLOR_EMPTY") )
		screen.hide( "CultureBar" )

		# Holy City Overlay
		# Number Changed for Shinto Mod: i * 34 Changed to i * 20; 24, 24 Changed to 18, 18.
		for i in range( gc.getNumReligionInfos() ):
			xCoord = xResolution - 242 + (i * 20)
			yCoord = 42
			szName = "ReligionHolyCityDDS" + str(i)
			screen.addDDSGFC( szName, ArtFileMgr.getInterfaceArtInfo("INTERFACE_HOLYCITY_OVERLAY").getPath(), xCoord, yCoord, 18, 18, WidgetTypes.WIDGET_HELP_RELIGION_CITY, i, -1 )
			screen.hide( szName )

		# Number Changed for Shinto Mod: i * 34 Changed to i * 20; 24, 24 Changed to 18, 18.
		for i in range( gc.getNumCorporationInfos() ):
			xCoord = xResolution - 242 + (i * 20)
			yCoord = 66
			szName = "CorporationHeadquarterDDS" + str(i)
			screen.addDDSGFC( szName, ArtFileMgr.getInterfaceArtInfo("INTERFACE_HOLYCITY_OVERLAY").getPath(), xCoord, yCoord, 18, 18, WidgetTypes.WIDGET_HELP_CORPORATION_CITY, i, -1 )
			screen.hide( szName )

		screen.addStackedBarGFC( "NationalityBar", 16, yResolution - 214, 220, iStackBarHeight, InfoBarTypes.NUM_INFOBAR_TYPES, WidgetTypes.WIDGET_HELP_NATIONALITY, -1, -1 )
		screen.hide( "NationalityBar" )

		screen.setButtonGFC( "CityScrollMinus", u"", "", 274, 32, 32, 32, WidgetTypes.WIDGET_CITY_SCROLL, -1, -1, ButtonStyles.BUTTON_STYLE_ARROW_LEFT )
		screen.hide( "CityScrollMinus" )

		screen.setButtonGFC( "CityScrollPlus", u"", "", 288, 32, 32, 32, WidgetTypes.WIDGET_CITY_SCROLL, 1, -1, ButtonStyles.BUTTON_STYLE_ARROW_RIGHT )
		screen.hide( "CityScrollPlus" )

############################################################
##########=MSM===Main City Scroll (SimCutie)===1/9===0===
############################################################
		if g_bMainCityScroll:
			screen.setButtonGFC( "MainCityScrollMinus", u"", "", xResolution - 275, yResolution - 165, 32, 32, WidgetTypes.WIDGET_CITY_SCROLL, -1, -1, ButtonStyles.BUTTON_STYLE_ARROW_LEFT )
			screen.hide( "MainCityScrollMinus" )

			screen.setButtonGFC( "MainCityScrollPlus", u"", "", xResolution - 255, yResolution - 165, 32, 32, WidgetTypes.WIDGET_CITY_SCROLL, 1, -1, ButtonStyles.BUTTON_STYLE_ARROW_RIGHT )
			screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===1/9===X===
############################################################
		
		screen.setButtonGFC( "PlotListMinus", u"", "", 315 + ( xResolution - (iMultiListXL+iMultiListXR) - 68 ), yResolution - 171, 32, 32, WidgetTypes.WIDGET_PLOT_LIST_SHIFT, -1, -1, ButtonStyles.BUTTON_STYLE_ARROW_LEFT )
		screen.hide( "PlotListMinus" )

		screen.setButtonGFC( "PlotListPlus", u"", "", 298 + ( xResolution - (iMultiListXL+iMultiListXR) - 34 ), yResolution - 171, 32, 32, WidgetTypes.WIDGET_PLOT_LIST_SHIFT, 1, -1, ButtonStyles.BUTTON_STYLE_ARROW_RIGHT )
		screen.hide( "PlotListPlus" )

############################################################
##########=MSM===Raw City Commerce Display (Sevo)=2/9===0===
############################################################
		screen.addPanel( "TradeRouteListBackground", u"", u"", True, False, 10, 247, 238, 30, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "TradeRouteListBackground", "Panel_City_Header_Style" )
		screen.hide( "TradeRouteListBackground" )

		screen.setLabel( "TradeRouteListLabel", "Background", localText.getText("TXT_KEY_HEADING_TRADEROUTE_LIST", ()), CvUtil.FONT_CENTER_JUSTIFY, 129, 255, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
		screen.hide( "TradeRouteListLabel" )

		screen.addPanel( "BuildingListBackground", u"", u"", True, False, 10, 377, 238, 30, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "BuildingListBackground", "Panel_City_Header_Style" )
		screen.hide( "BuildingListBackground" )

		screen.setLabel( "BuildingListLabel", "Background", localText.getText("TXT_KEY_CONCEPT_BUILDINGS", ()), CvUtil.FONT_CENTER_JUSTIFY, 129, 385, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
		screen.hide( "BuildingListLabel" )
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=2/9===X===
############################################################

		# *********************************************************************************
		# UNIT INFO ELEMENTS
		# *********************************************************************************

		i = 0
		for i in range(gc.getNumPromotionInfos()):
			szName = "PromotionButton" + str(i)
			screen.addDDSGFC( szName, gc.getPromotionInfo(i).getButton(), 180, yResolution - 18, 24, 24, WidgetTypes.WIDGET_ACTION, gc.getPromotionInfo(i).getActionInfoIndex(), -1 )
			screen.hide( szName )
			
		# *********************************************************************************
		# SCORES
		# *********************************************************************************
		
		screen.addPanel( "ScoreBackground", u"", u"", True, False, 0, 0, 0, 0, PanelStyles.PANEL_STYLE_HUD_HELP )
		screen.hide( "ScoreBackground" )
		screen.addPanel( "CultureBackground", u"", u"", True, False, 0, 0, 0, 0, PanelStyles.PANEL_STYLE_HUD_HELP )
		screen.hide( "CultureBackground" )

		for i in range( gc.getMAX_PLAYERS() ):
			szName = "ScoreText" + str(i)
			screen.setText( szName, "Background", u"", CvUtil.FONT_RIGHT_JUSTIFY, 996, 622, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_CONTACT_CIV, i, -1 )
			screen.hide( szName )
			
		# This should be a forced redraw screen
		screen.setForcedRedraw( True )
		
		# This should show the screen immidiately and pass input to the game
		screen.showScreen(PopupStates.POPUPSTATE_IMMEDIATE, True)
		
		szHideList = []
		
		szHideList.append( "CreateGroup" )
		szHideList.append( "DeleteGroup" )

		# City Tabs
		for i in range( g_NumCityTabTypes ):
			szButtonID = "CityTab" + str(i)
			szHideList.append( szButtonID )
					
		for i in range( g_NumHurryInfos ):
			szButtonID = "Hurry" + str(i)
			szHideList.append( szButtonID )

		szHideList.append( "Hurry0" )
		szHideList.append( "Hurry1" )
		
		screen.registerHideList( szHideList, len(szHideList), 0 )

		return 0

	# Will update the screen (every 250 MS)
	def updateScreen(self):
		
		global g_szTimeText
		global g_iTimeTextCounter

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		
		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		self.m_iNumPlotListButtons = (xResolution - (iMultiListXL+iMultiListXR) - 68) / 34
		
		# This should recreate the minimap on load games and returns if already exists -JW
		screen.initMinimap( xResolution - 210, xResolution - 9, yResolution - 131, yResolution - 9, -0.1 )

		messageControl = CyMessageControl()
		
		bShow = False
		
		# Hide all interface widgets		
		#screen.hide( "EndTurnText" )

		if ( CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY ):
			if (gc.getGame().isPaused()):
				# Pause overrides other messages
				acOutput = localText.getText("SYSTEM_GAME_PAUSED", (gc.getPlayer(gc.getGame().getPausePlayer()).getNameKey(), ))
				#screen.modifyLabel( "EndTurnText", acOutput, CvUtil.FONT_CENTER_JUSTIFY )
				screen.setEndTurnState( "EndTurnText", acOutput )
				bShow = True
			elif (messageControl.GetFirstBadConnection() != -1):
				# Waiting on a bad connection to resolve
				if (messageControl.GetConnState(messageControl.GetFirstBadConnection()) == 1):
					if (gc.getGame().isMPOption(MultiplayerOptionTypes.MPOPTION_ANONYMOUS)):
						acOutput = localText.getText("SYSTEM_WAITING_FOR_PLAYER", (gc.getPlayer(messageControl.GetFirstBadConnection()).getNameKey(), 0))
					else:
						acOutput = localText.getText("SYSTEM_WAITING_FOR_PLAYER", (gc.getPlayer(messageControl.GetFirstBadConnection()).getNameKey(), (messageControl.GetFirstBadConnection() + 1)))
					#screen.modifyLabel( "EndTurnText", acOutput, CvUtil.FONT_CENTER_JUSTIFY )
					screen.setEndTurnState( "EndTurnText", acOutput )
					bShow = True
				elif (messageControl.GetConnState(messageControl.GetFirstBadConnection()) == 2):
					if (gc.getGame().isMPOption(MultiplayerOptionTypes.MPOPTION_ANONYMOUS)):
						acOutput = localText.getText("SYSTEM_PLAYER_JOINING", (gc.getPlayer(messageControl.GetFirstBadConnection()).getNameKey(), 0))
					else:
						acOutput = localText.getText("SYSTEM_PLAYER_JOINING", (gc.getPlayer(messageControl.GetFirstBadConnection()).getNameKey(), (messageControl.GetFirstBadConnection() + 1)))
					#screen.modifyLabel( "EndTurnText", acOutput, CvUtil.FONT_CENTER_JUSTIFY )
					screen.setEndTurnState( "EndTurnText", acOutput )
					bShow = True
			else:
				# Flash select messages if no popups are present
				if ( CyInterface().shouldDisplayReturn() ):
					acOutput = localText.getText("SYSTEM_RETURN", ())
					#screen.modifyLabel( "EndTurnText", acOutput, CvUtil.FONT_CENTER_JUSTIFY )
					screen.setEndTurnState( "EndTurnText", acOutput )
					bShow = True
				elif ( CyInterface().shouldDisplayWaitingOthers() ):
					acOutput = localText.getText("SYSTEM_WAITING", ())
					#screen.modifyLabel( "EndTurnText", acOutput, CvUtil.FONT_CENTER_JUSTIFY )
					screen.setEndTurnState( "EndTurnText", acOutput )
					bShow = True
				elif ( CyInterface().shouldDisplayEndTurn() ):
					acOutput = localText.getText("SYSTEM_END_TURN", ())
					#screen.modifyLabel( "EndTurnText", acOutput, CvUtil.FONT_CENTER_JUSTIFY )
					screen.setEndTurnState( "EndTurnText", acOutput )
					bShow = True
				elif ( CyInterface().shouldDisplayWaitingYou() ):
					acOutput = localText.getText("SYSTEM_WAITING_FOR_YOU", ())
					#screen.modifyLabel( "EndTurnText", acOutput, CvUtil.FONT_CENTER_JUSTIFY )
					screen.setEndTurnState( "EndTurnText", acOutput )
					bShow = True

		if ( bShow ):
			screen.showEndTurn( "EndTurnText" )
			if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW or CyInterface().isCityScreenUp() ):
				screen.moveItem( "EndTurnText", 0, yResolution - 194, -0.1 )
			else:
				screen.moveItem( "EndTurnText", 0, yResolution - 86, -0.1 )
		else:
			screen.hideEndTurn( "EndTurnText" )

		self.updateEndTurnButton()
		
		if (CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_ADVANCED_START):
			self.updateTimeText()
			screen.setLabel( "TimeText", "Background", g_szTimeText, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 56, 6, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
			screen.show( "TimeText" )
		else:
			screen.hide( "TimeText" )		

		return 0

	# Will redraw the interface
	def redraw( self ):

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		# Check Dirty Bits, see what we need to redraw...
		if (CyInterface().isDirty(InterfaceDirtyBits.PercentButtons_DIRTY_BIT) == True):
			# Percent Buttons
			self.updatePercentButtons()
			CyInterface().setDirty(InterfaceDirtyBits.PercentButtons_DIRTY_BIT, False)
		if (CyInterface().isDirty(InterfaceDirtyBits.Flag_DIRTY_BIT) == True):
			# Percent Buttons
			self.updateFlag()
			CyInterface().setDirty(InterfaceDirtyBits.Flag_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.MiscButtons_DIRTY_BIT) == True ):
			# Miscellaneous buttons (civics screen, etc)
			self.updateMiscButtons()
			CyInterface().setDirty(InterfaceDirtyBits.MiscButtons_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.InfoPane_DIRTY_BIT) == True ):
			# Info Pane Dirty Bit
			# This must come before updatePlotListButtons so that the entity widget appears in front of the stats
			self.updateInfoPaneStrings()
			CyInterface().setDirty(InterfaceDirtyBits.InfoPane_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.PlotListButtons_DIRTY_BIT) == True ):
			# Plot List Buttons Dirty
			self.updatePlotListButtons()
			CyInterface().setDirty(InterfaceDirtyBits.PlotListButtons_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.SelectionButtons_DIRTY_BIT) == True ):
			# Selection Buttons Dirty
			self.updateSelectionButtons()
			CyInterface().setDirty(InterfaceDirtyBits.SelectionButtons_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.ResearchButtons_DIRTY_BIT) == True ):
			# Research Buttons Dirty
			self.updateResearchButtons()
			CyInterface().setDirty(InterfaceDirtyBits.ResearchButtons_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.CitizenButtons_DIRTY_BIT) == True ):
			# Citizen Buttons Dirty
			self.updateCitizenButtons()
			CyInterface().setDirty(InterfaceDirtyBits.CitizenButtons_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.GameData_DIRTY_BIT) == True ):
			# Game Data Strings Dirty
			self.updateGameDataStrings()
			CyInterface().setDirty(InterfaceDirtyBits.GameData_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.Help_DIRTY_BIT) == True ):
			# Help Dirty bit
			self.updateHelpStrings()
			CyInterface().setDirty(InterfaceDirtyBits.Help_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.CityScreen_DIRTY_BIT) == True ):
			# Selection Data Dirty Bit
			self.updateCityScreen()
			CyInterface().setDirty(InterfaceDirtyBits.Domestic_Advisor_DIRTY_BIT, True)
			CyInterface().setDirty(InterfaceDirtyBits.CityScreen_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.Score_DIRTY_BIT) == True or CyInterface().checkFlashUpdate() ):
			# Scores!
			self.updateScoreStrings()
			CyInterface().setDirty(InterfaceDirtyBits.Score_DIRTY_BIT, False)
		if ( CyInterface().isDirty(InterfaceDirtyBits.GlobeInfo_DIRTY_BIT) == True ):
			# Globeview and Globelayer buttons
			CyInterface().setDirty(InterfaceDirtyBits.GlobeInfo_DIRTY_BIT, False)
			self.updateGlobeviewButtons()
		
		return 0

	# Will update the percent buttons
	def updatePercentButtons( self ):

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		for iI in range( CommerceTypes.NUM_COMMERCE_TYPES ):
			szString = "IncreasePercent" + str(iI)
			screen.hide( szString )
			szString = "DecreasePercent" + str(iI)
			screen.hide( szString )

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()

		if ( not CyInterface().isCityScreenUp() or ( pHeadSelectedCity.getOwner() == gc.getGame().getActivePlayer() ) or gc.getGame().isDebugMode() ):
			iCount = 0

			if ( CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_ADVANCED_START):
				for iI in range( CommerceTypes.NUM_COMMERCE_TYPES ):
					# Intentional offset...
					eCommerce = (iI + 1) % CommerceTypes.NUM_COMMERCE_TYPES
										
					if (gc.getActivePlayer().isCommerceFlexible(eCommerce) or (CyInterface().isCityScreenUp() and (eCommerce == CommerceTypes.COMMERCE_GOLD))):
						szString1 = "IncreasePercent" + str(eCommerce)
						screen.setButtonGFC( szString1, u"", "", 70, 50 + (19 * iCount), 20, 20, WidgetTypes.WIDGET_CHANGE_PERCENT, eCommerce, gc.getDefineINT("COMMERCE_PERCENT_CHANGE_INCREMENTS"), ButtonStyles.BUTTON_STYLE_CITY_PLUS )
						screen.show( szString1 )
						szString2 = "DecreasePercent" + str(eCommerce)
						screen.setButtonGFC( szString2, u"", "", 90, 50 + (19 * iCount), 20, 20, WidgetTypes.WIDGET_CHANGE_PERCENT, eCommerce, -gc.getDefineINT("COMMERCE_PERCENT_CHANGE_INCREMENTS"), ButtonStyles.BUTTON_STYLE_CITY_MINUS )
						screen.show( szString2 )

						iCount = iCount + 1

						if (gc.getActivePlayer().isCommerceFlexible(eCommerce)):
							screen.enable( szString1, True )
							screen.enable( szString2, True )
						else:
							screen.enable( szString1, False )
							screen.enable( szString2, False )
							
		return 0

	# Will update the end Turn Button
	def updateEndTurnButton( self ):

		global g_eEndTurnButtonState
		
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		if ( CyInterface().shouldDisplayEndTurnButton() and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
		
			eState = CyInterface().getEndTurnState()
			
			bShow = False
			
			if ( eState == EndTurnButtonStates.END_TURN_OVER_HIGHLIGHT ):
				screen.setEndTurnState( "EndTurnButton", u"Red" )
				bShow = True
			elif ( eState == EndTurnButtonStates.END_TURN_OVER_DARK ):
				screen.setEndTurnState( "EndTurnButton", u"Red" )
				bShow = True
			elif ( eState == EndTurnButtonStates.END_TURN_GO ):
				screen.setEndTurnState( "EndTurnButton", u"Green" )
				bShow = True
			
			if ( bShow ):
				screen.showEndTurn( "EndTurnButton" )
			else:
				screen.hideEndTurn( "EndTurnButton" )
			
			if ( g_eEndTurnButtonState == eState ):
				return
				
			g_eEndTurnButtonState = eState
			
		else:
			screen.hideEndTurn( "EndTurnButton" )

		return 0

	# Update the miscellaneous buttons
	def updateMiscButtons( self ):
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		
		xResolution = screen.getXResolution()

		if ( CyInterface().shouldDisplayFlag() and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
#----------Dimon157 Best Cities 2/4 0
			if (g_bThreeBestCities):
				global hammerNo1Count
				global hammerNo1CityName
				global hammerNo2Count
				global hammerNo2CityName
				global hammerNo3Count
				global hammerNo3CityName
				global scienceNo1Count
				global scienceNo1CityName
				global scienceNo2Count
				global scienceNo2CityName
				global scienceNo3Count
				global scienceNo3CityName
				global goldNo1Count
				global goldNo1CityName
				global goldNo2Count
				global goldNo2CityName
				global goldNo3Count
				global goldNo3CityName
				global espionageNo1Count
				global espionageNo1CityName
				global espionageNo2Count
				global espionageNo2CityName
				global espionageNo3Count
				global espionageNo3CityName

				if (hammerNo1Count>0):
					screen.show( "HammerNo1Button" )
					screen.show( "HammerNo1Text" )
				if (hammerNo2Count>0):
					screen.show( "HammerNo2Button" )
					screen.show( "HammerNo2Text" )
				if (hammerNo3Count>0):
					screen.show( "HammerNo3Button" )
					screen.show( "HammerNo3Text" )
				if (scienceNo1Count>0):
					screen.show( "ScienceNo1Button" )
					screen.show( "ScienceNo1Text" )
				if (scienceNo2Count>0):
					screen.show( "ScienceNo2Button" )
					screen.show( "ScienceNo2Text" )
				if (scienceNo3Count>0):
					screen.show( "ScienceNo3Button" )
					screen.show( "ScienceNo3Text" )
				if (goldNo1Count>0):
					screen.show( "GoldNo1Button" )
					screen.show( "GoldNo1Text" )
				if (goldNo2Count>0):
					screen.show( "GoldNo2Button" )
					screen.show( "GoldNo2Text" )
				if (goldNo3Count>0):
					screen.show( "GoldNo3Button" )
					screen.show( "GoldNo3Text" )
				if (espionageNo1Count>0):
					screen.show( "EspionageNo1Button" )
					screen.show( "EspionageNo1Text" )

			else:
				screen.show( "CivilizationFlag" )
#----------Dimon157 Best Cities 2/4 X
			screen.show( "InterfaceHelpButton" )
			screen.show( "MainMenuButton" )
		else:
#----------Dimon157 Best Cities 3/4 0
			if (g_bThreeBestCities):
				screen.hide( "HammerNo1Button" )
				screen.hide( "HammerNo1Text" )
				screen.hide( "HammerNo2Button" )
				screen.hide( "HammerNo2Text" )
				screen.hide( "HammerNo3Button" )
				screen.hide( "HammerNo3Text" )
				screen.hide( "ScienceNo1Button" )
				screen.hide( "ScienceNo1Text" )
				screen.hide( "ScienceNo2Button" )
				screen.hide( "ScienceNo2Text" )
				screen.hide( "ScienceNo3Button" )
				screen.hide( "ScienceNo3Text" )
				screen.hide( "GoldNo1Button" )
				screen.hide( "GoldNo1Text" )
				screen.hide( "GoldNo2Button" )
				screen.hide( "GoldNo2Text" )
				screen.hide( "GoldNo3Button" )
				screen.hide( "GoldNo3Text" )
				screen.hide( "EspionageNo1Button" )
				screen.hide( "EspionageNo1Text" )

			else:
				screen.hide( "CivilizationFlag" )
#----------Dimon157 Best Cities 3/4 X
			screen.hide( "InterfaceHelpButton" )
			screen.hide( "MainMenuButton" )

		if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE_ALL or CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_MINIMAP_ONLY ):
			screen.hide( "InterfaceLeftBackgroundWidget" )
			screen.hide( "InterfaceTopBackgroundWidget" )
			screen.hide( "InterfaceCenterBackgroundWidget" )
			screen.hide( "InterfaceRightBackgroundWidget" )
			screen.hide( "MiniMapPanel" )
			screen.hide( "InterfaceTopLeft" )
			screen.hide( "InterfaceTopCenter" )
			screen.hide( "InterfaceTopRight" )
			screen.hide( "TurnLogButton" )
##### RtW
			screen.hide( "ChangeCivButton" )
			screen.hide( "EspionageAdvisorButton" )
			screen.hide( "DomesticAdvisorButton" )
			screen.hide( "ForeignAdvisorButton" )
			screen.hide( "TechAdvisorButton" )
			screen.hide( "CivicsAdvisorButton" )
			screen.hide( "ReligiousAdvisorButton" )
			screen.hide( "CorporationAdvisorButton" )
			screen.hide( "FinanceAdvisorButton" )
			screen.hide( "MilitaryAdvisorButton" )
			screen.hide( "VictoryAdvisorButton" )
			screen.hide( "InfoAdvisorButton" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===2/9===0===
############################################################
			screen.hide( "MainCityScrollMinus" )
			screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===2/9===X===
############################################################
			
		elif ( CyInterface().isCityScreenUp() ):
			screen.show( "InterfaceLeftBackgroundWidget" )
			screen.show( "InterfaceTopBackgroundWidget" )
			screen.show( "InterfaceCenterBackgroundWidget" )
			screen.show( "InterfaceRightBackgroundWidget" )
			screen.show( "MiniMapPanel" )
			screen.hide( "InterfaceTopLeft" )
			screen.hide( "InterfaceTopCenter" )
			screen.hide( "InterfaceTopRight" )
			screen.hide( "TurnLogButton" )
##### RtW
			screen.hide( "ChangeCivButton" )
			screen.hide( "EspionageAdvisorButton" )
			screen.hide( "DomesticAdvisorButton" )
			screen.hide( "ForeignAdvisorButton" )
			screen.hide( "TechAdvisorButton" )
			screen.hide( "CivicsAdvisorButton" )
			screen.hide( "ReligiousAdvisorButton" )
			screen.hide( "CorporationAdvisorButton" )
			screen.hide( "FinanceAdvisorButton" )
			screen.hide( "MilitaryAdvisorButton" )
			screen.hide( "VictoryAdvisorButton" )
			screen.hide( "InfoAdvisorButton" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===3/9===0===
############################################################
			screen.hide( "MainCityScrollMinus" )
			screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===3/9===X===
############################################################
			
		elif ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE):
			screen.hide( "InterfaceLeftBackgroundWidget" )
			screen.show( "InterfaceTopBackgroundWidget" )
			screen.hide( "InterfaceCenterBackgroundWidget" )
			screen.hide( "InterfaceRightBackgroundWidget" )
			screen.hide( "MiniMapPanel" )
			screen.show( "InterfaceTopLeft" )
			screen.show( "InterfaceTopCenter" )
			screen.show( "InterfaceTopRight" )
			screen.show( "TurnLogButton" )
##### RtW
			if (gc.getDCM_CIV_CHANGER()):
                            screen.show( "ChangeCivButton" )
			screen.show( "EspionageAdvisorButton" )
			screen.show( "DomesticAdvisorButton" )
			screen.show( "ForeignAdvisorButton" )
			screen.show( "TechAdvisorButton" )
			screen.show( "CivicsAdvisorButton" )
			screen.show( "ReligiousAdvisorButton" )
			screen.show( "CorporationAdvisorButton" )
			screen.show( "FinanceAdvisorButton" )
			screen.show( "MilitaryAdvisorButton" )
			screen.show( "VictoryAdvisorButton" )
			screen.show( "InfoAdvisorButton" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===4/9===0===
############################################################
			screen.hide( "MainCityScrollMinus" )
			screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===4/9===X===
############################################################
			screen.moveToFront( "TurnLogButton" )
##### RtW
			if (gc.getDCM_CIV_CHANGER()):
                            screen.moveToFront( "ChangeCivButton" )
			screen.moveToFront( "EspionageAdvisorButton" )
			screen.moveToFront( "DomesticAdvisorButton" )
			screen.moveToFront( "ForeignAdvisorButton" )
			screen.moveToFront( "TechAdvisorButton" )
			screen.moveToFront( "CivicsAdvisorButton" )
			screen.moveToFront( "ReligiousAdvisorButton" )
			screen.moveToFront( "CorporationAdvisorButton" )
			screen.moveToFront( "FinanceAdvisorButton" )
			screen.moveToFront( "MilitaryAdvisorButton" )
			screen.moveToFront( "VictoryAdvisorButton" )
			screen.moveToFront( "InfoAdvisorButton" )

		elif (CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_ADVANCED_START):		
			screen.hide( "InterfaceLeftBackgroundWidget" )
			screen.hide( "InterfaceTopBackgroundWidget" )
			screen.hide( "InterfaceCenterBackgroundWidget" )
			screen.hide( "InterfaceRightBackgroundWidget" )
			screen.show( "MiniMapPanel" )
			screen.hide( "InterfaceTopLeft" )
			screen.hide( "InterfaceTopCenter" )
			screen.hide( "InterfaceTopRight" )
			screen.hide( "TurnLogButton" )
##### RtW
			screen.hide( "ChangeCivButton" )
			screen.hide( "EspionageAdvisorButton" )
			screen.hide( "DomesticAdvisorButton" )
			screen.hide( "ForeignAdvisorButton" )
			screen.hide( "TechAdvisorButton" )
			screen.hide( "CivicsAdvisorButton" )
			screen.hide( "ReligiousAdvisorButton" )
			screen.hide( "CorporationAdvisorButton" )
			screen.hide( "FinanceAdvisorButton" )
			screen.hide( "MilitaryAdvisorButton" )
			screen.hide( "VictoryAdvisorButton" )
			screen.hide( "InfoAdvisorButton" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===5/9===0===
############################################################
			screen.hide( "MainCityScrollMinus" )
			screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===5/9===X===
############################################################
			
		elif ( CyEngine().isGlobeviewUp() ):
			screen.hide( "InterfaceLeftBackgroundWidget" )
			screen.hide( "InterfaceTopBackgroundWidget" )
			screen.hide( "InterfaceCenterBackgroundWidget" )
			screen.show( "InterfaceRightBackgroundWidget" )
			screen.show( "MiniMapPanel" )
			screen.show( "InterfaceTopLeft" )
			screen.show( "InterfaceTopCenter" )
			screen.show( "InterfaceTopRight" )
			screen.show( "TurnLogButton" )
##### RtW
			if (gc.getDCM_CIV_CHANGER()):
                            screen.show( "ChangeCivButton" )
			screen.show( "EspionageAdvisorButton" )
			screen.show( "DomesticAdvisorButton" )
			screen.show( "ForeignAdvisorButton" )
			screen.show( "TechAdvisorButton" )
			screen.show( "CivicsAdvisorButton" )
			screen.show( "ReligiousAdvisorButton" )
			screen.show( "CorporationAdvisorButton" )
			screen.show( "FinanceAdvisorButton" )
			screen.show( "MilitaryAdvisorButton" )
			screen.show( "VictoryAdvisorButton" )
			screen.show( "InfoAdvisorButton" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===6/9===0===
############################################################
			screen.hide( "MainCityScrollMinus" )
			screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===6/9===X===
############################################################			
			screen.moveToFront( "TurnLogButton" )
##### RtW
			if (gc.getDCM_CIV_CHANGER()):
                            screen.moveToFront( "ChangeCivButton" )
			screen.moveToFront( "EspionageAdvisorButton" )
			screen.moveToFront( "DomesticAdvisorButton" )
			screen.moveToFront( "ForeignAdvisorButton" )
			screen.moveToFront( "TechAdvisorButton" )
			screen.moveToFront( "CivicsAdvisorButton" )
			screen.moveToFront( "ReligiousAdvisorButton" )
			screen.moveToFront( "CorporationAdvisorButton" )
			screen.moveToFront( "FinanceAdvisorButton" )
			screen.moveToFront( "MilitaryAdvisorButton" )
			screen.moveToFront( "VictoryAdvisorButton" )
			screen.moveToFront( "InfoAdvisorButton" )
			
		else:
			screen.show( "InterfaceLeftBackgroundWidget" )
			screen.show( "InterfaceTopBackgroundWidget" )
			screen.show( "InterfaceCenterBackgroundWidget" )
			screen.show( "InterfaceRightBackgroundWidget" )
			screen.show( "MiniMapPanel" )
			screen.show( "InterfaceTopLeft" )
			screen.show( "InterfaceTopCenter" )
			screen.show( "InterfaceTopRight" )
			screen.show( "TurnLogButton" )
##### RtW
			if (gc.getDCM_CIV_CHANGER()):
                            screen.show( "ChangeCivButton" )
			screen.show( "EspionageAdvisorButton" )
			screen.show( "DomesticAdvisorButton" )
			screen.show( "ForeignAdvisorButton" )
			screen.show( "TechAdvisorButton" )
			screen.show( "CivicsAdvisorButton" )
			screen.show( "ReligiousAdvisorButton" )
			screen.show( "CorporationAdvisorButton" )
			screen.show( "FinanceAdvisorButton" )
			screen.show( "MilitaryAdvisorButton" )
			screen.show( "VictoryAdvisorButton" )
			screen.show( "InfoAdvisorButton" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===7/9===0===
############################################################
			if g_bMainCityScroll:
				screen.show( "MainCityScrollMinus" )
				screen.show( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===7/9===X===
############################################################
			screen.moveToFront( "TurnLogButton" )
##### RtW
			if (gc.getDCM_CIV_CHANGER()):
                            screen.moveToFront( "ChangeCivButton" )
			screen.moveToFront( "EspionageAdvisorButton" )
			screen.moveToFront( "DomesticAdvisorButton" )
			screen.moveToFront( "ForeignAdvisorButton" )
			screen.moveToFront( "TechAdvisorButton" )
			screen.moveToFront( "CivicsAdvisorButton" )
			screen.moveToFront( "ReligiousAdvisorButton" )
			screen.moveToFront( "CorporationAdvisorButton" )
			screen.moveToFront( "FinanceAdvisorButton" )
			screen.moveToFront( "MilitaryAdvisorButton" )
			screen.moveToFront( "VictoryAdvisorButton" )
			screen.moveToFront( "InfoAdvisorButton" )
			
		screen.updateMinimapVisibility()

		return 0

	# Update plot List Buttons
	def updatePlotListButtons( self ):

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		bHandled = False
		if ( CyInterface().shouldDisplayUnitModel() and CyEngine().isGlobeviewUp() == false and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL ):
			if ( CyInterface().isCitySelection() ):

				iOrders = CyInterface().getNumOrdersQueued()

				for i in range( iOrders ):
					if ( bHandled == False ):
						eOrderNodeType = CyInterface().getOrderNodeType(i)
						if (eOrderNodeType  == OrderTypes.ORDER_TRAIN ):
							screen.addUnitGraphicGFC( "InterfaceUnitModel", CyInterface().getOrderNodeData1(i), 175, yResolution - 138, 123, 132, WidgetTypes.WIDGET_HELP_SELECTED, 0, -1,  -20, 30, 1, False )
							bHandled = True
						elif ( eOrderNodeType == OrderTypes.ORDER_CONSTRUCT ):
							screen.addBuildingGraphicGFC( "InterfaceUnitModel", CyInterface().getOrderNodeData1(i), 175, yResolution - 138, 123, 132, WidgetTypes.WIDGET_HELP_SELECTED, 0, -1,  -20, 30, 0.8, False )
							bHandled = True
						elif ( eOrderNodeType == OrderTypes.ORDER_CREATE ):
							if(gc.getProjectInfo(CyInterface().getOrderNodeData1(i)).isSpaceship()):
								modelType = 0
								screen.addSpaceShipWidgetGFC("InterfaceUnitModel", 175, yResolution - 138, 123, 132, CyInterface().getOrderNodeData1(i), modelType, WidgetTypes.WIDGET_HELP_SELECTED, 0, -1)
							else:
								screen.hide( "InterfaceUnitModel" )
							bHandled = True
						elif ( eOrderNodeType == OrderTypes.ORDER_MAINTAIN ):
							screen.hide( "InterfaceUnitModel" )
							bHandled = True
													
				if ( not bHandled ):
					screen.hide( "InterfaceUnitModel" )
					bHandled = True

				screen.moveToFront("SelectedCityText")

			elif ( CyInterface().getHeadSelectedUnit() ):
				screen.addSpecificUnitGraphicGFC( "InterfaceUnitModel", CyInterface().getHeadSelectedUnit(), 175, yResolution - 138, 123, 132, WidgetTypes.WIDGET_UNIT_MODEL, CyInterface().getHeadSelectedUnit().getUnitType(), -1,  -20, 30, 1, False )
				screen.moveToFront("SelectedUnitText")
			else:
				screen.hide( "InterfaceUnitModel" )
		else:
			screen.hide( "InterfaceUnitModel" )
			
		pPlot = CyInterface().getSelectionPlot()

		for i in range(gc.getNumPromotionInfos()):
			szName = "PromotionButton" + str(i)
			screen.moveToFront( szName )
		
		screen.hide( "PlotListMinus" )
		screen.hide( "PlotListPlus" )
		
		for j in range(gc.getMAX_PLOT_LIST_ROWS()):
			#szStringPanel = "PlotListPanel" + str(j)
			#screen.hide(szStringPanel)
			
			for i in range(self.numPlotListButtons()):
				szString = "PlotListButton" + str(j*self.numPlotListButtons()+i)
				screen.hide( szString )
				
				szStringHealth = szString + "Health"
				screen.hide( szStringHealth )

				szStringIcon = szString + "Icon"
				screen.hide( szStringIcon )

		if ( pPlot and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyEngine().isGlobeviewUp() == False):

			iVisibleUnits = CyInterface().getNumVisibleUnits()
			iCount = -(CyInterface().getPlotListColumn())
				

			bLeftArrow = False
			bRightArrow = False
			
			if (CyInterface().isCityScreenUp()):
				iMaxRows = 1
				iSkipped = (gc.getMAX_PLOT_LIST_ROWS() - 1) * self.numPlotListButtons()
				iCount += iSkipped
			else:
				iMaxRows = gc.getMAX_PLOT_LIST_ROWS()
				iCount += CyInterface().getPlotListOffset()
				iSkipped = 0

			CyInterface().cacheInterfacePlotUnits(pPlot)
			for i in range(CyInterface().getNumCachedInterfacePlotUnits()):
				pLoopUnit = CyInterface().getCachedInterfacePlotUnit(i)
				if (pLoopUnit):

					if ((iCount == 0) and (CyInterface().getPlotListColumn() > 0)):
						bLeftArrow = True
					elif ((iCount == (gc.getMAX_PLOT_LIST_ROWS() * self.numPlotListButtons() - 1)) and ((iVisibleUnits - iCount - CyInterface().getPlotListColumn() + iSkipped) > 1)):
						bRightArrow = True
						
					if ((iCount >= 0) and (iCount <  self.numPlotListButtons() * gc.getMAX_PLOT_LIST_ROWS())):
						if ((pLoopUnit.getTeam() != gc.getGame().getActiveTeam()) or pLoopUnit.isWaiting()):
							szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_FORTIFY").getPath()
							
						elif (pLoopUnit.canMove()):
							if (pLoopUnit.hasMoved()):
								szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_HASMOVED").getPath()
							else:
								szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_MOVE").getPath()
						else:
							szFileName = ArtFileMgr.getInterfaceArtInfo("OVERLAY_NOMOVE").getPath()

						szString = "PlotListButton" + str(iCount)
						screen.changeImageButton( szString, pLoopUnit.getButton() )
						if ( pLoopUnit.getOwner() == gc.getGame().getActivePlayer() ):
							bEnable = True
						else:
							bEnable = False
						screen.enable(szString, bEnable)

						if (pLoopUnit.IsSelected()):
							screen.setState(szString, True)
						else:
							screen.setState(szString, False)
						screen.show( szString )
						
						# place the health bar
						if (pLoopUnit.isFighting()):
							bShowHealth = False
						elif (pLoopUnit.getDomainType() == DomainTypes.DOMAIN_AIR):
							bShowHealth = pLoopUnit.canAirAttack()
						else:
							bShowHealth = pLoopUnit.canFight()
						
						if bShowHealth:
							szStringHealth = szString + "Health"
							screen.setBarPercentage( szStringHealth, InfoBarTypes.INFOBAR_STORED, float( pLoopUnit.currHitPoints() ) / float( pLoopUnit.maxHitPoints() ) )
							if (pLoopUnit.getDamage() >= ((pLoopUnit.maxHitPoints() * 2) / 3)):
								screen.setStackedBarColors(szStringHealth, InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_RED"))
							elif (pLoopUnit.getDamage() >= (pLoopUnit.maxHitPoints() / 3)):
								screen.setStackedBarColors(szStringHealth, InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_YELLOW"))
							else:
								screen.setStackedBarColors(szStringHealth, InfoBarTypes.INFOBAR_STORED, gc.getInfoTypeForString("COLOR_GREEN"))
							screen.show( szStringHealth )
						
						# Adds the overlay first
						szStringIcon = szString + "Icon"
						screen.changeDDSGFC( szStringIcon, szFileName )
						screen.show( szStringIcon )

					iCount = iCount + 1

			if (iVisibleUnits > self.numPlotListButtons() * iMaxRows):
				screen.enable("PlotListMinus", bLeftArrow)
				screen.show( "PlotListMinus" )
	
				screen.enable("PlotListPlus", bRightArrow)
				screen.show( "PlotListPlus" )

		return 0
		
	# This will update the flag widget for SP hotseat and dbeugging
	def updateFlag( self ):

		if ( CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_ADVANCED_START ):
			screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
			xResolution = screen.getXResolution()
			yResolution = screen.getYResolution()
#----------Dimon157 Best Cities 4/4 0
			if (g_bThreeBestCities):
				global hammerNo1Count
				global hammerNo1CityName
				global hammerNo2Count
				global hammerNo2CityName
				global hammerNo3Count
				global hammerNo3CityName
				global scienceNo1Count
				global scienceNo1CityName
				global scienceNo2Count
				global scienceNo2CityName
				global scienceNo3Count
				global scienceNo3CityName
				global goldNo1Count
				global goldNo1CityName
				global goldNo2Count
				global goldNo2CityName
				global goldNo3Count
				global goldNo3CityName
				global espionageNo1Count
				global espionageNo1CityName
				global espionageNo2Count
				global espionageNo2CityName
				global espionageNo3Count
				global espionageNo3CityName
				hammerNo1Count=0
				hammerNo1CityName=""
				hammerNo2Count=0
				hammerNo2CityName=""
				hammerNo3Count=0
				hammerNo3CityName=""
				scienceNo1Count=0
				scienceNo1CityName=""
				scienceNo2Count=0
				scienceNo2CityName=""
				scienceNo3Count=0
				scienceNo3CityName=""
				goldNo1Count=0
				goldNo1CityName=""
				goldNo2Count=0
				goldNo2CityName=""
				goldNo3Count=0
				goldNo3CityName=""
				espionageNo1Count=0
				espionageNo1CityName=""
				espionageNo2Count=0
				espionageNo2CityName=""
				espionageNo3Count=0
				espionageNo3CityName=""
				
				player = gc.getPlayer(CyGame().getActivePlayer())
				(pLoopCity, iter) = player.firstCity(false)
				while(pLoopCity):
					# hummers
					if (pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION) >= hammerNo1Count):
						hammerNo3Count = hammerNo2Count
						hammerNo3CityName = hammerNo2CityName
						hammerNo2Count = hammerNo1Count
						hammerNo2CityName = hammerNo1CityName
						hammerNo1Count = pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION)
						hammerNo1CityName = pLoopCity.getName()
					elif ((pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION) < hammerNo1Count) and (pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION) >= hammerNo2Count)):
						hammerNo3Count = hammerNo2Count
						hammerNo3CityName = hammerNo2CityName
						hammerNo2Count = pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION)
						hammerNo2CityName = pLoopCity.getName()
					elif ((pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION) < hammerNo2Count) and (pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION) >= hammerNo3Count)):
						hammerNo3Count = pLoopCity.getYieldRate(YieldTypes.YIELD_PRODUCTION)
						hammerNo3CityName = pLoopCity.getName()
						
					# science
					if (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH) >= scienceNo1Count):
						scienceNo3Count = scienceNo2Count
						scienceNo3CityName = scienceNo2CityName
						scienceNo2Count = scienceNo1Count
						scienceNo2CityName = scienceNo1CityName
						scienceNo1Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH)
						scienceNo1CityName = pLoopCity.getName()
					elif ((pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH) < scienceNo1Count) and (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH) >= scienceNo2Count)):
						scienceNo3Count = scienceNo2Count
						scienceNo3CityName = scienceNo2CityName
						scienceNo2Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH)
						scienceNo2CityName = pLoopCity.getName()
					elif ((pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH) < scienceNo2Count) and (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH) >= scienceNo3Count)):
						scienceNo3Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH)
						scienceNo3CityName = pLoopCity.getName()
						
					# gold
					if (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD) >= goldNo1Count):
						goldNo3Count = goldNo2Count
						goldNo3CityName = goldNo2CityName
						goldNo2Count = goldNo1Count
						goldNo2CityName = goldNo1CityName
						goldNo1Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD)
						goldNo1CityName = pLoopCity.getName()
					elif ((pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD) < goldNo1Count) and (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD) >= goldNo2Count)):
						goldNo3Count = goldNo2Count
						goldNo3CityName = goldNo2CityName
						goldNo2Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD)
						goldNo2CityName = pLoopCity.getName()
					elif ((pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD) < goldNo2Count) and (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD) >= goldNo3Count)):
						goldNo3Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_GOLD)
						goldNo3CityName = pLoopCity.getName()
						
					# espionage
					if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_ESPIONAGE):
						if (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE) >= espionageNo1Count):
							espionageNo3Count = espionageNo2Count
							espionageNo3CityName = espionageNo2CityName
							espionageNo2Count = espionageNo1Count
							espionageNo2CityName = espionageNo1CityName
							espionageNo1Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE)
							espionageNo1CityName = pLoopCity.getName()
						elif ((pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE) < espionageNo1Count) and (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE) >= espionageNo2Count)):
							espionageNo3Count = espionageNo2Count
							espionageNo3CityName = espionageNo2CityName
							espionageNo2Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE)
							espionageNo2CityName = pLoopCity.getName()
						elif ((pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE) < espionageNo2Count) and (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE) >= espionageNo3Count)):
							espionageNo3Count = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_ESPIONAGE)
							espionageNo3CityName = pLoopCity.getName()
					(pLoopCity, iter) = player.nextCity(iter, false)
					
					
				eHammerButton = u"<font=2>%c</font>" % gc.getYieldInfo(YieldTypes.YIELD_PRODUCTION).getChar()
				eHammerNo1Text = hammerNo1CityName[:4] + ": " + unicode(hammerNo1Count)
				eHammerNo2Text = hammerNo2CityName[:4] + ": " + unicode(hammerNo2Count)
				eHammerNo3Text = hammerNo3CityName[:4] + ": " + unicode(hammerNo3Count)
				eScienceButton = u"<font=2>%c</font>" % gc.getCommerceInfo(CommerceTypes.COMMERCE_RESEARCH).getChar()
				eScienceNo1Text = scienceNo1CityName[:4] + ": " + unicode(scienceNo1Count)
				eScienceNo2Text = scienceNo2CityName[:4] + ": " + unicode(scienceNo2Count)
				eScienceNo3Text = scienceNo3CityName[:4] + ": " + unicode(scienceNo3Count)
				eGoldButton = u"<font=2>%c</font>" % gc.getCommerceInfo(CommerceTypes.COMMERCE_GOLD).getChar()
				eGoldNo1Text = goldNo1CityName[:4] + ": " + unicode(goldNo1Count)
				eGoldNo2Text = goldNo2CityName[:4] + ": " + unicode(goldNo2Count)
				eGoldNo3Text = goldNo3CityName[:4] + ": " + unicode(goldNo3Count)
				if gc.getGame().isOption(GameOptionTypes.GAMEOPTION_NO_ESPIONAGE):
					eEspionageButton = u"<font=2>%c</font>" % gc.getCommerceInfo(CommerceTypes.COMMERCE_ESPIONAGE).getChar()
					eEspionageNo1Text = espionageNo1CityName[:4] + ": " + unicode(espionageNo1Count)
					eEspionageNo2Text = espionageNo2CityName[:4] + ": " + unicode(espionageNo2Count)
					eEspionageNo3Text = espionageNo3CityName[:4] + ": " + unicode(espionageNo3Count)
				
				screen.setLabel( "HammerNo1Button", "Background", eHammerButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 145, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "HammerNo1Text", "Background", eHammerNo1Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 145, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "HammerNo2Button", "Background", eHammerButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 132, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "HammerNo2Text", "Background", eHammerNo2Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 132, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "HammerNo3Button", "Background", eHammerButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 119, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "HammerNo3Text", "Background", eHammerNo3Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 119, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "ScienceNo1Button", "Background", eScienceButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 102, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "ScienceNo1Text", "Background", eScienceNo1Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 102, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "ScienceNo2Button", "Background", eScienceButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 89, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "ScienceNo2Text", "Background", eScienceNo2Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 89, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "ScienceNo3Button", "Background", eScienceButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 76, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "ScienceNo3Text", "Background", eScienceNo3Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 76, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "GoldNo1Button", "Background", eGoldButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 59, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "GoldNo1Text", "Background", eGoldNo1Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 59, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "GoldNo2Button", "Background", eGoldButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 46, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "GoldNo2Text", "Background", eGoldNo2Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 46, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "GoldNo3Button", "Background", eGoldButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 33, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "GoldNo3Text", "Background", eGoldNo3Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 33, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "EspionageNo1Button", "Background", eEspionageButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 210, yResolution - 16, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setLabel( "EspionageNo1Text", "Background", eEspionageNo1Text, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 288, yResolution - 16, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )

				screen.hide( "HammerNo1Button" )
				screen.hide( "HammerNo1Text" )
				screen.hide( "HammerNo2Button" )
				screen.hide( "HammerNo2Text" )
				screen.hide( "HammerNo3Button" )
				screen.hide( "HammerNo3Text" )
				screen.hide( "ScienceNo1Button" )
				screen.hide( "ScienceNo1Text" )
				screen.hide( "ScienceNo2Button" )
				screen.hide( "ScienceNo2Text" )
				screen.hide( "ScienceNo3Button" )
				screen.hide( "ScienceNo3Text" )
				screen.hide( "GoldNo1Button" )
				screen.hide( "GoldNo1Text" )
				screen.hide( "GoldNo2Button" )
				screen.hide( "GoldNo2Text" )
				screen.hide( "GoldNo3Button" )
				screen.hide( "GoldNo3Text" )
				screen.hide( "EspionageNo1Button" )
				screen.hide( "EspionageNo1Text" )

			else:
				screen.addFlagWidgetGFC( "CivilizationFlag", xResolution - 288, yResolution - 138, 68, 250, gc.getGame().getActivePlayer(), WidgetTypes.WIDGET_FLAG, gc.getGame().getActivePlayer(), -1)
#----------Dimon157 Best Cities 4/4 X
		
	# Will hide and show the selection buttons and their associated buttons
	def updateSelectionButtons( self ):
	
		global SELECTION_BUTTON_COLUMNS
		global MAX_SELECTION_BUTTONS
		global g_pSelectedUnit

		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		
		pHeadSelectedCity = CyInterface().getHeadSelectedCity()
		pHeadSelectedUnit = CyInterface().getHeadSelectedUnit()
		
		global g_NumEmphasizeInfos
		global g_NumCityTabTypes
		global g_NumHurryInfos
		global g_NumUnitClassInfos
		global g_NumBuildingClassInfos
		global g_NumProjectInfos
		global g_NumProcessInfos
		global g_NumActionInfos
		
		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		screen.addMultiListControlGFC( "BottomButtonContainer", u"", iMultiListXL, yResolution - 113, xResolution - (iMultiListXL+iMultiListXR), 100, 4, 48, 48, TableStyles.TABLE_STYLE_STANDARD )
		screen.clearMultiList( "BottomButtonContainer" )
		screen.hide( "BottomButtonContainer" )
		
		# All of the hides...	
		self.setMinimapButtonVisibility(False)

		screen.hideList( 0 )

		for i in range (g_NumEmphasizeInfos):
			szButtonID = "Emphasize" + str(i)
			screen.hide( szButtonID )

		# Hurry button show...
		for i in range( g_NumHurryInfos ):
			szButtonID = "Hurry" + str(i)
			screen.hide( szButtonID )

		# Conscript Button Show
		screen.hide( "Conscript" )
		#screen.hide( "Liberate" )
		screen.hide( "AutomateProduction" )
		screen.hide( "AutomateCitizens" )

		if (not CyEngine().isGlobeviewUp() and pHeadSelectedCity):
		
			self.setMinimapButtonVisibility(True)

			if ((pHeadSelectedCity.getOwner() == gc.getGame().getActivePlayer()) or gc.getGame().isDebugMode()):
			
				iBtnX = xResolution - 284
				iBtnY = yResolution - 177
				iBtnW = 64
				iBtnH = 30

				# Liberate button
				#szText = "<font=1>" + localText.getText("TXT_KEY_LIBERATE_CITY", ()) + "</font>"
				#screen.setButtonGFC( "Liberate", szText, "", iBtnX, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_LIBERATE_CITY, -1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
				#screen.setStyle( "Liberate", "Button_CityT1_Style" )
				#screen.hide( "Liberate" )

				iBtnSX = xResolution - 284
				
				iBtnX = iBtnSX
				iBtnY = yResolution - 140
				iBtnW = 64
				iBtnH = 30

				# Conscript button
				szText = "<font=1>" + localText.getText("TXT_KEY_DRAFT", ()) + "</font>"
				screen.setButtonGFC( "Conscript", szText, "", iBtnX, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_CONSCRIPT, -1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
				screen.setStyle( "Conscript", "Button_CityT1_Style" )
				screen.hide( "Conscript" )

				iBtnY += iBtnH
				iBtnW = 32
				iBtnH = 28
				
				# Hurry Buttons		
				screen.setButtonGFC( "Hurry0", "", "", iBtnX, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_HURRY, 0, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
				screen.setStyle( "Hurry0", "Button_CityC1_Style" )
				screen.hide( "Hurry0" )

				iBtnX += iBtnW

				screen.setButtonGFC( "Hurry1", "", "", iBtnX, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_HURRY, 1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
				screen.setStyle( "Hurry1", "Button_CityC2_Style" )
				screen.hide( "Hurry1" )
			
				iBtnX = iBtnSX
				iBtnY += iBtnH
			
				# Automate Production Button
				screen.addCheckBoxGFC( "AutomateProduction", "", "", iBtnX, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_AUTOMATE_PRODUCTION, -1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
				screen.setStyle( "AutomateProduction", "Button_CityC3_Style" )

				iBtnX += iBtnW

				# Automate Citizens Button
				screen.addCheckBoxGFC( "AutomateCitizens", "", "", iBtnX, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_AUTOMATE_CITIZENS, -1, -1, ButtonStyles.BUTTON_STYLE_STANDARD )
				screen.setStyle( "AutomateCitizens", "Button_CityC4_Style" )

				iBtnY += iBtnH
				iBtnX = iBtnSX

				iBtnW	= 22
				iBtnWa	= 20
				iBtnH	= 24
				iBtnHa	= 27
			
				# Set Emphasize buttons
				i = 0
				szButtonID = "Emphasize" + str(i)
				screen.addCheckBoxGFC( szButtonID, "", "", iBtnX, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_EMPHASIZE, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
				szStyle = "Button_CityB" + str(i+1) + "_Style"
				screen.setStyle( szButtonID, szStyle )
				screen.hide( szButtonID )

				i+=1
				szButtonID = "Emphasize" + str(i)
				screen.addCheckBoxGFC( szButtonID, "", "", iBtnX+iBtnW, iBtnY, iBtnWa, iBtnH, WidgetTypes.WIDGET_EMPHASIZE, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
				szStyle = "Button_CityB" + str(i+1) + "_Style"
				screen.setStyle( szButtonID, szStyle )
				screen.hide( szButtonID )

				i+=1
				szButtonID = "Emphasize" + str(i)
				screen.addCheckBoxGFC( szButtonID, "", "", iBtnX+iBtnW+iBtnWa, iBtnY, iBtnW, iBtnH, WidgetTypes.WIDGET_EMPHASIZE, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
				szStyle = "Button_CityB" + str(i+1) + "_Style"
				screen.setStyle( szButtonID, szStyle )
				screen.hide( szButtonID )

				iBtnY += iBtnH
				
				i+=1
				szButtonID = "Emphasize" + str(i)
				screen.addCheckBoxGFC( szButtonID, "", "", iBtnX, iBtnY, iBtnW, iBtnHa, WidgetTypes.WIDGET_EMPHASIZE, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
				szStyle = "Button_CityB" + str(i+1) + "_Style"
				screen.setStyle( szButtonID, szStyle )
				screen.hide( szButtonID )

				i+=1
				szButtonID = "Emphasize" + str(i)
				screen.addCheckBoxGFC( szButtonID, "", "", iBtnX+iBtnW, iBtnY, iBtnWa, iBtnHa, WidgetTypes.WIDGET_EMPHASIZE, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
				szStyle = "Button_CityB" + str(i+1) + "_Style"
				screen.setStyle( szButtonID, szStyle )
				screen.hide( szButtonID )

				i+=1
				szButtonID = "Emphasize" + str(i)
				screen.addCheckBoxGFC( szButtonID, "", "", iBtnX+iBtnW+iBtnWa, iBtnY, iBtnW, iBtnHa, WidgetTypes.WIDGET_EMPHASIZE, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
				szStyle = "Button_CityB" + str(i+1) + "_Style"
				screen.setStyle( szButtonID, szStyle )
				screen.hide( szButtonID )
				
				g_pSelectedUnit = 0
				screen.setState( "AutomateCitizens", pHeadSelectedCity.isCitizensAutomated() )
				screen.setState( "AutomateProduction", pHeadSelectedCity.isProductionAutomated() )
				
				for i in range (g_NumEmphasizeInfos):
					szButtonID = "Emphasize" + str(i)
					screen.show( szButtonID )
					if ( pHeadSelectedCity.AI_isEmphasize(i) ):
						screen.setState( szButtonID, True )
					else:
						screen.setState( szButtonID, False )

				# City Tabs
				for i in range( g_NumCityTabTypes ):
					szButtonID = "CityTab" + str(i)
					screen.show( szButtonID )

				# Hurry button show...
				for i in range( g_NumHurryInfos ):
					szButtonID = "Hurry" + str(i)
					screen.show( szButtonID )
					screen.enable( szButtonID, pHeadSelectedCity.canHurry(i, False) )

				# Conscript Button Show
				screen.show( "Conscript" )
				if (pHeadSelectedCity.canConscript()):
					screen.enable( "Conscript", True )
				else:
					screen.enable( "Conscript", False )

				# Liberate Button Show
				#screen.show( "Liberate" )
				#if (-1 != pHeadSelectedCity.getLiberationPlayer()):
				#	screen.enable( "Liberate", True )
				#else:
				#	screen.enable( "Liberate", False )

				iCount = 0
				iRow = 0
				bFound = False

				# Units to construct
				for i in range ( g_NumUnitClassInfos ):
					eLoopUnit = gc.getCivilizationInfo(pHeadSelectedCity.getCivilizationType()).getCivilizationUnits(i)

					if (pHeadSelectedCity.canTrain(eLoopUnit, False, True)):
						szButton = gc.getPlayer(pHeadSelectedCity.getOwner()).getUnitButton(eLoopUnit)
						screen.appendMultiListButton( "BottomButtonContainer", szButton, iRow, WidgetTypes.WIDGET_TRAIN, i, -1, False )
						screen.show( "BottomButtonContainer" )
						
						if ( not pHeadSelectedCity.canTrain(eLoopUnit, False, False) ):
							screen.disableMultiListButton( "BottomButtonContainer", iRow, iCount, szButton)
						
						iCount = iCount + 1
						bFound = True

				iCount = 0
				if (bFound):
					iRow = iRow + 1
				bFound = False

				# Buildings to construct
				for i in range ( g_NumBuildingClassInfos ):
					if (not isLimitedWonderClass(i)):
						eLoopBuilding = gc.getCivilizationInfo(pHeadSelectedCity.getCivilizationType()).getCivilizationBuildings(i)

						if (pHeadSelectedCity.canConstruct(eLoopBuilding, False, True, False)):
							screen.appendMultiListButton( "BottomButtonContainer", gc.getBuildingInfo(eLoopBuilding).getButton(), iRow, WidgetTypes.WIDGET_CONSTRUCT, i, -1, False )
							screen.show( "BottomButtonContainer" )
							
							if ( not pHeadSelectedCity.canConstruct(eLoopBuilding, False, False, False) ):
								screen.disableMultiListButton( "BottomButtonContainer", iRow, iCount, gc.getBuildingInfo(eLoopBuilding).getButton() )

							iCount = iCount + 1
							bFound = True

				iCount = 0
				if (bFound):
					iRow = iRow + 1
				bFound = False

				# Wonders to construct
				i = 0
				for i in range( g_NumBuildingClassInfos ):
					if (isLimitedWonderClass(i)):
						eLoopBuilding = gc.getCivilizationInfo(pHeadSelectedCity.getCivilizationType()).getCivilizationBuildings(i)

						if (pHeadSelectedCity.canConstruct(eLoopBuilding, False, True, False)):
							screen.appendMultiListButton( "BottomButtonContainer", gc.getBuildingInfo(eLoopBuilding).getButton(), iRow, WidgetTypes.WIDGET_CONSTRUCT, i, -1, False )
							screen.show( "BottomButtonContainer" )
							
							if ( not pHeadSelectedCity.canConstruct(eLoopBuilding, False, False, False) ):
								screen.disableMultiListButton( "BottomButtonContainer", iRow, iCount, gc.getBuildingInfo(eLoopBuilding).getButton() )

							iCount = iCount + 1
							bFound = True

				iCount = 0
				if (bFound):
					iRow = iRow + 1
				bFound = False

				# Projects
				i = 0
				for i in range( g_NumProjectInfos ):
					if (pHeadSelectedCity.canCreate(i, False, True)):
						screen.appendMultiListButton( "BottomButtonContainer", gc.getProjectInfo(i).getButton(), iRow, WidgetTypes.WIDGET_CREATE, i, -1, False )
						screen.show( "BottomButtonContainer" )
						
						if ( not pHeadSelectedCity.canCreate(i, False, False) ):
							screen.disableMultiListButton( "BottomButtonContainer", iRow, iCount, gc.getProjectInfo(i).getButton() )
						
						iCount = iCount + 1
						bFound = True

				# Processes
				i = 0
				for i in range( g_NumProcessInfos ):
					if (pHeadSelectedCity.canMaintain(i, False)):
						screen.appendMultiListButton( "BottomButtonContainer", gc.getProcessInfo(i).getButton(), iRow, WidgetTypes.WIDGET_MAINTAIN, i, -1, False )
						screen.show( "BottomButtonContainer" )
						
						iCount = iCount + 1
						bFound = True

				screen.selectMultiList( "BottomButtonContainer", CyInterface().getCityTabSelectionRow() )
							
		elif (not CyEngine().isGlobeviewUp() and pHeadSelectedUnit and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY):

			self.setMinimapButtonVisibility(True)

			if (CyInterface().getInterfaceMode() == InterfaceModeTypes.INTERFACEMODE_SELECTION):
			
				if ( pHeadSelectedUnit.getOwner() == gc.getGame().getActivePlayer() and g_pSelectedUnit != pHeadSelectedUnit ):
				
					g_pSelectedUnit = pHeadSelectedUnit
					
					iCount = 0

					actions = CyInterface().getActionsToShow()
					for i in actions:
						screen.appendMultiListButton( "BottomButtonContainer", gc.getActionInfo(i).getButton(), 0, WidgetTypes.WIDGET_ACTION, i, -1, False )
						screen.show( "BottomButtonContainer" )
				
						if ( not CyInterface().canHandleAction(i, False) ):
							screen.disableMultiListButton( "BottomButtonContainer", 0, iCount, gc.getActionInfo(i).getButton() )
							
						if ( pHeadSelectedUnit.isActionRecommended(i) ):#or gc.getActionInfo(i).getCommandType() == CommandTypes.COMMAND_PROMOTION ):
							screen.enableMultiListPulse( "BottomButtonContainer", True, 0, iCount )
						else:
							screen.enableMultiListPulse( "BottomButtonContainer", False, 0, iCount )

						iCount = iCount + 1

					if (CyInterface().canCreateGroup()):
						screen.appendMultiListButton( "BottomButtonContainer", ArtFileMgr.getInterfaceArtInfo("INTERFACE_BUTTONS_CREATEGROUP").getPath(), 0, WidgetTypes.WIDGET_CREATE_GROUP, -1, -1, False )
						screen.show( "BottomButtonContainer" )
						
						iCount = iCount + 1

					if (CyInterface().canDeleteGroup()):
						screen.appendMultiListButton( "BottomButtonContainer", ArtFileMgr.getInterfaceArtInfo("INTERFACE_BUTTONS_SPLITGROUP").getPath(), 0, WidgetTypes.WIDGET_DELETE_GROUP, -1, -1, False )
						screen.show( "BottomButtonContainer" )
						
						iCount = iCount + 1

					# Inquisition Mod
					###### Unit Buttons ######
					pUnit = g_pSelectedUnit
					iUnitType = pUnit.getUnitType()
					pUnitOwner = gc.getPlayer( pUnit.getOwner( ))
					
					if pUnitOwner.isTurnActive( ):						
						# Inquisitor
						if iUnitType == CvUtil.findInfoTypeNum(gc.getUnitInfo, gc.getNumUnitInfos(), "UNIT_INQUISITOR") and gc.getMap().plot( g_pSelectedUnit.getX(), g_pSelectedUnit.getY() ).isCity():
							pCity = gc.getMap().plot( g_pSelectedUnit.getX(), g_pSelectedUnit.getY() ).getPlotCity( )
							pCityPlayer = gc.getPlayer( pCity.getOwner( ) )
							ProceedWithInquisition = False
							if ( pCity.getOwner( ) == pUnit.getOwner( ) ) or ( gc.getTeam( pCityPlayer.getTeam( ) ).isVassal( gc.getPlayer( pUnit. getOwner( ) ).getTeam( ) ) ): 
								ProceedWithInquisition = True
							elif CvUtil.isOC_FOREIGN_INQUISITIONS():
								#Foriegn Inquisition Check
								if ( pCity.getOwner( ) != pUnit.getOwner( ) ):
									iPlayerA = pUnit.getOwner( )
									iPlayerB = pCity.getOwner( )
									if CvUtil.hasOpenBordersAgreement(iPlayerA, iPlayerB):
										if CvUtil.hasMatchingStateReligion(iPlayerA, iPlayerB):
											ProceedWithInquisition = True
										
							if ProceedWithInquisition:
								iStateReligion = gc.getPlayer( pUnit.getOwner( ) ).getStateReligion( )
								if iStateReligion != -1:
									if pCity.isHasReligion( iStateReligion ):
										for iReligionLoop in range(gc.getNumReligionInfos( )):
											if pCity.isHasReligion( iReligionLoop ):
												if iReligionLoop != iStateReligion:
													screen.appendMultiListButton( "BottomButtonContainer", ArtFileMgr.getInterfaceArtInfo("INTERFACE_GODS_PERSICUTION").getPath(), 0, WidgetTypes.WIDGET_GENERAL, 665, 665, False )
													screen.show( "BottomButtonContainer" )
													iCount = iCount + 1
													return
					# Inquisition Mod

		elif (CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY):
		
			self.setMinimapButtonVisibility(True)

		return 0
		
	# Will update the research buttons
	def updateResearchButtons( self ):
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		for i in range( gc.getNumTechInfos() ):
			szName = "ResearchButton" + str(i)
			screen.hide( szName )

		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		#screen.hide( "InterfaceOrnamentLeftLow" )
		#screen.hide( "InterfaceOrnamentRightLow" )
			
		for i in range(gc.getNumReligionInfos()):
			szName = "ReligionButton" + str(i)
			screen.hide( szName )

		i = 0
		if ( CyInterface().shouldShowResearchButtons() and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
			iCount = 0
			
			for i in range( gc.getNumTechInfos() ):
				if (gc.getActivePlayer().canResearch(i, False)):
					if (iCount < 20):
						szName = "ResearchButton" + str(i)

						bDone = False
						for j in range( gc.getNumReligionInfos() ):
							if ( not bDone ):
								if (gc.getReligionInfo(j).getTechPrereq() == i):
									if not (gc.getGame().isReligionSlotTaken(j)):
										szName = "ReligionButton" + str(j)
										bDone = True

						screen.show( szName )
						self.setResearchButtonPosition(szName, iCount)

					iCount = iCount + 1
					
		return 0
		
	# Will update the citizen buttons
	def updateCitizenButtons( self ):
	
		global MAX_CITIZEN_BUTTONS
		
		bHandled = False
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		for i in range( MAX_CITIZEN_BUTTONS ):
			szName = "FreeSpecialist" + str(i)
			screen.hide( szName )
			szName = "AngryCitizen" + str(i)
			screen.hide( szName )
			
		for i in range( gc.getNumSpecialistInfos() ):
			szName = "IncreaseSpecialist" + str(i)
			screen.hide( szName )
			szName = "DecreaseSpecialist" + str(i)
			screen.hide( szName )
			szName = "CitizenDisabledButton" + str(i)
			screen.hide( szName )
			for j in range(MAX_CITIZEN_BUTTONS):
				szName = "CitizenButton" + str((i * 100) + j)
				screen.hide( szName )
				szName = "CitizenButtonHighlight" + str((i * 100) + j)
				screen.hide( szName )

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()

		if ( CyInterface().isCityScreenUp() ):
			if (pHeadSelectedCity and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW):
				if ( pHeadSelectedCity.angryPopulation(0) < MAX_CITIZEN_BUTTONS ):
					iCount = pHeadSelectedCity.angryPopulation(0)
				else:
					iCount = MAX_CITIZEN_BUTTONS

				for i in range(iCount):
					bHandled = True
					szName = "AngryCitizen" + str(i)
					screen.show( szName )

				iFreeSpecialistCount = 0
				for i in range(gc.getNumSpecialistInfos()):
					iFreeSpecialistCount += pHeadSelectedCity.getFreeSpecialistCount(i)

				iCount = 0

				bHandled = False
				
				if (iFreeSpecialistCount > MAX_CITIZEN_BUTTONS):
					for i in range(gc.getNumSpecialistInfos()):
						if (pHeadSelectedCity.getFreeSpecialistCount(i) > 0):
							if (iCount < MAX_CITIZEN_BUTTONS):
								szName = "FreeSpecialist" + str(iCount)
								screen.setImageButton( szName, gc.getSpecialistInfo(i).getTexture(), (xResolution - 74  - (26 * iCount)), yResolution - 206, 24, 24, WidgetTypes.WIDGET_FREE_CITIZEN, i, 1 )
								screen.show( szName )
								bHandled = true
							iCount += 1
							
				else:				
					for i in range(gc.getNumSpecialistInfos()):
						for j in range( pHeadSelectedCity.getFreeSpecialistCount(i) ):
							if (iCount < MAX_CITIZEN_BUTTONS):
								szName = "FreeSpecialist" + str(iCount)
								screen.setImageButton( szName, gc.getSpecialistInfo(i).getTexture(), (xResolution - 74  - (26 * iCount)), yResolution - 206, 24, 24, WidgetTypes.WIDGET_FREE_CITIZEN, i, -1 )
								screen.show( szName )
								bHandled = true

							iCount = iCount + 1

				for i in range( gc.getNumSpecialistInfos() ):
				
					bHandled = False

					if (pHeadSelectedCity.getOwner() == gc.getGame().getActivePlayer() or gc.getGame().isDebugMode()):
					
						if (pHeadSelectedCity.isCitizensAutomated()):
							iSpecialistCount = max(pHeadSelectedCity.getSpecialistCount(i), pHeadSelectedCity.getForceSpecialistCount(i))
						else:
							iSpecialistCount = pHeadSelectedCity.getSpecialistCount(i)
					
						if (pHeadSelectedCity.isSpecialistValid(i, 1) and (pHeadSelectedCity.isCitizensAutomated() or iSpecialistCount < (pHeadSelectedCity.getPopulation() + pHeadSelectedCity.totalFreeSpecialists()))):
							szName = "IncreaseSpecialist" + str(i)
							screen.show( szName )
							szName = "CitizenDisabledButton" + str(i)
							screen.show( szName )

						if iSpecialistCount > 0:
							szName = "CitizenDisabledButton" + str(i)
							screen.hide( szName )
							szName = "DecreaseSpecialist" + str(i)
							screen.show( szName )
							
					if (pHeadSelectedCity.getSpecialistCount(i) < MAX_CITIZEN_BUTTONS):
						iCount = pHeadSelectedCity.getSpecialistCount(i)
					else:
						iCount = MAX_CITIZEN_BUTTONS

					j = 0
					for j in range( iCount ):
						bHandled = True
						szName = "CitizenButton" + str((i * 100) + j)
						screen.addCheckBoxGFC( szName, gc.getSpecialistInfo(i).getTexture(), "", xResolution - 74 - (26 * j), (yResolution - 272 - (26 * i)), 24, 24, WidgetTypes.WIDGET_CITIZEN, i, j, ButtonStyles.BUTTON_STYLE_LABEL )
						screen.show( szName )
						szName = "CitizenButtonHighlight" + str((i * 100) + j)
						screen.addDDSGFC( szName, ArtFileMgr.getInterfaceArtInfo("BUTTON_HILITE_SQUARE").getPath(), xResolution - 74 - (26 * j), (yResolution - 272 - (26 * i)), 24, 24, WidgetTypes.WIDGET_CITIZEN, i, j )
						if ( pHeadSelectedCity.getForceSpecialistCount(i) > j ):
							screen.show( szName )
						else:
							screen.hide( szName )
						
					if ( not bHandled ):
						szName = "CitizenDisabledButton" + str(i)
						screen.show( szName )

		return 0
			
	# Will update the game data strings
	def updateGameDataStrings( self ):
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		screen.hide( "ResearchText" )
		screen.hide( "GoldText" )
		screen.hide( "TimeText" )

#----------MSM===Show Era===1/2===0===
		screen.hide( "EraText" )
#----------MSM===Show Era===1/2===X===
#----------Dimon157 Happy and health 1/2 0
		screen.hide( "HappyAndHealthText" )
#----------Dimon157 Happy and health 1/2 X

#----------MSM===ombat XP Counter (NeverMind)===1/2===0===
		screen.hide( "CombatXPButton" )
		screen.hide( "CombatXPText" )
#----------MSM===ombat XP Counter (NeverMind)===1/2===X===
#----------Dimon157 Oxford e.t.c. 1/2 0
		screen.hide( "OxfordButton" )
		screen.hide( "OxfordText" )
		screen.hide( "WallStreetButton" )
		screen.hide( "WallStreetText" )
		screen.hide( "ForbiddenPalaceButton" )
		screen.hide( "ForbiddenPalaceText" )
#----------Dimon157 Oxford e.t.c. 1/2 X

#----------MSM===GP Bar (Impaler)===2/4===0===
		screen.hide( "GreatPersonBar" )
		screen.hide( "GreatPersonBarText" )
#----------MSM===GP Bar (Impaler)===2/4===X===

#----------Dimon157 Domination 1/2 0
		if g_bDominationCounter:
			global dominationVictoryEnabled
			for iLoopVC in range(gc.getNumVictoryInfos()):
				if gc.getGame().isVictoryValid(iLoopVC):
					if (gc.getGame().getAdjustedPopulationPercent(iLoopVC) > 0):			
						dominationVictoryEnabled = true
	
			screen.hide( "DominationPopButton" )
			screen.hide( "DominationPopText" )
			screen.hide( "DominationLandButton" )
			screen.hide( "DominationLandText" )
#----------Dimon157 Domination 1/2 X

		screen.hide( "ResearchBar" )
#----------Dimon157 Culture 2/3 0
		if (g_iThreeCulturedCities > 0):
			screen.hide( "Culture1Bar" )
			screen.hide( "Culture2Bar" )
			screen.hide( "Culture3Bar" )
			screen.hide("Culture1Button")
			screen.hide("Culture1Text")
			screen.hide("Culture1City")
			screen.hide("Culture2Button")
			screen.hide("Culture2Text")
			screen.hide("Culture2City")
			screen.hide("Culture3Button")
			screen.hide("Culture3Text")
			screen.hide("Culture3City")

			screen.hide("TipCulture3City")
			for iNumCorp in [1, 3, 6]:
				screen.hide("TipCulture3CorpCulture" + str(iNumCorp))
				screen.hide("TipCulture3CorpButton" + str(iNumCorp))
			screen.hide("TipCulture3Rate1")
			screen.hide("TipCulture3Rate2")
			screen.hide("TipCulture3Build1")
			screen.hide("TipCulture3Build2")
			screen.hide("CultureBackground")
			screen.hide("TipCulture3Civic1")
			screen.hide("TipCulture3Civic2")
			screen.hide("TipCulture3Force")
#----------Dimon157 Culture 2/3 X

		bShift = CyInterface().shiftKey()
		
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()

		if (pHeadSelectedCity):
			ePlayer = pHeadSelectedCity.getOwner()
		else:
			ePlayer = gc.getGame().getActivePlayer()

		if ( ePlayer < 0 or ePlayer >= gc.getMAX_PLAYERS() ):
			return 0

		for iI in range(CommerceTypes.NUM_COMMERCE_TYPES):
			szString = "PercentText" + str(iI)
			screen.hide(szString)
			szString = "RateText" + str(iI)
			screen.hide(szString)

		if ( CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY  and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_ADVANCED_START):

			# Percent of commerce
			if (gc.getPlayer(ePlayer).isAlive()):
				iCount = 0
				for iI in range( CommerceTypes.NUM_COMMERCE_TYPES ):
					eCommerce = (iI + 1) % CommerceTypes.NUM_COMMERCE_TYPES
					if (gc.getPlayer(ePlayer).isCommerceFlexible(eCommerce) or (CyInterface().isCityScreenUp() and (eCommerce == CommerceTypes.COMMERCE_GOLD))):
						szOutText = u"<font=2>%c:%d%%</font>" %(gc.getCommerceInfo(eCommerce).getChar(), gc.getPlayer(ePlayer).getCommercePercent(eCommerce))
						szString = "PercentText" + str(iI)
						screen.setLabel( szString, "Background", szOutText, CvUtil.FONT_LEFT_JUSTIFY, 14, 50 + (iCount * 19), -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
						screen.show( szString )

						if not CyInterface().isCityScreenUp():
							szOutText = u"<font=2>" + localText.getText("TXT_KEY_MISC_POS_GOLD_PER_TURN", (gc.getPlayer(ePlayer).getCommerceRate(CommerceTypes(eCommerce)), )) + u"</font>"
							szString = "RateText" + str(iI)
							screen.setLabel( szString, "Background", szOutText, CvUtil.FONT_LEFT_JUSTIFY, 112, 50 + (iCount * 19), -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
							screen.show( szString )

						iCount = iCount + 1;
                                                
			self.updateTimeText()
			screen.setLabel( "TimeText", "Background", g_szTimeText, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 56, 6, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
			screen.show( "TimeText" )
			
			if (gc.getPlayer(ePlayer).isAlive()):
				
				szText = CyGameTextMgr().getGoldStr(ePlayer)
				screen.setLabel( "GoldText", "Background", szText, CvUtil.FONT_LEFT_JUSTIFY, 12, 6, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "GoldText" )
				
#----------MSM===Show Era===2/2===0===
				if g_bShowEra:
					szText = gc.getEraInfo(gc.getPlayer(ePlayer).getCurrentEra()).getDescription()
					screen.setLabel( "EraText", "Background", szText, CvUtil.FONT_RIGHT_JUSTIFY, 250, 6, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.show( "EraText" )
#----------MSM===Show Era===2/2===X===
#----------Dimon157 Happy and health 2/2 0
				elif (gc.getPlayer(ePlayer).getNumCities() > 0):
					minHappy=1000
					minHealth=1000
					player = gc.getPlayer(CyGame().getActivePlayer())
					(pLoopCity, iter) = player.firstCity(false)
					while(pLoopCity):
						if (pLoopCity.happyLevel() - pLoopCity.unhappyLevel(0) < minHappy):
							minHappy = pLoopCity.happyLevel() - pLoopCity.unhappyLevel(0)
						if (pLoopCity.goodHealth() - pLoopCity.badHealth(0) < minHealth):
							minHealth = pLoopCity.goodHealth() - pLoopCity.badHealth(0)
						(pLoopCity, iter) = player.nextCity(iter, false)

					szText = "<font=2>" + (u"%c" % CyGame().getSymbolID(FontSymbols.HAPPY_CHAR)) + "</font>" + ':'
					if (minHappy > 0): szText = szText + localText.getText("TXT_KEY_COLOR_POSITIVE", ()) + unicode(minHappy) + localText.getText("TXT_KEY_COLOR_REVERT", ())
					if (minHappy == 0): szText = szText + unicode(minHappy)
					if (minHappy < 0): szText = szText + localText.getText("TXT_KEY_COLOR_NEGATIVE", ()) + unicode(minHappy) + localText.getText("TXT_KEY_COLOR_REVERT", ())
					
					szText = szText + "  " + "<font=2>" + (u"%c" % CyGame().getSymbolID(FontSymbols.HEALTHY_CHAR)) + "</font>" + ':'
					if (minHealth > 0): szText = szText + localText.getText("TXT_KEY_COLOR_POSITIVE", ()) + unicode(minHealth) + localText.getText("TXT_KEY_COLOR_REVERT", ())
					if (minHealth == 0): szText = szText + unicode(minHealth)
					if (minHealth < 0): szText = szText + localText.getText("TXT_KEY_COLOR_NEGATIVE", ()) + unicode(minHealth) + localText.getText("TXT_KEY_COLOR_REVERT", ())
					
					screen.setLabel( "HappyAndHealthText", "Background", szText, CvUtil.FONT_RIGHT_JUSTIFY, 250, 6, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					if (CyInterface().isCityScreenUp()):
						screen.hide( "HappyAndHealthText" )
					else:
						screen.show( "HappyAndHealthText" )
#----------Dimon157 Happy and health 2/2 X


				numberOfButtons = 0
#----------MSM===ombat XP Counter (NeverMind)===2/2===0===
				if g_bCombatXPCounter and gc.getPlayer(ePlayer).getCombatExperience() > 0:
					eCombatXPText = " " + unicode(gc.getPlayer(ePlayer).getCombatExperience()) + "/" + unicode(gc.getPlayer(ePlayer).greatPeopleThreshold(true))
					screen.setImageButton( "CombatXPButton", ArtFileMgr.getUnitArtInfo("ART_DEF_UNIT_WARLORD_ANCIENT").getButton(), 199, 46, 24, 24, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.setHitTest( "CombatXPButton", HitTestTypes.HITTEST_NOHIT )
					screen.setLabel( "CombatXPText", "Background", eCombatXPText, CvUtil.FONT_LEFT_JUSTIFY, 220, 50, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					if (CyInterface().isCityScreenUp()):
						screen.hide( "CombatXPButton" )
						screen.hide( "CombatXPText" )
					else:
						screen.show( "CombatXPButton" )
						screen.show( "CombatXPText" )
					numberOfButtons = numberOfButtons + 1 # dimon's insert
#----------MSM===ombat XP Counter (NeverMind)===2/2===X===

#----------Dimon157 Oxford e.t.c. 2/2 0
				neededBuildings = 0
				size = CyMap().getWorldSize()
				if (size == 0): # duel
					neededBuildings = 4
				elif (size == 1): # tiny
					neededBuildings = 4
				elif (size == 2): # small
					neededBuildings = 5
				elif (size == 3): # standard
					neededBuildings = 6
				elif (size == 4): # large
					neededBuildings = 7
				elif (size == 5): # huge
					neededBuildings = 8
				
				if g_bOxford:
					oxfordIsBuild = false
					numberOfUnivs = 0
#					numberOfUnivsUnderConstruction = 0
					player = gc.getPlayer(CyGame().getActivePlayer())
					(pLoopCity, iter) = player.firstCity(false)
					while(pLoopCity):
						if (pLoopCity.isHasBuilding(110)): 
							# 110 == BUILDING_OXFORD_UNIVERSITY
							oxfordIsBuild = true
						if (pLoopCity.isHasBuilding(45)):
							# 45 == BUILDING_UNIVERSITY
							numberOfUnivs += 1
#						elif (pLoopCity.getFirstBuildingOrder(45) < 3):
#							numberOfUnivsUnderConstruction + numberOfUnivsUnderConstruction + 1
						(pLoopCity, iter) = player.nextCity(iter, false)
					if ((PyHelpers.PyPlayer(CyGame().getActivePlayer()).getTeam().isHasTech(39)) and (not oxfordIsBuild)):
						# 39 == TECH_EDUCATION
						if (numberOfUnivs < neededBuildings):
							OxfordText = "  " + unicode(numberOfUnivs) + "/" + unicode(neededBuildings)
						else:
							OxfordText = "  Ok"
						screen.setImageButton( "OxfordButton", ArtFileMgr.getBuildingArtInfo("ART_DEF_BUILDING_OXFORD_UNIVERSITY").getButton(), 199, 46 + 26*numberOfButtons, 24, 24, WidgetTypes.WIDGET_GENERAL, -1, -1 )
						screen.setHitTest( "OxfordButton", HitTestTypes.HITTEST_NOHIT )
						screen.setLabel( "OxfordText", "Background", OxfordText, CvUtil.FONT_LEFT_JUSTIFY, 220, 50 + 26*numberOfButtons, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )				
						if (CyInterface().isCityScreenUp()):
							screen.hide( "OxfordButton" )
							screen.hide( "OxfordText" )
						else:
							screen.show( "OxfordButton" )
							screen.show( "OxfordText" )
						numberOfButtons += 1
					
				if g_bForbiddenPalace:
					forbiddenPalaceIsBuild = false
					numberOfCots = 0
					player = gc.getPlayer(CyGame().getActivePlayer())
					(pLoopCity, iter) = player.firstCity(false)
					while(pLoopCity):
						if (pLoopCity.isHasBuilding(1)): 
							# 1 == BUILDING_GREAT_PALACE
							forbiddenPalaceIsBuild = true
						if (pLoopCity.isHasBuilding(67)):
							# 67 == BUILDING_COURTHOUSE
							numberOfCots += 1
						(pLoopCity, iter) = player.nextCity(iter, false)
					if ((PyHelpers.PyPlayer(CyGame().getActivePlayer()).getTeam().isHasTech(7)) and (not forbiddenPalaceIsBuild)):
						# 7 == TECH_CODE_OF_LAWS
						if (numberOfCots < neededBuildings):
							ForbiddenPalaceText = "  " + unicode(numberOfCots) + "/" + unicode(neededBuildings)
						else:
							ForbiddenPalaceText = "  Ok"
						screen.setImageButton( "ForbiddenPalaceButton", ArtFileMgr.getBuildingArtInfo("ART_DEF_BUILDING_GREAT_PALACE").getButton(), 199, 46 + 26*numberOfButtons, 24, 24, WidgetTypes.WIDGET_GENERAL, -1, -1 )
						screen.setHitTest( "ForbiddenPalaceButton", HitTestTypes.HITTEST_NOHIT )
						screen.setLabel( "ForbiddenPalaceText", "Background", ForbiddenPalaceText, CvUtil.FONT_LEFT_JUSTIFY, 220, 50 + 26*numberOfButtons, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )				
						if (CyInterface().isCityScreenUp()):
							screen.hide( "ForbiddenPalaceButton" )
							screen.hide( "ForbiddenPalaceText" )
						else:
							screen.show( "ForbiddenPalaceButton" )
							screen.show( "ForbiddenPalaceText" )
						numberOfButtons += 1

				if g_bWallStreet:
					wallStreetIsBuild = false
					numberOfBanks = 0
					player = gc.getPlayer(CyGame().getActivePlayer())
					(pLoopCity, iter) = player.firstCity(false)
					while(pLoopCity):
						if (pLoopCity.isHasBuilding(111)): 
							# 111 == BUILDING_WALL_STREET
							wallStreetIsBuild = true
						if (pLoopCity.isHasBuilding(63)):
							# 63 == BUILDING_BANK
							numberOfBanks += 1
						(pLoopCity, iter) = player.nextCity(iter, false)
					if ((PyHelpers.PyPlayer(CyGame().getActivePlayer()).getTeam().isHasTech(20)) and (not wallStreetIsBuild)):
						# 20 == TECH_CORPORATION
						if (numberOfBanks < neededBuildings):
							WallStreetText = "  " + unicode(numberOfBanks) + "/" + unicode(neededBuildings)
						else:
							WallStreetText = "  Ok"
						screen.setImageButton( "WallStreetButton", ArtFileMgr.getBuildingArtInfo("ART_DEF_BUILDING_WALL_STREET").getButton(), 199, 46 + 26*numberOfButtons, 24, 24, WidgetTypes.WIDGET_GENERAL, -1, -1 )
						screen.setHitTest( "WallStreetButton", HitTestTypes.HITTEST_NOHIT )
						screen.setLabel( "WallStreetText", "Background", WallStreetText, CvUtil.FONT_LEFT_JUSTIFY, 220, 50 + 26*numberOfButtons, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )				
						if (CyInterface().isCityScreenUp()):
							screen.hide( "WallStreetButton" )
							screen.hide( "WallStreetText" )
						else:
							screen.show( "WallStreetButton" )
							screen.show( "WallStreetText" )
						numberOfButtons += 1
						
#----------Dimon157 Oxford e.t.c. 2/2 X

#----------Dimon157 Domination 2/2 0
				if g_bDominationCounter and dominationVictoryEnabled:
					totalPop = gc.getGame().getTotalPopulation()
					ourPop = PyHelpers.PyPlayer(CyGame().getActivePlayer()).getTeam().getTotalPopulation() 
					if (totalPop > 0):
						popPercent = (ourPop * 100.0) / totalPop
					else:
						popPercent = 0.0

					eDominationPopText = ""
					for iLoopVC in range(gc.getNumVictoryInfos()):
						if gc.getGame().isVictoryValid(iLoopVC):
							if (gc.getGame().getAdjustedPopulationPercent(iLoopVC) > 0):			
								eDominationPopText = ":" + u"%.2f%%" % popPercent + "/" + u"%.2f%%" % gc.getGame().getAdjustedPopulationPercent(iLoopVC)

					screen.setImageButton( "DominationPopButton", gc.getSpecialistInfo(0).getButton(), 12, 108, 18, 18, WidgetTypes.WIDGET_GENERAL, -1, -1 )
#					eDominationPopButton = u"<font=2>%c</font>" %(CyGame().getSymbolID(FontSymbols.ANGRY_POP_CHAR))
#					screen.setLabel( "DominationPopButton", "Background", eDominationPopButton, CvUtil.FONT_RIGHT_JUSTIFY, 31, 108, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.setLabel( "DominationPopText", "Background", eDominationPopText, CvUtil.FONT_LEFT_JUSTIFY, 32, 108, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					if (CyInterface().isCityScreenUp()):
						screen.hide( "DominationPopButton" )
						screen.hide( "DominationPopText" )
					elif (totalPop > 0):						
						screen.show( "DominationPopButton" )
						screen.show( "DominationPopText" )

					
					totalLand = gc.getMap().getLandPlots()
					ourLand = PyHelpers.PyPlayer(CyGame().getActivePlayer()).getTeam().getTotalLand()
					if (totalLand > 0):
						landPercent = (ourLand * 100.0) / totalLand
					else:
						landPercent = 0.0

					for iLoopVC in range(gc.getNumVictoryInfos()):
						if gc.getGame().isVictoryValid(iLoopVC):
							if (gc.getGame().getAdjustedLandPercent(iLoopVC) > 0):			
								eDominationLandText = ":" + u"%.2f%%" % landPercent + "/" + u"%.2f%%" % gc.getGame().getAdjustedLandPercent(iLoopVC)

					eDominationLandButton = u"<font=2>%c</font>" %(CyGame().getSymbolID(FontSymbols.MAP_CHAR))
					screen.setLabel( "DominationLandButton", "Background", eDominationLandButton, CvUtil.FONT_RIGHT_JUSTIFY, 31, 128, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.setLabel( "DominationLandText", "Background", eDominationLandText, CvUtil.FONT_LEFT_JUSTIFY, 32, 128, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					if (CyInterface().isCityScreenUp()):
						screen.hide( "DominationLandButton" )
						screen.hide( "DominationLandText" )
					elif (totalLand > 0):
						screen.show( "DominationLandButton" )
						screen.show( "DominationLandText" )

#----------Dimon157 Domination 2/2 X

				if (((gc.getPlayer(ePlayer).calculateGoldRate() != 0) and not (gc.getPlayer(ePlayer).isAnarchy())) or (gc.getPlayer(ePlayer).getGold() != 0)):
					screen.show( "GoldText" )

				if (gc.getPlayer(ePlayer).isAnarchy()):
				
					szText = localText.getText("INTERFACE_ANARCHY", (gc.getPlayer(ePlayer).getAnarchyTurns(), ))
					screen.setText( "ResearchText", "Background", szText, CvUtil.FONT_CENTER_JUSTIFY, screen.centerX(512), 3, -0.4, FontTypes.GAME_FONT, WidgetTypes.WIDGET_RESEARCH, -1, -1 )
					if ( gc.getPlayer(ePlayer).getCurrentResearch() != -1 ):
						screen.show( "ResearchText" )
					else:
						screen.hide( "ResearchText" )
					
				elif (gc.getPlayer(ePlayer).getCurrentResearch() != -1):

					szText = CyGameTextMgr().getResearchStr(ePlayer)
					screen.setText( "ResearchText", "Background", szText, CvUtil.FONT_CENTER_JUSTIFY, screen.centerX(512), 3, -0.4, FontTypes.GAME_FONT, WidgetTypes.WIDGET_RESEARCH, -1, -1 )
					screen.show( "ResearchText" )

					researchProgress = gc.getTeam(gc.getPlayer(ePlayer).getTeam()).getResearchProgress(gc.getPlayer(ePlayer).getCurrentResearch())
					overflowResearch = (gc.getPlayer(ePlayer).getOverflowResearch() * gc.getPlayer(ePlayer).calculateResearchModifier(gc.getPlayer(ePlayer).getCurrentResearch()))/100
					researchCost = gc.getTeam(gc.getPlayer(ePlayer).getTeam()).getResearchCost(gc.getPlayer(ePlayer).getCurrentResearch())
					researchRate = gc.getPlayer(ePlayer).calculateResearchRate(-1)
					
					iFirst = float(researchProgress + overflowResearch) / float(researchCost)
					screen.setBarPercentage( "ResearchBar", InfoBarTypes.INFOBAR_STORED, iFirst )
					if ( iFirst == 1 ):
						screen.setBarPercentage( "ResearchBar", InfoBarTypes.INFOBAR_RATE, ( float(researchRate) / float(researchCost) ) )
					else:
						screen.setBarPercentage( "ResearchBar", InfoBarTypes.INFOBAR_RATE, ( ( float(researchRate) / float(researchCost) ) ) / ( 1 - iFirst ) )

					screen.show( "ResearchBar" )

############################################################
##########=MSM===GP Bar (Impaler)===3/4===0===
############################################################
				if (g_bGPBar and not CyInterface().isCityScreenUp()):				
					pGreatPersonCity, iGPTurns = self.getnextGPCity()
					if (iGPTurns < 10000000 and pGreatPersonCity):
#----------Dimon157 GP Bar 1/1 0
						if (g_iDetailGPBar == 0):
							szText = "GreatPerson: " + pGreatPersonCity.getName() + " (%d)" %(iGPTurns)
						if (g_iDetailGPBar == 1):
							maxProgress = 0
							maxPerson = "Great Person: "
							if (pGreatPersonCity.getGreatPeopleUnitProgress(116) > maxProgress):
								maxProgress = pGreatPersonCity.getGreatPeopleUnitProgress(116)
								maxPerson = "Great Prophet: "
							if (pGreatPersonCity.getGreatPeopleUnitProgress(117) > maxProgress):
								maxProgress = pGreatPersonCity.getGreatPeopleUnitProgress(117)
								maxPerson = "Great Artist: "
							if (pGreatPersonCity.getGreatPeopleUnitProgress(118) > maxProgress):
								maxProgress = pGreatPersonCity.getGreatPeopleUnitProgress(118)
								maxPerson = "Great Scientist: "
							if (pGreatPersonCity.getGreatPeopleUnitProgress(119) > maxProgress):
								maxProgress = pGreatPersonCity.getGreatPeopleUnitProgress(119)
								maxPerson = "Great Merchant: "
							if (pGreatPersonCity.getGreatPeopleUnitProgress(120) > maxProgress):
								maxProgress = pGreatPersonCity.getGreatPeopleUnitProgress(120)
								maxPerson = "Great Engineer: "
							if (pGreatPersonCity.getGreatPeopleUnitProgress(122) > maxProgress):
								maxProgress = pGreatPersonCity.getGreatPeopleUnitProgress(122)
								maxPerson = "Great Spy: "
							if (maxProgress > 0):
								chance = 100*maxProgress / (pGreatPersonCity.getGreatPeopleUnitProgress(116) + pGreatPersonCity.getGreatPeopleUnitProgress(117) + pGreatPersonCity.getGreatPeopleUnitProgress(118) + pGreatPersonCity.getGreatPeopleUnitProgress(119) + pGreatPersonCity.getGreatPeopleUnitProgress(120) + pGreatPersonCity.getGreatPeopleUnitProgress(122))
								szText = maxPerson + pGreatPersonCity.getName() + " (" + unicode(iGPTurns) + "): " + unicode(chance) + "%"
							else:
								szText = maxPerson + pGreatPersonCity.getName() + " (" + unicode(iGPTurns) + ")"
								
						if (g_iDetailGPBar == 2):
							listProgress = [pGreatPersonCity.getGreatPeopleUnitProgress(116), pGreatPersonCity.getGreatPeopleUnitProgress(117), pGreatPersonCity.getGreatPeopleUnitProgress(118), pGreatPersonCity.getGreatPeopleUnitProgress(119), pGreatPersonCity.getGreatPeopleUnitProgress(120), pGreatPersonCity.getGreatPeopleUnitProgress(122)]
							indexListProgress = range(6)
							for iSort in [6, 5, 4, 3, 2, 1]:
								for jSort in range(0, iSort-1):
									if (listProgress[jSort] < listProgress[jSort+1]):
										swapElem = listProgress[jSort]
										listProgress[jSort] = listProgress[jSort+1]
										listProgress[jSort+1] = swapElem
										swapIndex = indexListProgress[jSort]
										indexListProgress[jSort] = indexListProgress[jSort+1]
										indexListProgress[jSort+1] = swapIndex
							
							if (listProgress[0] > 0):
								szText = pGreatPersonCity.getName() + " (" + unicode(iGPTurns) + ") - "
								totalProgress = 0
								for iProgress in listProgress:
									totalProgress += iProgress
								for iIndex in range(len(listProgress)):
									chance = 100*listProgress[iIndex] / (totalProgress)
									if (chance > 0):
										if (iIndex > 0):
											szText += ", "
										if (indexListProgress[iIndex] == 0): szText += "Pro"
										if (indexListProgress[iIndex] == 1): szText += "Art"
										if (indexListProgress[iIndex] == 2): szText += "Sci"
										if (indexListProgress[iIndex] == 3): szText += "Mer"
										if (indexListProgress[iIndex] == 4): szText += "Eng"
										if (indexListProgress[iIndex] == 5): szText += "Spy"
										szText += ": " + unicode(chance) + "%"
							else:
								szText = "Great Person: " + pGreatPersonCity.getName() + " (" + unicode(iGPTurns) + ")"
#----------Dimon157 GP Bar 1/1 X
						#szText = "GreatPerson: " + pGreatPersonCity.getName() + " (%d)" %(iGPTurns)
						screen.setText( "GreatPersonBarText", "Background", szText, CvUtil.FONT_CENTER_JUSTIFY, screen.centerX(512), 31, -0.4, FontTypes.GAME_FONT, WidgetTypes.WIDGET_HELP_GREAT_PEOPLE, -1, -1 )
						screen.show( "GreatPersonBarText" )
					
						iFirst = float(pGreatPersonCity.getGreatPeopleProgress()) / float( gc.getPlayer( pGreatPersonCity.getOwner() ).greatPeopleThreshold(false) )
						screen.setBarPercentage( "GreatPersonBar", InfoBarTypes.INFOBAR_STORED, iFirst )
						if ( iFirst == 1 ):
							screen.setBarPercentage( "GreatPersonBar", InfoBarTypes.INFOBAR_RATE, ( float(pGreatPersonCity.getGreatPeopleRate()) / float( gc.getPlayer( pGreatPersonCity.getOwner() ).greatPeopleThreshold(false) ) ) )
						else:
							screen.setBarPercentage( "GreatPersonBar", InfoBarTypes.INFOBAR_RATE, ( ( float(pGreatPersonCity.getGreatPeopleRate()) / float( gc.getPlayer( pGreatPersonCity.getOwner() ).greatPeopleThreshold(false) ) ) ) / ( 1 - iFirst ) )				
						screen.show( "GreatPersonBar" )
					else:	
						screen.hide( "GreatPersonBar" )
						screen.hide( "GreatPersonBarText" )
############################################################
##########=MSM===GP Bar (Impaler)===3/4===X===
############################################################

#----------Dimon157 Culture 3/3 0
				if ((g_iThreeCulturedCities > 0) and (not CyInterface().isCityScreenUp())):
					# finding 3 best cities
					for iLoopVC in range(gc.getNumVictoryInfos()):
						victory = gc.getVictoryInfo(iLoopVC)
						if (victory.getCityCulture() != CultureLevelTypes.NO_CULTURELEVEL and victory.getNumCultureCities() > 0):
						
							cultureNo1 = CyCity()
							cultureNo2 = CyCity()
							cultureNo3 = CyCity()
							cultureNo1TurnsLeft = 10000
							cultureNo2TurnsLeft = 10000
							cultureNo3TurnsLeft = 10000
							maxCulture = gc.getCultureLevelInfo(gc.getNumCultureLevelInfos()-1).getSpeedThreshold(CyGame().getGameSpeedType())
							player = gc.getPlayer(CyGame().getActivePlayer())
							(pLoopCity, iter) = player.firstCity(false)
							while(pLoopCity):
								pLoopCityTurnsLeft = 10001
								if (pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE) > 0):
									pLoopCityTurnsLeft = max((maxCulture - pLoopCity.getCulture(CyGame().getActivePlayer()) + pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE) - 1)/pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE), 0)
								if (pLoopCityTurnsLeft <= cultureNo1TurnsLeft):
									cultureNo3 = cultureNo2
									cultureNo2 = cultureNo1
									cultureNo1 = pLoopCity
									cultureNo1Count = pLoopCity.getCulture(CyGame().getActivePlayer())
									cultureNo1PerTurn = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE)
									if (cultureNo1PerTurn > 0):
										cultureNo1TurnsLeft = max((maxCulture - cultureNo1Count + cultureNo1PerTurn - 1)/cultureNo1PerTurn, 0)
								elif ((pLoopCityTurnsLeft > cultureNo1TurnsLeft) and (pLoopCityTurnsLeft <= cultureNo2TurnsLeft)):
									cultureNo3 = cultureNo2
									cultureNo2 = pLoopCity
									cultureNo2Count = pLoopCity.getCulture(CyGame().getActivePlayer())
									cultureNo2PerTurn = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE)
									if (cultureNo2PerTurn > 0):
										cultureNo2TurnsLeft = max((maxCulture - cultureNo2Count + cultureNo2PerTurn - 1)/cultureNo2PerTurn, 0)
								elif ((pLoopCityTurnsLeft > cultureNo2TurnsLeft) and (pLoopCityTurnsLeft <= cultureNo3TurnsLeft)):
									cultureNo3 = pLoopCity
									cultureNo3Count = pLoopCity.getCulture(CyGame().getActivePlayer())
									cultureNo3PerTurn = pLoopCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE)
									if (cultureNo3PerTurn > 0):
										cultureNo3TurnsLeft = max((maxCulture - cultureNo3Count + cultureNo3PerTurn - 1)/cultureNo3PerTurn, 0)
								(pLoopCity, iter) = player.nextCity(iter, false)
		
							totalCulture = (min(cultureNo1.getCulture(CyGame().getActivePlayer()), maxCulture) + min(cultureNo2.getCulture(CyGame().getActivePlayer()), maxCulture) + min(cultureNo3.getCulture(CyGame().getActivePlayer()), maxCulture)) / 3
		
							if (100*totalCulture/maxCulture >= 20):
								eCultureButton = u"<font=2>%c</font>" % gc.getCommerceInfo(CommerceTypes.COMMERCE_CULTURE).getChar()
								eCultureNo1Text = cultureNo1.getName() + ": +" + unicode(cultureNo1PerTurn) + " [" + unicode(cultureNo1TurnsLeft) + "]"
								eCultureNo2Text = cultureNo2.getName() + ": +" + unicode(cultureNo2PerTurn) + " [" + unicode(cultureNo2TurnsLeft) + "]"
								eCultureNo3Text = cultureNo3.getName() + ": +" + unicode(cultureNo3PerTurn) + " [" + unicode(cultureNo3TurnsLeft) + "]"
								screen.setLabel( "Culture1Button", "Background", eCultureButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 37, 60, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture1Text", "Background", ":" + unicode(min(100*cultureNo1Count/maxCulture, 100)) + "%", CvUtil.FONT_LEFT_JUSTIFY, xResolution - 37, 60, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture1City", "Background", eCultureNo1Text, CvUtil.FONT_CENTER_JUSTIFY, xResolution - 136, 60, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture2Button", "Background", eCultureButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 37, 80, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture2Text", "Background", ":" + unicode(min(100*cultureNo2Count/maxCulture, 100)) + "%", CvUtil.FONT_LEFT_JUSTIFY, xResolution - 37, 80, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture2City", "Background", eCultureNo2Text, CvUtil.FONT_CENTER_JUSTIFY, xResolution - 136, 80, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture3Button", "Background", eCultureButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 37, 100, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture3Text", "Background", ":" + unicode(min(100*cultureNo3Count/maxCulture, 100)) + "%", CvUtil.FONT_LEFT_JUSTIFY, xResolution - 37, 100, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.setLabel( "Culture3City", "Background", eCultureNo3Text, CvUtil.FONT_CENTER_JUSTIFY, xResolution - 136, 100, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
								screen.show("Culture1Button")
								screen.show("Culture1Text")
								screen.show("Culture1City")
								screen.show("Culture2Button")
								screen.show("Culture2Text")
								screen.show("Culture2City")
								screen.show("Culture3Button")
								screen.show("Culture3Text")
								screen.show("Culture3City")

								screen.setBarPercentage( "Culture1Bar", InfoBarTypes.INFOBAR_STORED, 1.0*cultureNo1Count/maxCulture )
								if (cultureNo1TurnsLeft > 0): screen.setBarPercentage( "Culture1Bar", InfoBarTypes.INFOBAR_RATE, 1.0/cultureNo1TurnsLeft )
								else: screen.setBarPercentage( "Culture1Bar", InfoBarTypes.INFOBAR_RATE, 1.0 )
								screen.show( "Culture1Bar" )
								screen.setBarPercentage( "Culture2Bar", InfoBarTypes.INFOBAR_STORED, 1.0*cultureNo2Count/maxCulture )
								if (cultureNo2TurnsLeft > 0): screen.setBarPercentage( "Culture2Bar", InfoBarTypes.INFOBAR_RATE, 1.0/cultureNo2TurnsLeft )
								else: screen.setBarPercentage( "Culture2Bar", InfoBarTypes.INFOBAR_RATE, 1.0 )
								screen.show( "Culture2Bar" )
								screen.setBarPercentage( "Culture3Bar", InfoBarTypes.INFOBAR_STORED, 1.0*cultureNo3Count/maxCulture )
								if (cultureNo3TurnsLeft > 0): screen.setBarPercentage( "Culture3Bar", InfoBarTypes.INFOBAR_RATE, 1.0/cultureNo3TurnsLeft )
								else: screen.setBarPercentage( "Culture3Bar", InfoBarTypes.INFOBAR_RATE, 1.0 )
								screen.show( "Culture3Bar" )
								
								# tips
								if (g_iThreeCulturedCities == 2):
									TipOffsetY = 0
									# starting from 3rd city
									# city name
									CultureNo3Title = cultureNo3.getName() + ": +" + unicode(cultureNo3PerTurn) + " [" + unicode(cultureNo3TurnsLeft) + "]  " + eCultureButton + ":" + u"%d.%02d" %(cultureNo3.getTotalCommerceRateModifier(CommerceTypes.COMMERCE_CULTURE)/100, cultureNo3.getTotalCommerceRateModifier(CommerceTypes.COMMERCE_CULTURE)%100) + "x"
									screen.setLabel( "TipCulture3City", "Background", CultureNo3Title, CvUtil.FONT_CENTER_JUSTIFY, xResolution - 111, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
									screen.show("TipCulture3City")
									TipOffsetY += 1
									
									# corporations
									for iNumCorp in [1, 3, 6]:
										if (not cultureNo3.isHasCorporation(iNumCorp)):
											screen.setImageButton( "TipCulture3CorpButton" + str(iNumCorp), gc.getCorporationInfo(iNumCorp).getButton(), xResolution - 208, 122 + 24*TipOffsetY, 24, 24, WidgetTypes.WIDGET_GENERAL, -1, -1 )
											screen.show("TipCulture3CorpButton" + str(iNumCorp))
											text = CyGameTextMgr().getCorporationHelpCity(iNumCorp, cultureNo3, False, True)
											screen.setLabel( "TipCulture3CorpCulture" + str(iNumCorp), "Background", text, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 11, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
											screen.show("TipCulture3CorpCulture" + str(iNumCorp))
											TipOffsetY += 1
											
									# Culture Rate
									if (player.getCommercePercent(CommerceTypes.COMMERCE_CULTURE) < 100):		
										screen.setLabel( "TipCulture3Rate1", "Background", eCultureButton + ":100%", CvUtil.FONT_LEFT_JUSTIFY, xResolution - 207, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
										screen.show("TipCulture3Rate1")
										raiseCulture = cultureNo3.getBaseYieldRate(YieldTypes.YIELD_COMMERCE) * (100-player.getCommercePercent(CommerceTypes.COMMERCE_CULTURE)) * cultureNo3.getTotalCommerceRateModifier(CommerceTypes.COMMERCE_CULTURE) / 100
										text = u"%d.%02d" %(raiseCulture/100, raiseCulture%100)
										screen.setLabel( "TipCulture3Rate2", "Background", "+" + unicode(text) + eCultureButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 12, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
										screen.show("TipCulture3Rate2")
										TipOffsetY += 1
										
									# Build culture
									if (cultureNo3.getProductionProcess() != 2):
										screen.setLabel( "TipCulture3Build1", "Background", "Build " + eCultureButton, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 206, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
										screen.show("TipCulture3Build1")
										raiseCulture = cultureNo3.getBaseYieldRate(YieldTypes.YIELD_PRODUCTION) * (100 + cultureNo3.getYieldRateModifier(YieldTypes.YIELD_PRODUCTION))
										text = u"%d.%02d" %(raiseCulture/100, raiseCulture%100)
										screen.setLabel( "TipCulture3Build2", "Background", "+" + unicode(text) + eCultureButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 12, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
										screen.show("TipCulture3Build2")
										TipOffsetY += 1
										
									# Free religion
									if (not player.isCivic(9)):
										screen.setLabel( "TipCulture3Civic1", "Background", "Free Speech ", CvUtil.FONT_LEFT_JUSTIFY, xResolution - 206, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
										screen.show("TipCulture3Civic1")
										screen.setLabel( "TipCulture3Civic2", "Background", "+100%" + eCultureButton, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 12, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
										screen.show("TipCulture3Civic2")
										TipOffsetY += 1
										
									# Force artist specialist
									if (cultureNo3.getForceSpecialistCount(2) == 0):
										screen.setLabel( "TipCulture3Force", "Background", "Force artist specialist", CvUtil.FONT_LEFT_JUSTIFY, xResolution - 206, 125 + 24*TipOffsetY, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
										screen.show("TipCulture3Force")
										TipOffsetY += 1
										
									screen.setPanelSize( "CultureBackground", xResolution - 211, 118, 200, TipOffsetY*24+9 )
									screen.show( "CultureBackground" )
								
#----------Dimon157 Culture 3/3 X
		return 0

############################################################
##########=MSM===GP Bar (Impaler)===4/4===0===
############################################################
	def getnextGPCity( self ):
	
		iFastestPerson = 10000000
		iGPTurns = 0
		pPlayer = gc.getPlayer(gc.getGame().getActivePlayer())
		iGPNext = pPlayer.greatPeopleThreshold(false)
		pFastestCity = CyInterface().getHeadSelectedCity()
		
		for icity in range(pPlayer.getNumCities()):
			pCity = pPlayer.getCity(icity)
			if (pCity):
				iGPRate = pCity.getGreatPeopleRate()
				if (iGPRate > 0):
					iGPNow = pCity.getGreatPeopleProgress()
					iGPTurns = (iGPNext - iGPNow + iGPRate - 1) / iGPRate
					if (iGPTurns < iFastestPerson):
						iFastestPerson = iGPTurns
						pFastestCity = pCity
		
		return (pFastestCity, iFastestPerson)
############################################################
##########=MSM===GP Bar (Impaler)===4/4===X===
############################################################
		
	def updateTimeText( self ):
		
		global g_szTimeText
		
		ePlayer = gc.getGame().getActivePlayer()

#		g_szTimeText = localText.getText("TXT_KEY_TIME_TURN", (CyGame().getGameTurn(), )) + u" - " + unicode(CyGameTextMgr().getInterfaceTimeStr(ePlayer))
#		if (CyUserProfile().isClockOn()):
#			g_szTimeText = getClockText() + u" - " + g_szTimeText
		
############################################################
##########=MSM===Show Turn===0===
############################################################
		if g_iShowTurn == 0:
			g_szTimeText = getClockText() + u" - " + localText.getText("TXT_KEY_TIME_TURN", (CyGame().getGameTurn(), )) + u" - " + unicode(CyGameTextMgr().getInterfaceTimeStr(ePlayer))
		elif g_iShowTurn == 2 and gc.getGame().getMaxTurns() > 0:
			g_szTimeText = getClockText() + " (" + unicode(gc.getGame().getGameTurn() - gc.getGame().getStartTurn() + 1) + "/" + unicode(gc.getGame().getMaxTurns()) + ") " + unicode(CyGameTextMgr().getInterfaceTimeStr(ePlayer))
		else:
			g_szTimeText = getClockText() + "  (" + unicode(gc.getGame().getGameTurn() - gc.getGame().getStartTurn() + 1) + ") " + unicode(CyGameTextMgr().getInterfaceTimeStr(ePlayer))
############################################################
##########=MSM===Show Turn===X===
############################################################
		
	# Will update the selection Data Strings
	def updateCityScreen( self ):
	
		global MAX_DISPLAYABLE_BUILDINGS
		global MAX_DISPLAYABLE_TRADE_ROUTES
		global MAX_BONUS_ROWS
		
		global g_iNumTradeRoutes
		global g_iNumBuildings
		global g_iNumLeftBonus
		global g_iNumCenterBonus
		global g_iNumRightBonus
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()

		# Find out our resolution
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		bShift = CyInterface().shiftKey()

		screen.hide( "PopulationBar" )
		screen.hide( "ProductionBar" )
		screen.hide( "GreatPeopleBar" )
		screen.hide( "CultureBar" )

############################################################
##########=MSM===Raw City Commerce Display (Sevo)=3/9===0===
############################################################
		screen.hide( "MaintenanceText" )
		screen.hide( "MaintenanceTextb" )
		screen.hide( "MaintenanceTextc" )
		screen.hide( "MaintenanceTextd" )
		screen.hide( "MaintenanceTexte" )
		screen.hide( "MaintenanceTextf" )
		screen.hide( "MaintenanceTextg" )
		screen.hide( "MaintenanceTexth" )
		screen.hide( "MaintenanceTexti" )
		screen.hide( "MaintenanceAmountText" )
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=3/9===X===
############################################################

		screen.hide( "NationalityText" )
		screen.hide( "NationalityBar" )
		screen.hide( "DefenseText" )
		screen.hide( "CityScrollMinus" )
		screen.hide( "CityScrollPlus" )
		screen.hide( "CityNameText" )
		screen.hide( "PopulationText" )
		screen.hide( "PopulationInputText" )
		screen.hide( "HealthText" )
		screen.hide( "ProductionText" )
		screen.hide( "ProductionInputText" )
		screen.hide( "HappinessText" )
		screen.hide( "CultureText" )
		screen.hide( "GreatPeopleText" )

		for i in range( gc.getNumReligionInfos() ):
			szName = "ReligionHolyCityDDS" + str(i)
			screen.hide( szName )
			szName = "ReligionDDS" + str(i)
			screen.hide( szName )
			
		for i in range( gc.getNumCorporationInfos() ):
			szName = "CorporationHeadquarterDDS" + str(i)
			screen.hide( szName )
			szName = "CorporationDDS" + str(i)
			screen.hide( szName )
			
		for i in range(CommerceTypes.NUM_COMMERCE_TYPES):
			szName = "CityPercentText" + str(i)
			screen.hide( szName )

		screen.addPanel( "BonusPane0", u"", u"", True, False, xResolution - 244, 94, 57, yResolution - 520, PanelStyles.PANEL_STYLE_CITY_COLUMNL )
		screen.hide( "BonusPane0" )
		screen.addScrollPanel( "BonusBack0", u"", xResolution - 242, 94, 157, yResolution - 536, PanelStyles.PANEL_STYLE_EXTERNAL )
		screen.hide( "BonusBack0" )

		screen.addPanel( "BonusPane1", u"", u"", True, False, xResolution - 187, 94, 68, yResolution - 520, PanelStyles.PANEL_STYLE_CITY_COLUMNC )
		screen.hide( "BonusPane1" )
		screen.addScrollPanel( "BonusBack1", u"", xResolution - 191, 94, 184, yResolution - 536, PanelStyles.PANEL_STYLE_EXTERNAL )
		screen.hide( "BonusBack1" )

		screen.addPanel( "BonusPane2", u"", u"", True, False, xResolution - 119, 94, 107, yResolution - 520, PanelStyles.PANEL_STYLE_CITY_COLUMNR )
		screen.hide( "BonusPane2" )
		screen.addScrollPanel( "BonusBack2", u"", xResolution - 125, 94, 205, yResolution - 536, PanelStyles.PANEL_STYLE_EXTERNAL )
		screen.hide( "BonusBack2" )

		screen.hide( "TradeRouteTable" )
		screen.hide( "BuildingListTable" )
		
		screen.hide( "BuildingListBackground" )
		screen.hide( "TradeRouteListBackground" )
		screen.hide( "BuildingListLabel" )
		screen.hide( "TradeRouteListLabel" )

		i = 0
		for i in range( g_iNumLeftBonus ):
			szName = "LeftBonusItem" + str(i)
			screen.hide( szName )
		
		i = 0
		for i in range( g_iNumCenterBonus ):
			szName = "CenterBonusItemLeft" + str(i)
			screen.hide( szName )
			szName = "CenterBonusItemRight" + str(i)
			screen.hide( szName )
		
		i = 0
		for i in range( g_iNumRightBonus ):
			szName = "RightBonusItemLeft" + str(i)
			screen.hide( szName )
			szName = "RightBonusItemRight" + str(i)
			screen.hide( szName )
			
		i = 0
		for i in range( 3 ):
			szName = "BonusPane" + str(i)
			screen.hide( szName )
			szName = "BonusBack" + str(i)
			screen.hide( szName )

		i = 0
		if ( CyInterface().isCityScreenUp() ):
			if ( pHeadSelectedCity ):
			
				screen.show( "InterfaceTopLeftBackgroundWidget" )
				screen.show( "InterfaceTopRightBackgroundWidget" )
				screen.show( "InterfaceCenterLeftBackgroundWidget" )
				screen.show( "CityScreenTopWidget" )
				screen.show( "CityNameBackground" )
				screen.show( "TopCityPanelLeft" )
				screen.show( "TopCityPanelRight" )
				screen.show( "CityScreenAdjustPanel" )

############################################################
##########=MSM===Raw City Commerce Display (Sevo)=4/9===0===
############################################################			
				screen.show( "CityScreenAdjustPanelb" )
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=4/9===X===
############################################################

				screen.show( "InterfaceCenterRightBackgroundWidget" )
				
				if ( pHeadSelectedCity.getTeam() == gc.getGame().getActiveTeam() ):
					if ( gc.getActivePlayer().getNumCities() > 1 ):
						screen.show( "CityScrollMinus" )
						screen.show( "CityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===8/9===0===
############################################################
						screen.hide( "MainCityScrollMinus" )
						screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===8/9===X===
############################################################
				
				# Help Text Area
				screen.setHelpTextArea( 390, FontTypes.SMALL_FONT, 0, 0, -2.2, True, ArtFileMgr.getInterfaceArtInfo("POPUPS_BACKGROUND_TRANSPARENT").getPath(), True, True, CvUtil.FONT_LEFT_JUSTIFY, 0 )

				iFoodDifference = pHeadSelectedCity.foodDifference(True)
				iProductionDiffNoFood = pHeadSelectedCity.getCurrentProductionDifference(True, True)
				iProductionDiffJustFood = (pHeadSelectedCity.getCurrentProductionDifference(False, True) - iProductionDiffNoFood)

				szBuffer = u"<font=4>"
				
				if (pHeadSelectedCity.isCapital()):
					szBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.STAR_CHAR))
				elif (pHeadSelectedCity.isGovernmentCenter()):
					szBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.SILVER_STAR_CHAR))

				if (pHeadSelectedCity.isPower()):
					szBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.POWER_CHAR))
					
				szBuffer += u"%s: %d" %(pHeadSelectedCity.getName(), pHeadSelectedCity.getPopulation())

				if (pHeadSelectedCity.isOccupation()):
					szBuffer += u" (%c:%d)" %(CyGame().getSymbolID(FontSymbols.OCCUPATION_CHAR), pHeadSelectedCity.getOccupationTimer())

				szBuffer += u"</font>"

				screen.setText( "CityNameText", "Background", szBuffer, CvUtil.FONT_CENTER_JUSTIFY, screen.centerX(512), 32, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_CITY_NAME, -1, -1 )
				screen.setStyle( "CityNameText", "Button_Stone_Style" )
				screen.show( "CityNameText" )

				if ( (iFoodDifference != 0) or not (pHeadSelectedCity.isFoodProduction() ) ):
					if (iFoodDifference > 0):
						szBuffer = localText.getText("INTERFACE_CITY_GROWING", (pHeadSelectedCity.getFoodTurnsLeft(), ))	
					elif (iFoodDifference < 0):
						szBuffer = localText.getText("INTERFACE_CITY_STARVING", ())	
					else:
						szBuffer = localText.getText("INTERFACE_CITY_STAGNANT", ())	

					screen.setLabel( "PopulationText", "Background", szBuffer, CvUtil.FONT_CENTER_JUSTIFY, screen.centerX(512), iCityCenterRow1Y, -1.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.setHitTest( "PopulationText", HitTestTypes.HITTEST_NOHIT )
					screen.show( "PopulationText" )

				if (not pHeadSelectedCity.isDisorder() and not pHeadSelectedCity.isFoodProduction()):
				
					szBuffer = u"%d%c - %d%c" %(pHeadSelectedCity.getYieldRate(YieldTypes.YIELD_FOOD), gc.getYieldInfo(YieldTypes.YIELD_FOOD).getChar(), pHeadSelectedCity.foodConsumption(False, 0), CyGame().getSymbolID(FontSymbols.EATEN_FOOD_CHAR))
					screen.setLabel( "PopulationInputText", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, iCityCenterRow1X - 6, iCityCenterRow1Y, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.show( "PopulationInputText" )
					
				else:
				
					szBuffer = u"%d%c" %(iFoodDifference, gc.getYieldInfo(YieldTypes.YIELD_FOOD).getChar())
					screen.setLabel( "PopulationInputText", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, iCityCenterRow1X - 6, iCityCenterRow1Y, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.show( "PopulationInputText" )

				if ((pHeadSelectedCity.badHealth(False) > 0) or (pHeadSelectedCity.goodHealth() >= 0)):
					if (pHeadSelectedCity.healthRate(False, 0) < 0):
						szBuffer = localText.getText("INTERFACE_CITY_HEALTH_BAD", (pHeadSelectedCity.goodHealth(), pHeadSelectedCity.badHealth(False), pHeadSelectedCity.healthRate(False, 0)))
					elif (pHeadSelectedCity.badHealth(False) > 0):
						szBuffer = localText.getText("INTERFACE_CITY_HEALTH_GOOD", (pHeadSelectedCity.goodHealth(), pHeadSelectedCity.badHealth(False)))
					else:
						szBuffer = localText.getText("INTERFACE_CITY_HEALTH_GOOD_NO_BAD", (pHeadSelectedCity.goodHealth(), ))
						
					screen.setLabel( "HealthText", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, xResolution - iCityCenterRow1X + 6, iCityCenterRow1Y, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_HELP_HEALTH, -1, -1 )
					screen.show( "HealthText" )

				if (iFoodDifference < 0):

					if ( pHeadSelectedCity.getFood() + iFoodDifference > 0 ):
						iDeltaFood = pHeadSelectedCity.getFood() + iFoodDifference
					else:
						iDeltaFood = 0
					if ( -iFoodDifference < pHeadSelectedCity.getFood() ):
						iExtraFood = -iFoodDifference
					else:
						iExtraFood = pHeadSelectedCity.getFood()
					iFirst = float(iDeltaFood) / float(pHeadSelectedCity.growthThreshold())
					screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_STORED, iFirst )
					screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_RATE, 0.0 )
					if ( iFirst == 1 ):
						screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_RATE_EXTRA, ( float(iExtraFood) / float(pHeadSelectedCity.growthThreshold()) ) )
					else:
						screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_RATE_EXTRA, ( ( float(iExtraFood) / float(pHeadSelectedCity.growthThreshold()) ) ) / ( 1 - iFirst ) )
					
				else:

					iFirst = float(pHeadSelectedCity.getFood()) / float(pHeadSelectedCity.growthThreshold())
					screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_STORED, iFirst )
					if ( iFirst == 1 ):
						screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_RATE, ( float(iFoodDifference) / float(pHeadSelectedCity.growthThreshold()) ) )
					else:
						screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_RATE, ( ( float(iFoodDifference) / float(pHeadSelectedCity.growthThreshold()) ) ) / ( 1 - iFirst ) )
					screen.setBarPercentage( "PopulationBar", InfoBarTypes.INFOBAR_RATE_EXTRA, 0.0 )
					
				screen.show( "PopulationBar" )

				if (pHeadSelectedCity.getOrderQueueLength() > 0):
					if (pHeadSelectedCity.isProductionProcess()):
						szBuffer = pHeadSelectedCity.getProductionName()
					else:
						szBuffer = localText.getText("INTERFACE_CITY_PRODUCTION", (pHeadSelectedCity.getProductionNameKey(), pHeadSelectedCity.getProductionTurnsLeft()))

					screen.setLabel( "ProductionText", "Background", szBuffer, CvUtil.FONT_CENTER_JUSTIFY, screen.centerX(512), iCityCenterRow2Y, -1.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.setHitTest( "ProductionText", HitTestTypes.HITTEST_NOHIT )
					screen.show( "ProductionText" )
				
				if (pHeadSelectedCity.isProductionProcess()):
					szBuffer = u"%d%c" %(pHeadSelectedCity.getYieldRate(YieldTypes.YIELD_PRODUCTION), gc.getYieldInfo(YieldTypes.YIELD_PRODUCTION).getChar())
				elif (pHeadSelectedCity.isFoodProduction() and (iProductionDiffJustFood > 0)):
					szBuffer = u"%d%c + %d%c" %(iProductionDiffJustFood, gc.getYieldInfo(YieldTypes.YIELD_FOOD).getChar(), iProductionDiffNoFood, gc.getYieldInfo(YieldTypes.YIELD_PRODUCTION).getChar())
				else:
					szBuffer = u"%d%c" %(iProductionDiffNoFood, gc.getYieldInfo(YieldTypes.YIELD_PRODUCTION).getChar())
					
				screen.setLabel( "ProductionInputText", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, iCityCenterRow1X - 6, iCityCenterRow2Y, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_PRODUCTION_MOD_HELP, -1, -1 )
				screen.show( "ProductionInputText" )

				if ((pHeadSelectedCity.happyLevel() >= 0) or (pHeadSelectedCity.unhappyLevel(0) > 0)):
					if (pHeadSelectedCity.isDisorder()):
						szBuffer = u"%d%c" %(pHeadSelectedCity.angryPopulation(0), CyGame().getSymbolID(FontSymbols.ANGRY_POP_CHAR))
					elif (pHeadSelectedCity.angryPopulation(0) > 0):
						szBuffer = localText.getText("INTERFACE_CITY_UNHAPPY", (pHeadSelectedCity.happyLevel(), pHeadSelectedCity.unhappyLevel(0), pHeadSelectedCity.angryPopulation(0)))
					elif (pHeadSelectedCity.unhappyLevel(0) > 0):
						szBuffer = localText.getText("INTERFACE_CITY_HAPPY", (pHeadSelectedCity.happyLevel(), pHeadSelectedCity.unhappyLevel(0)))
					else:
						szBuffer = localText.getText("INTERFACE_CITY_HAPPY_NO_UNHAPPY", (pHeadSelectedCity.happyLevel(), ))

					screen.setLabel( "HappinessText", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, xResolution - iCityCenterRow1X + 6, iCityCenterRow2Y, -0.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_HELP_HAPPINESS, -1, -1 )
					screen.show( "HappinessText" )

				if (not(pHeadSelectedCity.isProductionProcess())):
				
					iFirst = ((float(pHeadSelectedCity.getProduction())) / (float(pHeadSelectedCity.getProductionNeeded())))
					screen.setBarPercentage( "ProductionBar", InfoBarTypes.INFOBAR_STORED, iFirst )
					if ( iFirst == 1 ):
						iSecond = ( ((float(iProductionDiffNoFood)) / (float(pHeadSelectedCity.getProductionNeeded()))) )
					else:
						iSecond = ( ((float(iProductionDiffNoFood)) / (float(pHeadSelectedCity.getProductionNeeded()))) ) / ( 1 - iFirst )
					screen.setBarPercentage( "ProductionBar", InfoBarTypes.INFOBAR_RATE, iSecond )
					if ( iFirst + iSecond == 1 ):
						screen.setBarPercentage( "ProductionBar", InfoBarTypes.INFOBAR_RATE_EXTRA, ( ((float(iProductionDiffJustFood)) / (float(pHeadSelectedCity.getProductionNeeded()))) ) )
					else:
						screen.setBarPercentage( "ProductionBar", InfoBarTypes.INFOBAR_RATE_EXTRA, ( ( ((float(iProductionDiffJustFood)) / (float(pHeadSelectedCity.getProductionNeeded()))) ) ) / ( 1 - ( iFirst + iSecond ) ) )

					screen.show( "ProductionBar" )

				iCount = 0

				for i in range(CommerceTypes.NUM_COMMERCE_TYPES):
					eCommerce = (i + 1) % CommerceTypes.NUM_COMMERCE_TYPES

					if ((gc.getPlayer(pHeadSelectedCity.getOwner()).isCommerceFlexible(eCommerce)) or (eCommerce == CommerceTypes.COMMERCE_GOLD)):
						szBuffer = u"%d.%02d %c" %(pHeadSelectedCity.getCommerceRate(eCommerce), pHeadSelectedCity.getCommerceRateTimes100(eCommerce)%100, gc.getCommerceInfo(eCommerce).getChar())

						iHappiness = pHeadSelectedCity.getCommerceHappinessByType(eCommerce)

						if (iHappiness != 0):
							if ( iHappiness > 0 ):
								szTempBuffer = u", %d%c" %(iHappiness, CyGame().getSymbolID(FontSymbols.HAPPY_CHAR))
							else:
								szTempBuffer = u", %d%c" %(-iHappiness, CyGame().getSymbolID(FontSymbols.UNHAPPY_CHAR))
							szBuffer = szBuffer + szTempBuffer

						szName = "CityPercentText" + str(iCount)
						screen.setLabel( szName, "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 220, 45 + (19 * iCount) + 4, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_COMMERCE_MOD_HELP, eCommerce, -1 )
						screen.show( szName )
						iCount = iCount + 1

				iCount = 0

############################################################
##########=MSM===Raw City Commerce Display (Sevo)=5/9===0===
############################################################
				screen.addTableControlGFC( "TradeRouteTable", 3, 10, 277, 238, 98, False, False, 32, 32, TableStyles.TABLE_STYLE_STANDARD )
				screen.setStyle( "TradeRouteTable", "Table_City_Style" )
				screen.addTableControlGFC( "BuildingListTable", 3, 10, 407, 238, yResolution - 631, False, False, 32, 32, TableStyles.TABLE_STYLE_STANDARD )
				screen.setStyle( "BuildingListTable", "Table_City_Style" )
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=5/9===X===
############################################################
				
				screen.setTableColumnHeader( "TradeRouteTable", 0, u"", 108 )
				screen.setTableColumnHeader( "TradeRouteTable", 1, u"", 118 )
				screen.setTableColumnHeader( "TradeRouteTable", 2, u"", 10 )
				screen.setTableColumnRightJustify( "TradeRouteTable", 1 )

				screen.setTableColumnHeader( "BuildingListTable", 0, u"", 108 )
				screen.setTableColumnHeader( "BuildingListTable", 1, u"", 118 )
				screen.setTableColumnHeader( "BuildingListTable", 2, u"", 10 )
				screen.setTableColumnRightJustify( "BuildingListTable", 1 )

				screen.show( "BuildingListBackground" )
				screen.show( "TradeRouteListBackground" )
				screen.show( "BuildingListLabel" )
				screen.show( "TradeRouteListLabel" )
				
				for i in range( 3 ):
					szName = "BonusPane" + str(i)
					screen.show( szName )
					szName = "BonusBack" + str(i)
					screen.show( szName )

				i = 0
				iNumBuildings = 0
				for i in range( gc.getNumBuildingInfos() ):
					if (pHeadSelectedCity.getNumBuilding(i) > 0):

						for k in range(pHeadSelectedCity.getNumBuilding(i)):
							
							szLeftBuffer = gc.getBuildingInfo(i).getDescription()
							szRightBuffer = u""
							bFirst = True
							
							if (pHeadSelectedCity.getNumActiveBuilding(i) > 0):
								iHealth = pHeadSelectedCity.getBuildingHealth(i)

								if (iHealth != 0):
									if ( bFirst == False ):
										szRightBuffer = szRightBuffer + ", "
									else:
										bFirst = False
										
									if ( iHealth > 0 ):
										szTempBuffer = u"+%d%c" %( iHealth, CyGame().getSymbolID(FontSymbols.HEALTHY_CHAR) )
										szRightBuffer = szRightBuffer + szTempBuffer
									else:
										szTempBuffer = u"+%d%c" %( -(iHealth), CyGame().getSymbolID(FontSymbols.UNHEALTHY_CHAR) )
										szRightBuffer = szRightBuffer + szTempBuffer

								iHappiness = pHeadSelectedCity.getBuildingHappiness(i)

								if (iHappiness != 0):
									if ( bFirst == False ):
										szRightBuffer = szRightBuffer + ", "
									else:
										bFirst = False
										
									if ( iHappiness > 0 ):
										szTempBuffer = u"+%d%c" %(iHappiness, CyGame().getSymbolID(FontSymbols.HAPPY_CHAR) )
										szRightBuffer = szRightBuffer + szTempBuffer
									else:
										szTempBuffer = u"+%d%c" %( -(iHappiness), CyGame().getSymbolID(FontSymbols.UNHAPPY_CHAR) )
										szRightBuffer = szRightBuffer + szTempBuffer

								for j in range( YieldTypes.NUM_YIELD_TYPES):
									iYield = gc.getBuildingInfo(i).getYieldChange(j) + pHeadSelectedCity.getNumBuilding(i) * pHeadSelectedCity.getBuildingYieldChange(gc.getBuildingInfo(i).getBuildingClassType(), j)

									if (iYield != 0):
										if ( bFirst == False ):
											szRightBuffer = szRightBuffer + ", "
										else:
											bFirst = False
											
										if ( iYield > 0 ):
											szTempBuffer = u"%s%d%c" %( "+", iYield, gc.getYieldInfo(j).getChar() )
											szRightBuffer = szRightBuffer + szTempBuffer
										else:
											szTempBuffer = u"%s%d%c" %( "", iYield, gc.getYieldInfo(j).getChar() )
											szRightBuffer = szRightBuffer + szTempBuffer

							for j in range(CommerceTypes.NUM_COMMERCE_TYPES):
								iCommerce = pHeadSelectedCity.getBuildingCommerceByBuilding(j, i) / pHeadSelectedCity.getNumBuilding(i)
	
								if (iCommerce != 0):
									if ( bFirst == False ):
										szRightBuffer = szRightBuffer + ", "
									else:
										bFirst = False
										
									if ( iCommerce > 0 ):
										szTempBuffer = u"%s%d%c" %( "+", iCommerce, gc.getCommerceInfo(j).getChar() )
										szRightBuffer = szRightBuffer + szTempBuffer
									else:
										szTempBuffer = u"%s%d%c" %( "", iCommerce, gc.getCommerceInfo(j).getChar() )
										szRightBuffer = szRightBuffer + szTempBuffer
	
							szBuffer = szLeftBuffer + "  " + szRightBuffer
							
							screen.appendTableRow( "BuildingListTable" )
							screen.setTableText( "BuildingListTable", 0, iNumBuildings, "<font=1>" + szLeftBuffer + "</font>", "", WidgetTypes.WIDGET_HELP_BUILDING, i, -1, CvUtil.FONT_LEFT_JUSTIFY )
							screen.setTableText( "BuildingListTable", 1, iNumBuildings, "<font=1>" + szRightBuffer + "</font>", "", WidgetTypes.WIDGET_HELP_BUILDING, i, -1, CvUtil.FONT_RIGHT_JUSTIFY )
							
							iNumBuildings = iNumBuildings + 1
						
				if ( iNumBuildings > g_iNumBuildings ):
					g_iNumBuildings = iNumBuildings
					
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=6/9===0===
############################################################	
				iNumTradeRoutes = 0
				iNetTradeAmount = 0
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=6/9===X===
############################################################
				
				for i in range(gc.getDefineINT("MAX_TRADE_ROUTES")):
					pLoopCity = pHeadSelectedCity.getTradeCity(i)
  
					if (pLoopCity and pLoopCity.getOwner() >= 0):
						player = gc.getPlayer(pLoopCity.getOwner())
						szLeftBuffer = u"<color=%d,%d,%d,%d>%s</color>" %(player.getPlayerTextColorR(), player.getPlayerTextColorG(), player.getPlayerTextColorB(), player.getPlayerTextColorA(), pLoopCity.getName() )
						szRightBuffer = u""

						for j in range( YieldTypes.NUM_YIELD_TYPES ):
							iTradeProfit = pHeadSelectedCity.calculateTradeYield(j, pHeadSelectedCity.calculateTradeProfit(pLoopCity))

							if (iTradeProfit != 0):
								if ( iTradeProfit > 0 ):
									szTempBuffer = u"%s%d%c" %( "+", iTradeProfit, gc.getYieldInfo(j).getChar() )
									szRightBuffer = szRightBuffer + szTempBuffer
								else:
									szTempBuffer = u"%s%d%c" %( "", iTradeProfit, gc.getYieldInfo(j).getChar() )
									szRightBuffer = szRightBuffer + szTempBuffer

						screen.appendTableRow( "TradeRouteTable" )
						screen.setTableText( "TradeRouteTable", 0, iNumTradeRoutes, "<font=1>" + szLeftBuffer + "</font>", "", WidgetTypes.WIDGET_HELP_TRADE_ROUTE_CITY, i, -1, CvUtil.FONT_LEFT_JUSTIFY )
						screen.setTableText( "TradeRouteTable", 1, iNumTradeRoutes, "<font=1>" + szRightBuffer + "</font>", "", WidgetTypes.WIDGET_HELP_TRADE_ROUTE_CITY, i, -1, CvUtil.FONT_RIGHT_JUSTIFY )
						
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=7/9===0===
############################################################
						iNumTradeRoutes = iNumTradeRoutes + 1
						iNetTradeAmount += iTradeProfit
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=7/9===X===
############################################################
						
				if ( iNumTradeRoutes > g_iNumTradeRoutes ):
					g_iNumTradeRoutes = iNumTradeRoutes

				i = 0  
				iLeftCount = 0
				iCenterCount = 0
				iRightCount = 0

				for i in range( gc.getNumBonusInfos() ):
					bHandled = False
					if ( pHeadSelectedCity.hasBonus(i) ):

						iHealth = pHeadSelectedCity.getBonusHealth(i)
						iHappiness = pHeadSelectedCity.getBonusHappiness(i)
						
						szBuffer = u""
						szLeadBuffer = u""

						szTempBuffer = u"<font=1>%c" %( gc.getBonusInfo(i).getChar() )
						szLeadBuffer = szLeadBuffer + szTempBuffer
						
						if (pHeadSelectedCity.getNumBonuses(i) > 1):
							szTempBuffer = u"(%d)" %( pHeadSelectedCity.getNumBonuses(i) )
							szLeadBuffer = szLeadBuffer + szTempBuffer

						szLeadBuffer = szLeadBuffer + "</font>"
						
						if (iHappiness != 0):
							if ( iHappiness > 0 ):
								szTempBuffer = u"<font=1>+%d%c</font>" %(iHappiness, CyGame().getSymbolID(FontSymbols.HAPPY_CHAR) )
							else:
								szTempBuffer = u"<font=1>+%d%c</font>" %( -iHappiness, CyGame().getSymbolID(FontSymbols.UNHAPPY_CHAR) )

							if ( iHealth > 0 ):
								szTempBuffer += u"<font=1>, +%d%c</font>" %( iHealth, CyGame().getSymbolID( FontSymbols.HEALTHY_CHAR ) )

							szName = "RightBonusItemLeft" + str(iRightCount)
							screen.setLabelAt( szName, "BonusBack2", szLeadBuffer, CvUtil.FONT_LEFT_JUSTIFY, 0, (iRightCount * 20) + 4, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BONUS, i, -1 )
							szName = "RightBonusItemRight" + str(iRightCount)
							screen.setLabelAt( szName, "BonusBack2", szTempBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 102, (iRightCount * 20) + 4, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BONUS, i, -1 )
							
							iRightCount = iRightCount + 1

							bHandled = True

						if (iHealth != 0 and bHandled == False):
							if ( iHealth > 0 ):
								szTempBuffer = u"<font=1>+%d%c</font>" %( iHealth, CyGame().getSymbolID( FontSymbols.HEALTHY_CHAR ) )
							else:
								szTempBuffer = u"<font=1>+%d%c</font>" %( -iHealth, CyGame().getSymbolID(FontSymbols.UNHEALTHY_CHAR) )
								
							szName = "CenterBonusItemLeft" + str(iCenterCount)
							screen.setLabelAt( szName, "BonusBack1", szLeadBuffer, CvUtil.FONT_LEFT_JUSTIFY, 0, (iCenterCount * 20) + 4, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BONUS, i, -1 )
							szName = "CenterBonusItemRight" + str(iCenterCount)
							screen.setLabelAt( szName, "BonusBack1", szTempBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 62, (iCenterCount * 20) + 4, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BONUS, i, -1 )
							
							iCenterCount = iCenterCount + 1

							bHandled = True

						szBuffer = u""
						if ( not bHandled ):
						
							szName = "LeftBonusItem" + str(iLeftCount)
							screen.setLabelAt( szName, "BonusBack0", szLeadBuffer, CvUtil.FONT_LEFT_JUSTIFY, 0, (iLeftCount * 20) + 4, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_PEDIA_JUMP_TO_BONUS, i, -1 )
							
							iLeftCount = iLeftCount + 1

							bHandled = True

				g_iNumLeftBonus = iLeftCount
				g_iNumCenterBonus = iCenterCount
				g_iNumRightBonus = iRightCount
				
				iMaintenance = pHeadSelectedCity.getMaintenanceTimes100()

				szBuffer = localText.getText("INTERFACE_CITY_MAINTENANCE", ())
				
				screen.setLabel( "MaintenanceText", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, 15, 126, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_HELP_MAINTENANCE, -1, -1 )
				screen.show( "MaintenanceText" )
				
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=8/9===0===
############################################################
				szBuffer = "Plot Raw Commerce:"
				screen.setLabel( "MaintenanceTextb", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, 15, 160, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTextb" )

				szBuffer = localText.getText("TXT_KEY_HEADING_TRADEROUTE_LIST", ()) + ":"
				screen.setLabel( "MaintenanceTextc", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, 15, 180, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTextc" )

				szBuffer = localText.getText("TXT_KEY_CONCEPT_BUILDINGS", ()) + localText.getText("TXT_KEY_AND", ()) + localText.getText("TXT_KEY_CONCEPT_SPECIALISTS", ()) + ":"
				screen.setLabel( "MaintenanceTextd", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, 15, 200, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTextd" )

				szBuffer = "<color=205,180,55,255>Net Raw Commerce:</color>"
				screen.setLabel( "MaintenanceTexte", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, 15, 220, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTexte" )

				myLittleYield = 0
				# I'd like to get the net plot info, but CyPlot.getYield is all !@#$ up.  It doesn't seem to work at all.
				# Calculate the building & Specialist info instead.
				for ii in range (gc.getNumBuildingInfos()):
					if (pHeadSelectedCity.getNumBuilding(ii) > 0):
						myLittleYield += gc.getBuildingInfo(ii).getYieldChange(2)
				
														
				# Show Plot Commerces
				szBuffer = u"%s%d %c" %( "+", pHeadSelectedCity.getYieldRate(2) - myLittleYield - pHeadSelectedCity.getExtraSpecialistYield(2)-iNetTradeAmount, gc.getYieldInfo(2).getChar())
				screen.setLabel( "MaintenanceTextf", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 225, 160, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTextg" )
				
				# Show  trade route commerces
				szBuffer = u"%s%d %c" %( "+", iNetTradeAmount, gc.getYieldInfo(2).getChar() )
				screen.setLabel( "MaintenanceTextg", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 225, 180, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTextf" )

				# Show Modifiers
				szBuffer = u"%s%d %c" %( "+", myLittleYield + pHeadSelectedCity.getExtraSpecialistYield(2), gc.getYieldInfo(2).getChar())
				screen.setLabel( "MaintenanceTexth", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 225, 200, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTextf" )
	
				# Show Total Net Commerce
				szBuffer = u"<color=205,180,55,255>%s%d</color> %c" %( "=", pHeadSelectedCity.getYieldRate(2), gc.getYieldInfo(2).getChar() )
				screen.setLabel( "MaintenanceTexti", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 225, 220, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.show( "MaintenanceTextg" )
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=8/9===X===
############################################################
				
				szBuffer = u"-%d.%02d %c" %(iMaintenance/100, iMaintenance%100, gc.getCommerceInfo(CommerceTypes.COMMERCE_GOLD).getChar())
				screen.setLabel( "MaintenanceAmountText", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, 220, 125, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_HELP_MAINTENANCE, -1, -1 )
				screen.show( "MaintenanceAmountText" )

				szBuffer = u""

				# Number Changed for Shinto Mod: i * 34 Changed to i * 20.
				for i in range(gc.getNumReligionInfos()):
					xCoord = xResolution - 242 + (i * 20)
					yCoord = 42
					
					bEnable = True
						
					if (pHeadSelectedCity.isHasReligion(i)):
						if (pHeadSelectedCity.isHolyCityByType(i)):
							szTempBuffer = u"%c" %(gc.getReligionInfo(i).getHolyCityChar())
							szName = "ReligionHolyCityDDS" + str(i)
							screen.show( szName )
						else:
							szTempBuffer = u"%c" %(gc.getReligionInfo(i).getChar())
						szBuffer = szBuffer + szTempBuffer

						j = 0
						for j in range(CommerceTypes.NUM_COMMERCE_TYPES):
							iCommerce = pHeadSelectedCity.getReligionCommerceByReligion(j, i)

							if (iCommerce != 0):
								if ( iCommerce > 0 ):
									szTempBuffer = u",%s%d%c" %("+", iCommerce, gc.getCommerceInfo(j).getChar() )
									szBuffer = szBuffer + szTempBuffer
								else:
									szTempBuffer = u",%s%d%c" %( "", iCommerce, gc.getCommerceInfo(j).getChar() )
									szBuffer = szBuffer + szTempBuffer

						iHappiness = pHeadSelectedCity.getReligionHappiness(i)

						if (iHappiness != 0):
							if ( iHappiness > 0 ):
								szTempBuffer = u",+%d%c" %(iHappiness, CyGame().getSymbolID(FontSymbols.HAPPY_CHAR) )
								szBuffer = szBuffer + szTempBuffer
							else:
								szTempBuffer = u",+%d%c" %(-(iHappiness), CyGame().getSymbolID(FontSymbols.UNHAPPY_CHAR) )
								szBuffer = szBuffer + szTempBuffer

						szBuffer = szBuffer + " "
						
						szButton = gc.getReligionInfo(i).getButton()
					
					else:
					
						bEnable = False
						szButton = gc.getReligionInfo(i).getButton()

					# Number Changed for Shinto Mod: 24, 24 Changed to 18, 18.
					szName = "ReligionDDS" + str(i)
					screen.setImageButton( szName, szButton, xCoord, yCoord, 18, 18, WidgetTypes.WIDGET_HELP_RELIGION_CITY, i, -1 )
					screen.enable( szName, bEnable )
					screen.show( szName )

				# Number Changed for Shinto Mod: i * 34 Changed to i * 20.
				for i in range(gc.getNumCorporationInfos()):
					xCoord = xResolution - 242 + (i * 20)
					yCoord = 66
					
					bEnable = True
						
					if (pHeadSelectedCity.isHasCorporation(i)):
						if (pHeadSelectedCity.isHeadquartersByType(i)):
							szTempBuffer = u"%c" %(gc.getCorporationInfo(i).getHeadquarterChar())
							szName = "CorporationHeadquarterDDS" + str(i)
							screen.show( szName )
						else:
							szTempBuffer = u"%c" %(gc.getCorporationInfo(i).getChar())
						szBuffer = szBuffer + szTempBuffer

						for j in range(YieldTypes.NUM_YIELD_TYPES):
							iYield = pHeadSelectedCity.getCorporationYieldByCorporation(j, i)

							if (iYield != 0):
								if ( iYield > 0 ):
									szTempBuffer = u",%s%d%c" %("+", iYield, gc.getYieldInfo(j).getChar() )
									szBuffer = szBuffer + szTempBuffer
								else:
									szTempBuffer = u",%s%d%c" %( "", iYield, gc.getYieldInfo(j).getChar() )
									szBuffer = szBuffer + szTempBuffer
						
						for j in range(CommerceTypes.NUM_COMMERCE_TYPES):
							iCommerce = pHeadSelectedCity.getCorporationCommerceByCorporation(j, i)

							if (iCommerce != 0):
								if ( iCommerce > 0 ):
									szTempBuffer = u",%s%d%c" %("+", iCommerce, gc.getCommerceInfo(j).getChar() )
									szBuffer = szBuffer + szTempBuffer
								else:
									szTempBuffer = u",%s%d%c" %( "", iCommerce, gc.getCommerceInfo(j).getChar() )
									szBuffer = szBuffer + szTempBuffer

						szBuffer += " "
						
						szButton = gc.getCorporationInfo(i).getButton()
					
					else:
					
						bEnable = False
						szButton = gc.getCorporationInfo(i).getButton()

					# Number Changed for Shinto Mod: 24, 24 Changed to 18, 18.
					szName = "CorporationDDS" + str(i)
					screen.setImageButton( szName, szButton, xCoord, yCoord, 18, 18, WidgetTypes.WIDGET_HELP_CORPORATION_CITY, i, -1 )
					screen.enable( szName, bEnable )
					screen.show( szName )

				szBuffer = u"%d%% %s" %(pHeadSelectedCity.plot().calculateCulturePercent(pHeadSelectedCity.getOwner()), gc.getPlayer(pHeadSelectedCity.getOwner()).getCivilizationAdjective(0) )
				screen.setLabel( "NationalityText", "Background", szBuffer, CvUtil.FONT_CENTER_JUSTIFY, 125, yResolution - 210, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
				screen.setHitTest( "NationalityText", HitTestTypes.HITTEST_NOHIT )
				screen.show( "NationalityText" )
				iRemainder = 0
				iWhichBar = 0
				for h in range( gc.getMAX_PLAYERS() ):
					if ( gc.getPlayer(h).isAlive() ):
						fPercent = pHeadSelectedCity.plot().calculateCulturePercent(h)
						if ( fPercent != 0 ):
							fPercent = fPercent / 100.0
							screen.setStackedBarColorsRGB( "NationalityBar", iWhichBar, gc.getPlayer(h).getPlayerTextColorR(), gc.getPlayer(h).getPlayerTextColorG(), gc.getPlayer(h).getPlayerTextColorB(), gc.getPlayer(h).getPlayerTextColorA() )
							if ( iRemainder == 1 ):
								screen.setBarPercentage( "NationalityBar", iWhichBar, fPercent )
							else:
								screen.setBarPercentage( "NationalityBar", iWhichBar, fPercent / ( 1 - iRemainder ) )
							iRemainder += fPercent
							iWhichBar += 1
				screen.show( "NationalityBar" )

				iDefenseModifier = pHeadSelectedCity.getDefenseModifier(False)

				if (iDefenseModifier != 0):
					szBuffer = localText.getText("TXT_KEY_MAIN_CITY_DEFENSE", (CyGame().getSymbolID(FontSymbols.DEFENSE_CHAR), iDefenseModifier))
					
					if (pHeadSelectedCity.getDefenseDamage() > 0):
						szTempBuffer = u" (%d%%)" %( ( ( gc.getMAX_CITY_DEFENSE_DAMAGE() - pHeadSelectedCity.getDefenseDamage() ) * 100 ) / gc.getMAX_CITY_DEFENSE_DAMAGE() )
						szBuffer = szBuffer + szTempBuffer
					szNewBuffer = "<font=4>"
					szNewBuffer = szNewBuffer + szBuffer
					szNewBuffer = szNewBuffer + "</font>"
					screen.setLabel( "DefenseText", "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 270, 40, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_HELP_DEFENSE, -1, -1 )
					screen.show( "DefenseText" )

				if ( pHeadSelectedCity.getCultureLevel != CultureLevelTypes.NO_CULTURELEVEL ):
					iRate = pHeadSelectedCity.getCommerceRateTimes100(CommerceTypes.COMMERCE_CULTURE)
					if (iRate%100 == 0):
						szBuffer = localText.getText("INTERFACE_CITY_COMMERCE_RATE", (gc.getCommerceInfo(CommerceTypes.COMMERCE_CULTURE).getChar(), gc.getCultureLevelInfo(pHeadSelectedCity.getCultureLevel()).getTextKey(), iRate/100))
					else:
						szRate = u"+%d.%02d" % (iRate/100, iRate%100)
						szBuffer = localText.getText("INTERFACE_CITY_COMMERCE_RATE_FLOAT", (gc.getCommerceInfo(CommerceTypes.COMMERCE_CULTURE).getChar(), gc.getCultureLevelInfo(pHeadSelectedCity.getCultureLevel()).getTextKey(), szRate))
############################################################
##########=MSM===City Expansion Turns===0===
############################################################
					if g_bCityExpansionTurns:
						iCulRate =  pHeadSelectedCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE)
						if ( iCulRate > 0 ):
							iCulNext = pHeadSelectedCity.getCultureThreshold()
							iCulNow = pHeadSelectedCity.getCulture(pHeadSelectedCity.getOwner())
							iCulTurns = (iCulNext-iCulNow+iCulRate-1)/iCulRate
							#iCulTurns = (iCulNext-iCulNow+iCulRate/100-1)/(iCulRate/100)
							szTurnsToComplete = " [%d]" %(iCulTurns)
							szBuffer = szBuffer + szTurnsToComplete
							#szTurnsToComplete = ""
############################################################
##########=MSM===City Expansion Turns===X===
############################################################
					screen.setLabel( "CultureText", "Background", szBuffer, CvUtil.FONT_CENTER_JUSTIFY, 125, yResolution - 184, -1.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.setHitTest( "CultureText", HitTestTypes.HITTEST_NOHIT )
					screen.show( "CultureText" )

				if ((pHeadSelectedCity.getGreatPeopleProgress() > 0) or (pHeadSelectedCity.getGreatPeopleRate() > 0)):
					szBuffer = localText.getText("INTERFACE_CITY_GREATPEOPLE_RATE", (CyGame().getSymbolID(FontSymbols.GREAT_PEOPLE_CHAR), pHeadSelectedCity.getGreatPeopleRate()))
############################################################
##########=MSM===GP Birth Turns===0===
############################################################
					if g_bGPBirthTurns:
						iGPRate = pHeadSelectedCity.getGreatPeopleRate()
						if ( iGPRate > 0 ):
							iGPNext = gc.getPlayer(pHeadSelectedCity.getOwner()).greatPeopleThreshold(false)
							iGPNow = pHeadSelectedCity.getGreatPeopleProgress()
							iGPTurns = (iGPNext-iGPNow+iGPRate-1)/iGPRate
							szTurnsToComplete = " [%d]" %(iGPTurns)
							szBuffer = szBuffer + szTurnsToComplete
							#szTurnsToComplete = ""
############################################################
##########=MSM===GP Birth Turns===X===
############################################################

					screen.setLabel( "GreatPeopleText", "Background", szBuffer, CvUtil.FONT_CENTER_JUSTIFY, xResolution - 146, yResolution - 176, -1.3, FontTypes.GAME_FONT, WidgetTypes.WIDGET_GENERAL, -1, -1 )
					screen.setHitTest( "GreatPeopleText", HitTestTypes.HITTEST_NOHIT )
					screen.show( "GreatPeopleText" )

					iFirst = float(pHeadSelectedCity.getGreatPeopleProgress()) / float( gc.getPlayer( pHeadSelectedCity.getOwner() ).greatPeopleThreshold(false) )
					screen.setBarPercentage( "GreatPeopleBar", InfoBarTypes.INFOBAR_STORED, iFirst )
					if ( iFirst == 1 ):
						screen.setBarPercentage( "GreatPeopleBar", InfoBarTypes.INFOBAR_RATE, ( float(pHeadSelectedCity.getGreatPeopleRate()) / float( gc.getPlayer( pHeadSelectedCity.getOwner() ).greatPeopleThreshold(false) ) ) )
					else:
						screen.setBarPercentage( "GreatPeopleBar", InfoBarTypes.INFOBAR_RATE, ( ( float(pHeadSelectedCity.getGreatPeopleRate()) / float( gc.getPlayer( pHeadSelectedCity.getOwner() ).greatPeopleThreshold(false) ) ) ) / ( 1 - iFirst ) )
					screen.show( "GreatPeopleBar" )

				iFirst = float(pHeadSelectedCity.getCultureTimes100(pHeadSelectedCity.getOwner())) / float(100 * pHeadSelectedCity.getCultureThreshold())
				screen.setBarPercentage( "CultureBar", InfoBarTypes.INFOBAR_STORED, iFirst )
				if ( iFirst == 1 ):
					screen.setBarPercentage( "CultureBar", InfoBarTypes.INFOBAR_RATE, ( float(pHeadSelectedCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE)) / float(pHeadSelectedCity.getCultureThreshold()) ) )
				else:
					screen.setBarPercentage( "CultureBar", InfoBarTypes.INFOBAR_RATE, ( ( float(pHeadSelectedCity.getCommerceRate(CommerceTypes.COMMERCE_CULTURE)) / float(pHeadSelectedCity.getCultureThreshold()) ) ) / ( 1 - iFirst ) )
				screen.show( "CultureBar" )
				
		else:
		
			# Help Text Area
			if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
				screen.setHelpTextArea( 350, FontTypes.SMALL_FONT, 7, yResolution - 172, -0.1, False, "", True, False, CvUtil.FONT_LEFT_JUSTIFY, 150 )
			else:
				screen.setHelpTextArea( 350, FontTypes.SMALL_FONT, 7, yResolution - 50, -0.1, False, "", True, False, CvUtil.FONT_LEFT_JUSTIFY, 150 )

			screen.hide( "InterfaceTopLeftBackgroundWidget" )
			screen.hide( "InterfaceTopRightBackgroundWidget" )
			screen.hide( "InterfaceCenterLeftBackgroundWidget" )
			screen.hide( "CityScreenTopWidget" )
			screen.hide( "CityNameBackground" )
			screen.hide( "TopCityPanelLeft" )
			screen.hide( "TopCityPanelRight" )
			screen.hide( "CityScreenAdjustPanel" )

############################################################
##########=MSM===Raw City Commerce Display (Sevo)=9/9===0===
############################################################
			screen.hide( "CityScreenAdjustPanelb" )
############################################################
##########=MSM===Raw City Commerce Display (Sevo)=9/9===X===
############################################################

			screen.hide( "InterfaceCenterRightBackgroundWidget" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===9/9===0===
############################################################
			screen.hide( "MainCityScrollMinus" )
			screen.hide( "MainCityScrollPlus" )
############################################################
##########=MSM===Main City Scroll (SimCutie)===9/9===X===
############################################################
			
			if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
				self.setMinimapButtonVisibility(True)

		return 0
		
	# Will update the info pane strings
	def updateInfoPaneStrings( self ):
	
		iRow = 0
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		pHeadSelectedCity = CyInterface().getHeadSelectedCity()
		pHeadSelectedUnit = CyInterface().getHeadSelectedUnit()
		
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		bShift = CyInterface().shiftKey()

		screen.addPanel( "SelectedUnitPanel", u"", u"", True, False, 8, yResolution - 140, 280, 130, PanelStyles.PANEL_STYLE_STANDARD )
		screen.setStyle( "SelectedUnitPanel", "Panel_Game_HudStat_Style" )
		screen.hide( "SelectedUnitPanel" )

		screen.addTableControlGFC( "SelectedUnitText", 3, 10, yResolution - 109, 183, 102, False, False, 32, 32, TableStyles.TABLE_STYLE_STANDARD )
		screen.setStyle( "SelectedUnitText", "Table_EmptyScroll_Style" )
		screen.hide( "SelectedUnitText" )
		screen.hide( "SelectedUnitLabel" )
		
		screen.addTableControlGFC( "SelectedCityText", 3, 10, yResolution - 139, 183, 128, False, False, 32, 32, TableStyles.TABLE_STYLE_STANDARD )
		screen.setStyle( "SelectedCityText", "Table_EmptyScroll_Style" )
		screen.hide( "SelectedCityText" )
		
		for i in range(gc.getNumPromotionInfos()):
			szName = "PromotionButton" + str(i)
			screen.hide( szName )
		
		if CyEngine().isGlobeviewUp():
			return

		if (pHeadSelectedCity):
		
			iOrders = CyInterface().getNumOrdersQueued()

			screen.setTableColumnHeader( "SelectedCityText", 0, u"", 121 )
			screen.setTableColumnHeader( "SelectedCityText", 1, u"", 54 )
			screen.setTableColumnHeader( "SelectedCityText", 2, u"", 10 )
			screen.setTableColumnRightJustify( "SelectedCityText", 1 )
			
			for i in range( iOrders ):
				
				szLeftBuffer = u""
				szRightBuffer = u""
				
				if ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_TRAIN ):
					szLeftBuffer = gc.getUnitInfo(CyInterface().getOrderNodeData1(i)).getDescription()
					szRightBuffer = "(" + str(pHeadSelectedCity.getUnitProductionTurnsLeft(CyInterface().getOrderNodeData1(i), i)) + ")"

					if (CyInterface().getOrderNodeSave(i)):
						szLeftBuffer = u"*" + szLeftBuffer

				elif ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_CONSTRUCT ):
					szLeftBuffer = gc.getBuildingInfo(CyInterface().getOrderNodeData1(i)).getDescription()
					szRightBuffer = "(" + str(pHeadSelectedCity.getBuildingProductionTurnsLeft(CyInterface().getOrderNodeData1(i), i)) + ")"

				elif ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_CREATE ):
					szLeftBuffer = gc.getProjectInfo(CyInterface().getOrderNodeData1(i)).getDescription()
					szRightBuffer = "(" + str(pHeadSelectedCity.getProjectProductionTurnsLeft(CyInterface().getOrderNodeData1(i), i)) + ")"

				elif ( CyInterface().getOrderNodeType(i) == OrderTypes.ORDER_MAINTAIN ):
					szLeftBuffer = gc.getProcessInfo(CyInterface().getOrderNodeData1(i)).getDescription()

				screen.appendTableRow( "SelectedCityText" )
				screen.setTableText( "SelectedCityText", 0, iRow, szLeftBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, i, -1, CvUtil.FONT_LEFT_JUSTIFY )
				screen.setTableText( "SelectedCityText", 1, iRow, szRightBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, i, -1, CvUtil.FONT_RIGHT_JUSTIFY )
				screen.show( "SelectedCityText" )
				screen.show( "SelectedUnitPanel" )
				iRow += 1

		elif (pHeadSelectedUnit and CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW):
		
			screen.setTableColumnHeader( "SelectedUnitText", 0, u"", 100 )
			screen.setTableColumnHeader( "SelectedUnitText", 1, u"", 75 )
			screen.setTableColumnHeader( "SelectedUnitText", 2, u"", 10 )
			screen.setTableColumnRightJustify( "SelectedUnitText", 1 )
			
			if (CyInterface().mirrorsSelectionGroup()):
				pSelectedGroup = pHeadSelectedUnit.getGroup()
			else:
				pSelectedGroup = 0

			if (CyInterface().getLengthSelectionList() > 1):
			
				screen.setText( "SelectedUnitLabel", "Background", localText.getText("TXT_KEY_UNIT_STACK", (CyInterface().getLengthSelectionList(), )), CvUtil.FONT_LEFT_JUSTIFY, 18, yResolution - 137, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_UNIT_NAME, -1, -1 )
				
				if ((pSelectedGroup == 0) or (pSelectedGroup.getLengthMissionQueue() <= 1)):
					if (pHeadSelectedUnit):
						for i in range(gc.getNumUnitInfos()):
							iCount = CyInterface().countEntities(i)

							if (iCount > 0):
								szRightBuffer = u""
								
								szLeftBuffer = gc.getUnitInfo(i).getDescription()

								if (iCount > 1):
									szRightBuffer = u"(" + str(iCount) + u")"

								szBuffer = szLeftBuffer + u"  " + szRightBuffer
								screen.appendTableRow( "SelectedUnitText" )
								screen.setTableText( "SelectedUnitText", 0, iRow, szLeftBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, i, -1, CvUtil.FONT_LEFT_JUSTIFY )
								screen.setTableText( "SelectedUnitText", 1, iRow, szRightBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, i, -1, CvUtil.FONT_RIGHT_JUSTIFY )
								screen.show( "SelectedUnitText" )
								screen.show( "SelectedUnitPanel" )
								iRow += 1
			else:
			
				if (pHeadSelectedUnit.getHotKeyNumber() == -1):
					szBuffer = localText.getText("INTERFACE_PANE_UNIT_NAME", (pHeadSelectedUnit.getName(), ))
				else:
					szBuffer = localText.getText("INTERFACE_PANE_UNIT_NAME_HOT_KEY", (pHeadSelectedUnit.getHotKeyNumber(), pHeadSelectedUnit.getName()))
				if (len(szBuffer) > 60):
					szBuffer = "<font=2>" + szBuffer + "</font>"
				screen.setText( "SelectedUnitLabel", "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, 18, yResolution - 137, -0.1, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_UNIT_NAME, -1, -1 )
			
				if ((pSelectedGroup == 0) or (pSelectedGroup.getLengthMissionQueue() <= 1)):
					screen.show( "SelectedUnitText" )
					screen.show( "SelectedUnitPanel" )

					szBuffer = u""

					szLeftBuffer = u""
					szRightBuffer = u""
					
					if (pHeadSelectedUnit.getDomainType() == DomainTypes.DOMAIN_AIR):
						if (pHeadSelectedUnit.airBaseCombatStr() > 0):
							szLeftBuffer = localText.getText("INTERFACE_PANE_AIR_STRENGTH", ())
							if (pHeadSelectedUnit.isFighting()):
								szRightBuffer = u"?/%d%c" %(pHeadSelectedUnit.airBaseCombatStr(), CyGame().getSymbolID(FontSymbols.STRENGTH_CHAR))
							elif (pHeadSelectedUnit.isHurt()):
								szRightBuffer = u"%.1f/%d%c" %(((float(pHeadSelectedUnit.airBaseCombatStr() * pHeadSelectedUnit.currHitPoints())) / (float(pHeadSelectedUnit.maxHitPoints()))), pHeadSelectedUnit.airBaseCombatStr(), CyGame().getSymbolID(FontSymbols.STRENGTH_CHAR))
							else:
								szRightBuffer = u"%d%c" %(pHeadSelectedUnit.airBaseCombatStr(), CyGame().getSymbolID(FontSymbols.STRENGTH_CHAR))
					else:
						if (pHeadSelectedUnit.canFight()):
							szLeftBuffer = localText.getText("INTERFACE_PANE_STRENGTH", ())
							if (pHeadSelectedUnit.isFighting()):
								szRightBuffer = u"?/%d%c" %(pHeadSelectedUnit.baseCombatStr(), CyGame().getSymbolID(FontSymbols.STRENGTH_CHAR))
							elif (pHeadSelectedUnit.isHurt()):
								szRightBuffer = u"%.1f/%d%c" %(((float(pHeadSelectedUnit.baseCombatStr() * pHeadSelectedUnit.currHitPoints())) / (float(pHeadSelectedUnit.maxHitPoints()))), pHeadSelectedUnit.baseCombatStr(), CyGame().getSymbolID(FontSymbols.STRENGTH_CHAR))
							else:
								szRightBuffer = u"%d%c" %(pHeadSelectedUnit.baseCombatStr(), CyGame().getSymbolID(FontSymbols.STRENGTH_CHAR))

					szBuffer = szLeftBuffer + szRightBuffer
					if ( szBuffer ):
						screen.appendTableRow( "SelectedUnitText" )
						screen.setTableText( "SelectedUnitText", 0, iRow, szLeftBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_LEFT_JUSTIFY )
						screen.setTableText( "SelectedUnitText", 1, iRow, szRightBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY )
						screen.show( "SelectedUnitText" )
						screen.show( "SelectedUnitPanel" )
						iRow += 1

					szLeftBuffer = u""
					szRightBuffer = u""
				
					if ( (pHeadSelectedUnit.movesLeft() % gc.getMOVE_DENOMINATOR()) > 0 ):
						iDenom = 1
					else:
						iDenom = 0
					iCurrMoves = ((pHeadSelectedUnit.movesLeft() / gc.getMOVE_DENOMINATOR()) + iDenom )
					szLeftBuffer = localText.getText("INTERFACE_PANE_MOVEMENT", ())
					if (pHeadSelectedUnit.baseMoves() == iCurrMoves):
						szRightBuffer = u"%d%c" %(pHeadSelectedUnit.baseMoves(), CyGame().getSymbolID(FontSymbols.MOVES_CHAR) )
					else:
						szRightBuffer = u"%d/%d%c" %(iCurrMoves, pHeadSelectedUnit.baseMoves(), CyGame().getSymbolID(FontSymbols.MOVES_CHAR) )

					szBuffer = szLeftBuffer + "  " + szRightBuffer
					screen.appendTableRow( "SelectedUnitText" )
					screen.setTableText( "SelectedUnitText", 0, iRow, szLeftBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_LEFT_JUSTIFY )
					screen.setTableText( "SelectedUnitText", 1, iRow, szRightBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY )
					screen.show( "SelectedUnitText" )
					screen.show( "SelectedUnitPanel" )
					iRow += 1

					if (pHeadSelectedUnit.getLevel() > 0):
					
						szLeftBuffer = localText.getText("INTERFACE_PANE_LEVEL", ())
						szRightBuffer = u"%d" %(pHeadSelectedUnit.getLevel())
						
						szBuffer = szLeftBuffer + "  " + szRightBuffer
						screen.appendTableRow( "SelectedUnitText" )
						screen.setTableText( "SelectedUnitText", 0, iRow, szLeftBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_LEFT_JUSTIFY )
						screen.setTableText( "SelectedUnitText", 1, iRow, szRightBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY )
						screen.show( "SelectedUnitText" )
						screen.show( "SelectedUnitPanel" )
						iRow += 1

					if ((pHeadSelectedUnit.getExperience() > 0) and not pHeadSelectedUnit.isFighting()):
						szLeftBuffer = localText.getText("INTERFACE_PANE_EXPERIENCE", ())
						szRightBuffer = u"(%d/%d)" %(pHeadSelectedUnit.getExperience(), pHeadSelectedUnit.experienceNeeded())
						szBuffer = szLeftBuffer + "  " + szRightBuffer
						screen.appendTableRow( "SelectedUnitText" )
						screen.setTableText( "SelectedUnitText", 0, iRow, szLeftBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_LEFT_JUSTIFY )
						screen.setTableText( "SelectedUnitText", 1, iRow, szRightBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, -1, -1, CvUtil.FONT_RIGHT_JUSTIFY )
						screen.show( "SelectedUnitText" )
						screen.show( "SelectedUnitPanel" )
						iRow += 1

					iPromotionCount = 0
					i = 0
					for i in range(gc.getNumPromotionInfos()):
						if (pHeadSelectedUnit.isHasPromotion(i)):
							szName = "PromotionButton" + str(i)
							self.setPromotionButtonPosition( szName, iPromotionCount )
							screen.moveToFront( szName )
							screen.show( szName )

							iPromotionCount = iPromotionCount + 1

			if (pSelectedGroup):
			
				iNodeCount = pSelectedGroup.getLengthMissionQueue()

				if (iNodeCount > 1):
					for i in range( iNodeCount ):
						szLeftBuffer = u""
						szRightBuffer = u""
					
						if (gc.getMissionInfo(pSelectedGroup.getMissionType(i)).isBuild()):
							if (i == 0):
								szLeftBuffer = gc.getBuildInfo(pSelectedGroup.getMissionData1(i)).getDescription()
								szRightBuffer = localText.getText("INTERFACE_CITY_TURNS", (pSelectedGroup.plot().getBuildTurnsLeft(pSelectedGroup.getMissionData1(i), 0, 0), ))								
							else:
								szLeftBuffer = u"%s..." %(gc.getBuildInfo(pSelectedGroup.getMissionData1(i)).getDescription())
						else:
							szLeftBuffer = u"%s..." %(gc.getMissionInfo(pSelectedGroup.getMissionType(i)).getDescription())

						szBuffer = szLeftBuffer + "  " + szRightBuffer
						screen.appendTableRow( "SelectedUnitText" )
						screen.setTableText( "SelectedUnitText", 0, iRow, szLeftBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, i, -1, CvUtil.FONT_LEFT_JUSTIFY )
						screen.setTableText( "SelectedUnitText", 1, iRow, szRightBuffer, "", WidgetTypes.WIDGET_HELP_SELECTED, i, -1, CvUtil.FONT_RIGHT_JUSTIFY )
						screen.show( "SelectedUnitText" )
						screen.show( "SelectedUnitPanel" )
						iRow += 1

		return 0
		
	# Will update the scores
	def updateScoreStrings( self ):
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		screen.hide( "ScoreBackground" )
		
		for i in range( gc.getMAX_PLAYERS() ):
			szName = "ScoreText" + str(i)
			screen.hide( szName )

		iWidth = 0
		iCount = 0
		iBtnHeight = 22
		
		if ((CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_MINIMAP_ONLY)):
			if (CyInterface().isScoresVisible() and not CyInterface().isCityScreenUp() and CyEngine().isGlobeviewUp() == false):

# Dale - RtW: START
				i = 17#gc.getMAX_CIV_TEAMS() - 1
# Dale - RtW: END
				while (i > -1):
					eTeam = gc.getGame().getRankTeam(i)

					if (gc.getTeam(gc.getGame().getActiveTeam()).isHasMet(eTeam) or gc.getTeam(eTeam).isHuman() or gc.getGame().isDebugMode()):
						j = gc.getMAX_CIV_PLAYERS() - 1
						while (j > -1):
							ePlayer = gc.getGame().getRankPlayer(j)

							if (not CyInterface().isScoresMinimized() or gc.getGame().getActivePlayer() == ePlayer):
								if (gc.getPlayer(ePlayer).isAlive() and not gc.getPlayer(ePlayer).isMinorCiv()):

									if (gc.getPlayer(ePlayer).getTeam() == eTeam):
										szBuffer = u"<font=2>"

										if (gc.getGame().isGameMultiPlayer()):
											if (not (gc.getPlayer(ePlayer).isTurnActive())):
												szBuffer = szBuffer + "*"

#----------Dimon157 F4 1/1 0
										if (g_iShowF4 > 0):
											bSpaceBeforScore = false
											# Tech
											if (gc.getPlayer(ePlayer).isAlive() and ePlayer != CyGame().getActivePlayer() and (gc.getTeam(gc.getPlayer(ePlayer).getTeam()).isHasMet(gc.getPlayer(CyGame().getActivePlayer()).getTeam()) or gc.getGame().isDebugMode()) and not gc.getPlayer(ePlayer).isBarbarian() and not gc.getPlayer(ePlayer).isMinorCiv()):
												if (not(not gc.getTeam(gc.getPlayer(CyGame().getActivePlayer()).getTeam()).isTechTrading() and not gc.getTeam(gc.getPlayer(ePlayer).getTeam()).isTechTrading() and not gc.getGame().isDebugMode())):
													listTradeable = []
													listUntradeable = []
													listTradeNotAllowed = []						
													tradeData = TradeData()
													tradeData.ItemType = TradeableItems.TRADE_TECHNOLOGIES
													for iLoopTech in range(gc.getNumTechInfos()):
														tradeData.iData = iLoopTech
														if (gc.getPlayer(ePlayer).canTradeItem(CyGame().getActivePlayer(), tradeData, False)):
															if (gc.getPlayer(ePlayer).getTradeDenial(CyGame().getActivePlayer(), tradeData) == DenialTypes.NO_DENIAL):
																listTradeable.append(iLoopTech)
															else:
																listUntradeable.append(iLoopTech)
														elif (gc.getTeam(gc.getPlayer(ePlayer).getTeam()).isHasTech(iLoopTech) and gc.getPlayer(CyGame().getActivePlayer()).canResearch(iLoopTech, False)):
															listTradeNotAllowed.append(iLoopTech)
													
													# Can Trade Tech
													if (len(listTradeable) > 0):
														szBuffer += u"%c" % gc.getCommerceInfo(CommerceTypes.COMMERCE_RESEARCH).getChar()
													# Can't Trade & Won't Trade Tech 
													#elif (len(listUntradeable) > 0) or (len(listTradeNotAllowed) > 0):
													#	szBuffer += u"<font=2>%c</font>" % gc.getBonusInfo(25).getChar()
											if (gc.getTeam(gc.getPlayer(CyGame().getActivePlayer()).getTeam()).isGoldTrading() or gc.getTeam(gc.getPlayer(ePlayer).getTeam()).isGoldTrading()) and ePlayer != CyGame().getActivePlayer():
												goldAvilable = gc.getPlayer(ePlayer).AI_maxGoldTrade(CyGame().getActivePlayer())
												goldPerTurnAvilable = gc.getPlayer(ePlayer).AI_maxGoldPerTurnTrade(CyGame().getActivePlayer())
												currentEra = gc.getEraInfo(gc.getPlayer(CyGame().getActivePlayer()).getCurrentEra()).getDescription()
												# Much Gold avilable
												if ((currentEra == "Aincient") and (goldAvilable >= g_iGoldSensitivityAincient)) or ((currentEra == "Classical") and (goldAvilable >= g_iGoldSensitivityClassical)) or ((currentEra == "Medieval") and (goldAvilable >= g_iGoldSensitivityMedieval)) or ((currentEra == "Renaissance") and (goldAvilable >= g_iGoldSensitivityRenaissance)) or ((currentEra == "Industrial") and (goldAvilable >= g_iGoldSensitivityIndustrial)) or ((currentEra == "Modern") and (goldAvilable >= g_iGoldSensitivityModern)) or ((currentEra == "Future") and (goldAvilable >= g_iGoldSensitivityFuture)):
													szBuffer += u"%c" % gc.getCommerceInfo(CommerceTypes.COMMERCE_GOLD).getChar()
												# Much Gold Per Turn avilable
												if (g_iShowF4 == 1):
													if ((currentEra == "Aincient") and (goldPerTurnAvilable >= g_iGoldPerTurnSensitivityAincient)) or ((currentEra == "Classical") and (goldPerTurnAvilable >= g_iGoldPerTurnSensitivityClassical)) or ((currentEra == "Medieval") and (goldPerTurnAvilable >= g_iGoldPerTurnSensitivityMedieval)) or ((currentEra == "Renaissance") and (goldPerTurnAvilable >= g_iGoldPerTurnSensitivityRenaissance)) or ((currentEra == "Industrial") and (goldPerTurnAvilable >= g_iGoldPerTurnSensitivityIndustrial)) or ((currentEra == "Modern") and (goldPerTurnAvilable >= g_iGoldPerTurnSensitivityModern)) or ((currentEra == "Future") and (goldPerTurnAvilable >= g_iGoldPerTurnSensitivityFuture)):
														szBuffer = szBuffer + " " + u"%c" % gc.getCommerceInfo(CommerceTypes.COMMERCE_GOLD).getChar()
												elif ((g_iShowF4 == 2) and (goldPerTurnAvilable > 0)):
													szBuffer += "(" + unicode(goldPerTurnAvilable) + ")"
													bSpaceBeforScore = true
											
											# Happy and Health Resources
											if ((gc.getPlayer(CyGame().getActivePlayer()).canTradeNetworkWith(ePlayer) or gc.getGame().isDebugMode()) and ePlayer != CyGame().getActivePlayer()):
												minHappy=1000
												minHealth=1000
												player = gc.getPlayer(CyGame().getActivePlayer())
												(pLoopCity, iter) = player.firstCity(false)
												while(pLoopCity):
													if (pLoopCity.happyLevel() - pLoopCity.unhappyLevel(0) < minHappy):
														minHappy = pLoopCity.happyLevel() - pLoopCity.unhappyLevel(0)
													if (pLoopCity.goodHealth() - pLoopCity.badHealth(0) < minHealth):
														minHealth = pLoopCity.goodHealth() - pLoopCity.badHealth(0)
													(pLoopCity, iter) = player.nextCity(iter, false)
													
												if (minHappy < 0):
													listTradeable = []
													listHappyResourses = [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34]
													
													tradeData = TradeData()
													tradeData.ItemType = TradeableItems.TRADE_RESOURCES
													for iLoopBonus in range(gc.getNumBonusInfos()):
														tradeData.iData = iLoopBonus
														if (gc.getPlayer(ePlayer).canTradeItem(CyGame().getActivePlayer(), tradeData, False)):
															if (gc.getPlayer(ePlayer).getTradeDenial(CyGame().getActivePlayer(), tradeData) == DenialTypes.NO_DENIAL):
																if (iLoopBonus in listHappyResourses):
																	listTradeable.append(iLoopBonus)
																
													if len(listTradeable) > 0:
														szBuffer += u"%c" % gc.getBonusInfo(listTradeable[0]).getChar()
														
												if (minHealth < 0):
													listTradeable = []
													listHealthResourses = [9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19]
													
													tradeData = TradeData()
													tradeData.ItemType = TradeableItems.TRADE_RESOURCES
													for iLoopBonus in range(gc.getNumBonusInfos()):
														tradeData.iData = iLoopBonus
														if (gc.getPlayer(ePlayer).canTradeItem(CyGame().getActivePlayer(), tradeData, False)):
															if (gc.getPlayer(ePlayer).getTradeDenial(CyGame().getActivePlayer(), tradeData) == DenialTypes.NO_DENIAL):
																if (iLoopBonus in listHealthResourses):
																	listTradeable.append(iLoopBonus)
																
													if len(listTradeable) > 0:
														szBuffer += u"%c" % gc.getBonusInfo(listTradeable[0]).getChar()
											
											# Strategic Resource & Resource for Corporations
											if ((gc.getPlayer(CyGame().getActivePlayer()).canTradeNetworkWith(ePlayer) or gc.getGame().isDebugMode()) and ePlayer != CyGame().getActivePlayer()):
												listTradeable = []
												listStrategyResourses = [0, 1, 2, 3, 4, 5, 6, 7, 8, 25]

												listCorporationsHasPlayer = []
												player = gc.getPlayer(CyGame().getActivePlayer())
												(pLoopCity, iter) = player.firstCity(false)
												while(pLoopCity):
													for iCorp in range(gc.getNumCorporationInfos()):
														if (pLoopCity.isHasCorporation(iCorp)) and (not (iCorp in listCorporationsHasPlayer)):
															listCorporationsHasPlayer.append(iCorp)
													(pLoopCity, iter) = player.nextCity(iter, false)

												listCorporationsForTrade = []
												listCerealMills = [11, 17, 19] #0
												listSidsSushiCo = [10, 13, 15, 17] #1
												listStandartEthanol = [11, 17, 29] #2
												listCreativeConstructions = [0, 2, 4, 5, 7] #3
												listMiningInc = [1, 2, 4, 23, 27] #4
												listAluminiumCo = [1] #5
												listCivilizedJewelersInc = [22, 23, 27] #6
												
												tradeData = TradeData()
												tradeData.ItemType = TradeableItems.TRADE_RESOURCES
												for iLoopBonus in range(gc.getNumBonusInfos()):
													tradeData.iData = iLoopBonus
													if (gc.getPlayer(ePlayer).canTradeItem(CyGame().getActivePlayer(), tradeData, False)):
														if (gc.getPlayer(ePlayer).getTradeDenial(CyGame().getActivePlayer(), tradeData) == DenialTypes.NO_DENIAL):
															if (iLoopBonus in listStrategyResourses):
																listTradeable.append(iLoopBonus)
															if ((iLoopBonus in listCerealMills) and (0 in listCorporationsHasPlayer) and (not(0 in listCorporationsForTrade))):
																listCorporationsForTrade.append(0)
															if ((iLoopBonus in listSidsSushiCo) and (1 in listCorporationsHasPlayer) and (not(1 in listCorporationsForTrade))):
																listCorporationsForTrade.append(1)
															if ((iLoopBonus in listStandartEthanol) and (2 in listCorporationsHasPlayer) and (not(2 in listCorporationsForTrade))):
																listCorporationsForTrade.append(2)
															if ((iLoopBonus in listCreativeConstructions) and (3 in listCorporationsHasPlayer) and (not(3 in listCorporationsForTrade))):
																listCorporationsForTrade.append(3)
															if ((iLoopBonus in listMiningInc) and (4 in listCorporationsHasPlayer) and (not(4 in listCorporationsForTrade))):
																listCorporationsForTrade.append(4)
															if ((iLoopBonus in listAluminiumCo) and (5 in listCorporationsHasPlayer) and (not(5 in listCorporationsForTrade))):
																listCorporationsForTrade.append(5)
															if ((iLoopBonus in listCivilizedJewelersInc) and (6 in listCorporationsHasPlayer) and (not(6 in listCorporationsForTrade))):
																listCorporationsForTrade.append(6)
															
												if len(listTradeable) > 0:
													szBuffer += u"%c" % gc.getBonusInfo(listTradeable[0]).getChar()
												if len(listCorporationsForTrade) > 0:
													szBuffer += u"%c" % gc.getCorporationInfo(listCorporationsForTrade[0]).getChar()

											# Power
											playerPower = gc.getPlayer(CyGame().getActivePlayer()).getPowerHistory(CyGame().getGameTurn()-1)
											if (gc.getPlayer(ePlayer).getPowerHistory(CyGame().getGameTurn()-1) > playerPower):
												szBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.STRENGTH_CHAR))
												if g_bDetailPower:
													szBuffer += "(" + unicode(gc.getPlayer(ePlayer).getPowerHistory(CyGame().getGameTurn()-1)) + "/" + unicode(playerPower) + ")"
													bSpaceBeforScore = true
											
											# if player is building coal plant without coal
											if (ePlayer == CyGame().getActivePlayer()):
												noCoal = false
												player = gc.getPlayer(CyGame().getActivePlayer())
												(pLoopCity, iter) = player.firstCity(false)
												while(pLoopCity):
													if ((pLoopCity.getProductionBuilding() == 32) and (not pLoopCity.hasBonus(1))):
														# 32 == BUILDING_COAL_PLANT
														# 1 == BONUS_COAL
														noCoal = true
													(pLoopCity, iter) = player.nextCity(iter, false)
												if (noCoal):
													szBuffer += "[no " + u"%c" % gc.getBonusInfo(1).getChar() + "]"
												
											# Culture Victory warning
											for iLoopVC in range(gc.getNumVictoryInfos()):
												victory = gc.getVictoryInfo(iLoopVC)
												if (victory.getCityCulture() != CultureLevelTypes.NO_CULTURELEVEL and victory.getNumCultureCities() > 0):
												
													cultureNo1Count = 0
													cultureNo2Count = 0
													cultureNo3Count = 0
													player = gc.getPlayer(ePlayer)
													(pLoopCity, iter) = player.firstCity(false)
													while(pLoopCity):
														if (pLoopCity.getCulture(ePlayer) >= cultureNo1Count):
															cultureNo3Count = cultureNo2Count
															cultureNo2Count = cultureNo1Count
															cultureNo1Count = pLoopCity.getCulture(ePlayer)
														elif ((pLoopCity.getCulture(ePlayer) < cultureNo1Count) and (pLoopCity.getCulture(ePlayer) >= cultureNo2Count)):
															cultureNo3Count = cultureNo2Count
															cultureNo2Count = pLoopCity.getCulture(ePlayer)
														elif ((pLoopCity.getCulture(ePlayer) < cultureNo2Count) and (pLoopCity.getCulture(ePlayer) >= cultureNo3Count)):
															cultureNo3Count = pLoopCity.getCulture(ePlayer)
														(pLoopCity, iter) = player.nextCity(iter, false)

													maxCulture = gc.getCultureLevelInfo(gc.getNumCultureLevelInfos()-1).getSpeedThreshold(CyGame().getGameSpeedType())
													totalCulture = (min(cultureNo1Count, maxCulture) + min(cultureNo2Count, maxCulture) + min(cultureNo3Count, maxCulture)) / 3
													if (100*totalCulture/maxCulture >= 20):
														szBuffer += u"%c" % gc.getCommerceInfo(CommerceTypes.COMMERCE_CULTURE).getChar() + "(" + unicode(100*totalCulture/maxCulture) + "%)"
														bSpaceBeforScore = true
											
											# Space Race Victory warning
											team = gc.getTeam(gc.getPlayer(ePlayer).getTeam())
											PROJECT_APOLLO_PROGRAM = 3
											if (team.getProjectCount(PROJECT_APOLLO_PROGRAM) > 0):
												PROJECT_SS_CASING = 9
												PROJECT_SS_THRUSTERS = 10
												PROJECT_SS_ENGINE = 8
												PROJECT_SS_DOCKING_BAY = 7
												PROJECT_SS_COCKPIT = 4
												PROJECT_SS_LIFE_SUPPORT = 5
												PROJECT_SS_STASIS_CHAMBER = 6
												SSCasing = 1200
												SSCockpit = 1000
												SSDockingBay = 2000
												SSEngine = 1600
												SSLifeSupport = 1000
												SSStasisChamber = 1200
												SSThrusters = 1200
												BONUS_ALUMINUM = 0
												BONUS_COPPER = 2
												if (gc.getPlayer(ePlayer).countOwnedBonuses(BONUS_ALUMINUM) > 0):
													SSCasing *= 3/4
													SSDockingBay *= 3/4
													SSThrusters *= 3/4
												if (gc.getPlayer(ePlayer).countOwnedBonuses(BONUS_COPPER) > 0):
													SSCockpit *= 3/4
													SSLifeSupport *= 3/4
												haveProduction = team.getProjectCount(PROJECT_SS_CASING)*SSCasing + team.getProjectCount(PROJECT_SS_COCKPIT)*SSCockpit + team.getProjectCount(PROJECT_SS_DOCKING_BAY)*SSDockingBay + team.getProjectCount(PROJECT_SS_ENGINE)*SSEngine + team.getProjectCount(PROJECT_SS_LIFE_SUPPORT)*SSLifeSupport + team.getProjectCount(PROJECT_SS_STASIS_CHAMBER)*SSStasisChamber + team.getProjectCount(PROJECT_SS_THRUSTERS)*SSThrusters
												needProduction = 5*SSCasing + 1*SSCockpit + 1*SSDockingBay + 2*SSEngine + 1*SSLifeSupport + 1*SSStasisChamber + 5*SSThrusters
#												szBuffer += unicode(gc.getProjectInfo(10).getDescription())
												szBuffer += u"%c" %(CyGame().getSymbolID(FontSymbols.MAP_CHAR)) + "(" + unicode(100*haveProduction/needProduction) + "%)"
												bSpaceBeforScore = true
											
											if bSpaceBeforScore:
												szBuffer += " "
#----------Dimon157 F4 1/1 X

############################################################
##########=MSM===Show Score and Turn Score (Caesium)===0===
############################################################
										iScore = gc.getGame().getPlayerScore(ePlayer)
										iGameTurn = gc.getGame().getGameTurn()
										if (g_iShowScore > 0):
											if (g_iShowScore == 2 and iGameTurn > 0):
												iScore1 = gc.getPlayer(ePlayer).getScoreHistory(iGameTurn - 1)
												iScore2 = gc.getPlayer(ePlayer).getScoreHistory(iGameTurn - 2)
												iTurnScore = iScore1 - iScore2 
												if iTurnScore < 0 :
													szTempBuffer = u"(%d) " %(iTurnScore)
												else :
													szTempBuffer = u"(+%d) " %(iTurnScore)
												szBuffer = szBuffer + szTempBuffer
											szTempBuffer = u"%d: " %(iScore)
											szBuffer = szBuffer + szTempBuffer
############################################################
##########=MSM===Show Score and Turn Score (Caesium)===X===
############################################################

############################################################
##########=MSM===Civ\Leader Switch===0===
############################################################
										if (CyUserProfile().isClockOn()):
											gsName = gc.getPlayer(ePlayer).getCivilizationShortDescription(0)
										else:
											gsName = gc.getPlayer(ePlayer).getName()

										if (not CyInterface().isFlashingPlayer(ePlayer) or CyInterface().shouldFlash(ePlayer)):
											if (ePlayer == gc.getGame().getActivePlayer()):
												szTempBuffer = u"[<color=%d,%d,%d,%d>%s</color>]" %(gc.getPlayer(ePlayer).getPlayerTextColorR(), gc.getPlayer(ePlayer).getPlayerTextColorG(), gc.getPlayer(ePlayer).getPlayerTextColorB(), gc.getPlayer(ePlayer).getPlayerTextColorA(), gsName)
											else:
												szTempBuffer = u"<color=%d,%d,%d,%d>%s</color>" %(gc.getPlayer(ePlayer).getPlayerTextColorR(), gc.getPlayer(ePlayer).getPlayerTextColorG(), gc.getPlayer(ePlayer).getPlayerTextColorB(), gc.getPlayer(ePlayer).getPlayerTextColorA(), gsName)
										else:
											szTempBuffer = u"%s" %(gc.getPlayer(ePlayer).gsName)
										szBuffer = szBuffer + szTempBuffer
############################################################
##########=MSM===Civ\Leader Switch===X===
############################################################

										if (gc.getTeam(eTeam).isAlive()):
											if ( not (gc.getTeam(gc.getGame().getActiveTeam()).isHasMet(eTeam)) ):
												szBuffer = szBuffer + (" ?")
											if (gc.getTeam(eTeam).isAtWar(gc.getGame().getActiveTeam())):
												szBuffer = szBuffer + "("  + localText.getColorText("TXT_KEY_CONCEPT_WAR", (), gc.getInfoTypeForString("COLOR_RED")).upper() + ")"
											if (gc.getPlayer(ePlayer).canTradeNetworkWith(gc.getGame().getActivePlayer()) and (ePlayer != gc.getGame().getActivePlayer())):
												szTempBuffer = u"%c" %(CyGame().getSymbolID(FontSymbols.TRADE_CHAR))
												szBuffer = szBuffer + szTempBuffer
											if (gc.getTeam(eTeam).isOpenBorders(gc.getGame().getActiveTeam())):
												szTempBuffer = u"%c" %(CyGame().getSymbolID(FontSymbols.OPEN_BORDERS_CHAR))
												szBuffer = szBuffer + szTempBuffer
											if (gc.getTeam(eTeam).isDefensivePact(gc.getGame().getActiveTeam())):
												szTempBuffer = u"%c" %(CyGame().getSymbolID(FontSymbols.DEFENSIVE_PACT_CHAR))
												szBuffer = szBuffer + szTempBuffer
											if (gc.getPlayer(ePlayer).getStateReligion() != -1):
												if (gc.getPlayer(ePlayer).hasHolyCity(gc.getPlayer(ePlayer).getStateReligion())):
													szTempBuffer = u"%c" %(gc.getReligionInfo(gc.getPlayer(ePlayer).getStateReligion()).getHolyCityChar())
													szBuffer = szBuffer + szTempBuffer
												else:
													szTempBuffer = u"%c" %(gc.getReligionInfo(gc.getPlayer(ePlayer).getStateReligion()).getChar())
													szBuffer = szBuffer + szTempBuffer
											if (gc.getTeam(eTeam).getEspionagePointsAgainstTeam(gc.getGame().getActiveTeam()) < gc.getTeam(gc.getGame().getActiveTeam()).getEspionagePointsAgainstTeam(eTeam)):
												szTempBuffer = u"%c" %(gc.getCommerceInfo(CommerceTypes.COMMERCE_ESPIONAGE).getChar())
												szBuffer = szBuffer + szTempBuffer
										
										bEspionageCanSeeResearch = false
										for iMissionLoop in range(gc.getNumEspionageMissionInfos()):
											if (gc.getEspionageMissionInfo(iMissionLoop).isSeeResearch()):
												bEspionageCanSeeResearch = gc.getPlayer(gc.getGame().getActivePlayer()).canDoEspionageMission(iMissionLoop, ePlayer, None, -1)
												break
										
										if (((gc.getPlayer(ePlayer).getTeam() == gc.getGame().getActiveTeam()) and (gc.getTeam(gc.getGame().getActiveTeam()).getNumMembers() > 1)) or (gc.getTeam(gc.getPlayer(ePlayer).getTeam()).isVassal(gc.getGame().getActiveTeam())) or gc.getGame().isDebugMode() or bEspionageCanSeeResearch):
											if (gc.getPlayer(ePlayer).getCurrentResearch() != -1):
												szTempBuffer = u"-%s (%d)" %(gc.getTechInfo(gc.getPlayer(ePlayer).getCurrentResearch()).getDescription(), gc.getPlayer(ePlayer).getResearchTurnsLeft(gc.getPlayer(ePlayer).getCurrentResearch(), True))
												szBuffer = szBuffer + szTempBuffer

############################################################
##########=MSM===Show Attitude Text and Icons===0===
############################################################
										if (gc.getTeam(eTeam).isAlive()):
											if (not gc.getPlayer(ePlayer).isHuman()):
												iAtt = gc.getPlayer(ePlayer).AI_getAttitude(gc.getGame().getActivePlayer())
												if g_iShowAttitude > 0:
													if (CyUserProfile().is24Hours()):
														if g_iShowAttitude == 2:
															#Porges' Attitude Icons
															att = unichr(ord(unichr(CyGame().getSymbolID(FontSymbols.POWER_CHAR) + 4)) + iAtt)
															szTempBuffer = u"%s" %(att)
															szBuffer = szBuffer + szTempBuffer
														else:
															if iAtt == 0:
																att = unichr(CyGame().getSymbolID(FontSymbols.UNHAPPY_CHAR))
															elif iAtt == 1:
																att = unichr(CyGame().getSymbolID(FontSymbols.UNHEALTHY_CHAR))
															elif iAtt == 2:
																att = unichr(CyGame().getSymbolID(FontSymbols.BULLET_CHAR))#unichr(CyGame().getSymbolID(FontSymbols.ANGRY_POP_CHAR))
															elif iAtt == 3:
																att = unichr(CyGame().getSymbolID(FontSymbols.HAPPY_CHAR))
															elif iAtt == 4:
																att = unichr(CyGame().getSymbolID(FontSymbols.STAR_CHAR))
															else:
																att = unichr(CyGame().getSymbolID(FontSymbols.BULLET_CHAR))
															szTempBuffer = u"%s" %(att)
															szBuffer = szBuffer + szTempBuffer
													else:
														AttText = localText.changeTextColor(gc.getAttitudeInfo(gc.getPlayer(ePlayer).AI_getAttitude(gc.getGame().getActivePlayer())).getDescription(), self.attitudeColors[iAtt+1])
														szTempBuffer = u" - %s" % (AttText)
														szBuffer = szBuffer + szTempBuffer
############################################################
##########=MSM===Show Attitude Text and Icons===X===
############################################################

############################################################
##########=MSM===Attitude Value (Blacksun)===0===
############################################################
												if g_bAttitudeValue:
													iAttVal = gc.getPlayer(ePlayer).getAttitudeVal(ePlayer, gc.getGame().getActivePlayer())
													if iAttVal > 0 :
														szTempBuffer = u": +%d" % (iAttVal)
													else:
														szTempBuffer = u": %d" % (iAttVal)
													szTempBuffer = localText.changeTextColor(szTempBuffer, self.attitudeColors[iAtt+1])
													szBuffer = szBuffer + szTempBuffer
############################################################
##########=MSM===Attitude Value (Blacksun)===X===
############################################################
		
#										bEspionageCanSeeResearch = false
#										for iMissionLoop in range(gc.getNumEspionageMissionInfos()):
#											if (gc.getEspionageMissionInfo(iMissionLoop).isSeeResearch()):
#												bEspionageCanSeeResearch = gc.getPlayer(gc.getGame().getActivePlayer()).canDoEspionageMission(iMissionLoop, ePlayer, CyMap().plot(-1,-1), -1)
#												break
#										
#										if (((gc.getPlayer(ePlayer).getTeam() == gc.getGame().getActiveTeam()) and (gc.getTeam(gc.getGame().getActiveTeam()).getNumMembers() > 1)) or (gc.getTeam(gc.getPlayer(ePlayer).getTeam()).isVassal(gc.getGame().getActiveTeam())) or gc.getGame().isDebugMode() or bEspionageCanSeeResearch):
#											if (gc.getPlayer(ePlayer).getCurrentResearch() != -1):
#												szTempBuffer = u"-%s (%d)" %(gc.getTechInfo(gc.getPlayer(ePlayer).getCurrentResearch()).getDescription(), gc.getPlayer(ePlayer).getResearchTurnsLeft(gc.getPlayer(ePlayer).getCurrentResearch(), True))
#												szBuffer = szBuffer + szTempBuffer
										if (CyGame().isNetworkMultiPlayer()):
											szBuffer = szBuffer + CyGameTextMgr().getNetStats(ePlayer)
											
										if (gc.getPlayer(ePlayer).isHuman() and CyInterface().isOOSVisible()):
											szTempBuffer = u" <color=255,0,0>* %s *</color>" %(CyGameTextMgr().getOOSSeeds(ePlayer))
											szBuffer = szBuffer + szTempBuffer
											
										szBuffer = szBuffer + "</font>"

										if ( CyInterface().determineWidth( szBuffer ) > iWidth ):
											iWidth = CyInterface().determineWidth( szBuffer )

										szName = "ScoreText" + str(ePlayer)
										if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW or CyInterface().isInAdvancedStart()):
											yCoord = yResolution - 206
										else:
											yCoord = yResolution - 88
										screen.setText( szName, "Background", szBuffer, CvUtil.FONT_RIGHT_JUSTIFY, xResolution - 12, yCoord - (iCount * iBtnHeight), -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_CONTACT_CIV, ePlayer, -1 )
										screen.show( szName )
										
										CyInterface().checkFlashReset(ePlayer)

										iCount = iCount + 1
							j = j - 1
					i = i - 1

				if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW or CyInterface().isInAdvancedStart()):
					yCoord = yResolution - 186
				else:
					yCoord = yResolution - 68
				screen.setPanelSize( "ScoreBackground", xResolution - 21 - iWidth, yCoord - (iBtnHeight * iCount) - 4, iWidth + 12, (iBtnHeight * iCount) + 8 )
				screen.show( "ScoreBackground" )

	# Will update the help Strings
	def updateHelpStrings( self ):
	
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )

		if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE_ALL ):
			screen.setHelpTextString( "" )
		else:
			screen.setHelpTextString( CyInterface().getHelpString() )
		
		return 0
		
	# Will set the promotion button position
	def setPromotionButtonPosition( self, szName, iPromotionCount ):
		
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		
		# Find out our resolution
		yResolution = screen.getYResolution()

		if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
			screen.moveItem( szName, 266 - (24 * (iPromotionCount / 6)), yResolution - 144 + (24 * (iPromotionCount % 6)), -0.3 )

	# Will set the selection button position
	def setResearchButtonPosition( self, szButtonID, iCount ):
		
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		xResolution = screen.getXResolution()
		screen.moveItem( szButtonID, 264 + ( ( xResolution - 1024 ) / 2 ) + ( 34 * ( iCount % 15 ) ), 0 + ( 34 * ( iCount / 15 ) ), -0.3 )
							
	# Will set the selection button position
	def setScoreTextPosition( self, szButtonID, iWhichLine ):
		
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		yResolution = screen.getYResolution()
		if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
			yCoord = yResolution - 180
		else:
			yCoord = yResolution - 88
		screen.moveItem( szButtonID, 996, yCoord - (iWhichLine * 18), -0.3 )

	# Will build the globeview UI
	def updateGlobeviewButtons( self ):
		kInterface = CyInterface()
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		kEngine = CyEngine()
		kGLM = CyGlobeLayerManager()
		iNumLayers = kGLM.getNumLayers()
		iCurrentLayerID = kGLM.getCurrentLayerID()
		
		# Positioning things based on the visibility of the globe
		if kEngine.isGlobeviewUp():
			screen.setHelpTextArea( 350, FontTypes.SMALL_FONT, 7, yResolution - 50, -0.1, False, "", True, False, CvUtil.FONT_LEFT_JUSTIFY, 150 )
		else:
			if ( CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_SHOW ):
				screen.setHelpTextArea( 350, FontTypes.SMALL_FONT, 7, yResolution - 172, -0.1, False, "", True, False, CvUtil.FONT_LEFT_JUSTIFY, 150 )
			else:
				screen.setHelpTextArea( 350, FontTypes.SMALL_FONT, 7, yResolution - 50, -0.1, False, "", True, False, CvUtil.FONT_LEFT_JUSTIFY, 150 )

		
		# Set base Y position for the LayerOptions, if we find them	
		if CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE:
			iY = yResolution - iGlobeLayerOptionsY_Minimal
		else:
			iY = yResolution - iGlobeLayerOptionsY_Regular

		# Hide the layer options ... all of them
		for i in range (20):
			szName = "GlobeLayerOption" + str(i)
			screen.hide(szName)

		# Setup the GlobeLayer panel
		iNumLayers = kGLM.getNumLayers()
		if kEngine.isGlobeviewUp() and CyInterface().getShowInterface() != InterfaceVisibility.INTERFACE_HIDE_ALL:
			# set up panel
			if iCurrentLayerID != -1 and kGLM.getLayer(iCurrentLayerID).getNumOptions() != 0:
				bHasOptions = True		
			else:
				bHasOptions = False
				screen.hide( "ScoreBackground" )

			# set up toggle button
			screen.setState("GlobeToggle", True)

			# Set GlobeLayer indicators correctly
			for i in range(kGLM.getNumLayers()):
				szButtonID = "GlobeLayer" + str(i)
				screen.setState( szButtonID, iCurrentLayerID == i )
				
			# Set up options pane
			if bHasOptions:
				kLayer = kGLM.getLayer(iCurrentLayerID)

				iCurY = iY
				iNumOptions = kLayer.getNumOptions()
				iCurOption = kLayer.getCurrentOption()
				iMaxTextWidth = -1
				for iTmp in range(iNumOptions):
					iOption = iTmp # iNumOptions - iTmp - 1
					szName = "GlobeLayerOption" + str(iOption)
					szCaption = kLayer.getOptionName(iOption)			
					if(iOption == iCurOption):
						szBuffer = "  <color=0,255,0>%s</color>  " % (szCaption)
					else:
						szBuffer = "  %s  " % (szCaption)
					iTextWidth = CyInterface().determineWidth( szBuffer )

					screen.setText( szName, "Background", szBuffer, CvUtil.FONT_LEFT_JUSTIFY, xResolution - 9 - iTextWidth, iCurY-iGlobeLayerOptionHeight-10, -0.3, FontTypes.SMALL_FONT, WidgetTypes.WIDGET_GLOBELAYER_OPTION, iOption, -1 )
					screen.show( szName )

					iCurY -= iGlobeLayerOptionHeight

					if iTextWidth > iMaxTextWidth:
						iMaxTextWidth = iTextWidth

				#make extra space
				iCurY -= iGlobeLayerOptionHeight;
				iPanelWidth = iMaxTextWidth + 32
				iPanelHeight = iY - iCurY
				iPanelX = xResolution - 14 - iPanelWidth
				iPanelY = iCurY
				screen.setPanelSize( "ScoreBackground", iPanelX, iPanelY, iPanelWidth, iPanelHeight )
				screen.show( "ScoreBackground" )

		else:
			if iCurrentLayerID != -1:
				kLayer = kGLM.getLayer(iCurrentLayerID)
				if kLayer.getName() == "RESOURCES":
					screen.setState("ResourceIcons", True)
				else:
					screen.setState("ResourceIcons", False)

				if kLayer.getName() == "UNITS":
					screen.setState("UnitIcons", True)
				else:
					screen.setState("UnitIcons", False)
			else:
				screen.setState("ResourceIcons", False)
				screen.setState("UnitIcons", False)
				
			screen.setState("Grid", CyUserProfile().getGrid())
			screen.setState("BareMap", CyUserProfile().getMap())
			screen.setState("Yields", CyUserProfile().getYields())
			screen.setState("ScoresVisible", CyUserProfile().getScores())

			screen.hide( "InterfaceGlobeLayerPanel" )
			screen.setState("GlobeToggle", False )

	# Update minimap buttons
	def setMinimapButtonVisibility( self, bVisible):
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		kInterface = CyInterface()
		kGLM = CyGlobeLayerManager()
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		if ( CyInterface().isCityScreenUp() ):
			bVisible = False
		
		kMainButtons = ["UnitIcons", "Grid", "BareMap", "Yields", "ScoresVisible", "ResourceIcons"]
		kGlobeButtons = []
		for i in range(kGLM.getNumLayers()):
			szButtonID = "GlobeLayer" + str(i)
			kGlobeButtons.append(szButtonID)
		
		if bVisible:
			if CyEngine().isGlobeviewUp():
				kHide = kMainButtons
				kShow = kGlobeButtons
			else:
				kHide = kGlobeButtons
				kShow = kMainButtons
			screen.show( "GlobeToggle" )
			
		else:
			kHide = kMainButtons + kGlobeButtons
			kShow = []
			screen.hide( "GlobeToggle" )
		
		for szButton in kHide:
			screen.hide(szButton)
		
		if CyInterface().getShowInterface() == InterfaceVisibility.INTERFACE_HIDE:
			iY = yResolution - iMinimapButtonsY_Minimal
			iGlobeY = yResolution - iGlobeButtonY_Minimal 
		else:
			iY = yResolution - iMinimapButtonsY_Regular
			iGlobeY = yResolution - iGlobeButtonY_Regular
			
		iBtnX = xResolution - 39
		screen.moveItem("GlobeToggle", iBtnX, iGlobeY, 0.0)
		
		iBtnAdvance = 28
		iBtnX = iBtnX - len(kShow)*iBtnAdvance - 10
		if len(kShow) > 0:		
			i = 0
			for szButton in kShow:
				screen.moveItem(szButton, iBtnX, iY, 0.0)
				screen.moveToFront(szButton)
				screen.show(szButton)
				iBtnX += iBtnAdvance
				i += 1
				
	
	def createGlobeviewButtons( self ):
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()
		
		kEngine = CyEngine()
		kGLM = CyGlobeLayerManager()
		iNumLayers = kGLM.getNumLayers()

		for i in range (kGLM.getNumLayers()):
			szButtonID = "GlobeLayer" + str(i)

			kLayer = kGLM.getLayer(i)
			szStyle = kLayer.getButtonStyle()
			
			if szStyle == 0 or szStyle == "":
				szStyle = "Button_HUDSmall_Style"
			
			screen.addCheckBoxGFC( szButtonID, "", "", 0, 0, 28, 28, WidgetTypes.WIDGET_GLOBELAYER, i, -1, ButtonStyles.BUTTON_STYLE_LABEL )
			screen.setStyle( szButtonID, szStyle )
			screen.hide( szButtonID )
				
			
	def createMinimapButtons( self ):
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
		xResolution = screen.getXResolution()
		yResolution = screen.getYResolution()

		screen.addCheckBoxGFC( "UnitIcons", "", "", 0, 0, 28, 28, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_UNIT_ICONS).getActionInfoIndex(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
		screen.setStyle( "UnitIcons", "Button_HUDGlobeUnit_Style" )
		screen.setState( "UnitIcons", False )
		screen.hide( "UnitIcons" )

		screen.addCheckBoxGFC( "Grid", "", "", 0, 0, 28, 28, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_GRID).getActionInfoIndex(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
		screen.setStyle( "Grid", "Button_HUDBtnGrid_Style" )
		screen.setState( "Grid", False )
		screen.hide( "Grid" )

		screen.addCheckBoxGFC( "BareMap", "", "", 0, 0, 28, 28, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_BARE_MAP).getActionInfoIndex(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
		screen.setStyle( "BareMap", "Button_HUDBtnClearMap_Style" )
		screen.setState( "BareMap", False )
		screen.hide( "BareMap" )

		screen.addCheckBoxGFC( "Yields", "", "", 0, 0, 28, 28, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_YIELDS).getActionInfoIndex(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
		screen.setStyle( "Yields", "Button_HUDBtnTileAssets_Style" )
		screen.setState( "Yields", False )
		screen.hide( "Yields" )

		screen.addCheckBoxGFC( "ScoresVisible", "", "", 0, 0, 28, 28, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_SCORES).getActionInfoIndex(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
		screen.setStyle( "ScoresVisible", "Button_HUDBtnRank_Style" )
		screen.setState( "ScoresVisible", True )
		screen.hide( "ScoresVisible" )

		screen.addCheckBoxGFC( "ResourceIcons", "", "", 0, 0, 28, 28, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_RESOURCE_ALL).getActionInfoIndex(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
		screen.setStyle( "ResourceIcons", "Button_HUDBtnResources_Style" )
		screen.setState( "ResourceIcons", False )
		screen.hide( "ResourceIcons" )
		
		screen.addCheckBoxGFC( "GlobeToggle", "", "", -1, -1, 36, 36, WidgetTypes.WIDGET_ACTION, gc.getControlInfo(ControlTypes.CONTROL_GLOBELAYER).getActionInfoIndex(), -1, ButtonStyles.BUTTON_STYLE_LABEL )
		screen.setStyle( "GlobeToggle", "Button_HUDZoom_Style" )
		screen.setState( "GlobeToggle", False )
		screen.hide( "GlobeToggle" )

	# Will handle the input for this screen...
	def handleInput (self, inputClass):
##### RtW ChangeCiv Button START
		if(inputClass.getNotifyCode() == NotifyCode.NOTIFY_CLICKED and inputClass.getFunctionName() == "ChangeCivButton"):
                    CvEventManager.CvEventManager().ChangeCiv_Popup()
		screen = CyGInterfaceScreen( "MainInterface", CvScreenEnums.MAIN_INTERFACE )
##### RtW ChangeCiv Button END
		# Inquisition Mod
		# PROTO
		
		pGodsOfOld=CvEventInterface.getEventManager()
		
		# Eliminates Religion from city
		if (inputClass.getNotifyCode() == 11 and inputClass.getData1() == 665 and inputClass.getData2() == 665):
			pPlot = CyMap( ).plot( g_pSelectedUnit.getX( ), g_pSelectedUnit.getY( ) )
			
			iMessageID = pGodsOfOld.m_iNetMessage_Inquisitor
			iPlotX = pPlot.getX()
			iPlotY = pPlot.getY()
			iOwner = g_pSelectedUnit.getOwner()
			iUnitID = g_pSelectedUnit.getID()
			
			CyMessageControl( ).sendModNetMessage( iMessageID, iPlotX, iPlotY, iOwner, iUnitID )
		# End Inquisition Mod

		return 0
	
	def update(self, fDelta):
		return


